/* book-view.c generated by valac 0.56.14, the Vala compiler
 * generated from book-view.vala, do not modify */

/*
 * Copyright (C) 2009-2015 Canonical Ltd.
 * Author: Robert Ancell <robert.ancell@canonical.com>
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */
/* FIXME: When scrolling, copy existing render sideways?*/
/* FIXME: Only render pages that change and only the part that changed*/
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_BOOK_VIEW (book_view_get_type ())
#define BOOK_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOOK_VIEW, BookView))
#define BOOK_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BOOK_VIEW, BookViewClass))
#define IS_BOOK_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOOK_VIEW))
#define IS_BOOK_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BOOK_VIEW))
#define BOOK_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BOOK_VIEW, BookViewClass))

typedef struct _BookView BookView;
typedef struct _BookViewClass BookViewClass;
typedef struct _BookViewPrivate BookViewPrivate;

#define TYPE_BOOK (book_get_type ())
#define BOOK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BOOK, Book))
#define BOOK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BOOK, BookClass))
#define IS_BOOK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BOOK))
#define IS_BOOK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BOOK))
#define BOOK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BOOK, BookClass))

typedef struct _Book Book;
typedef struct _BookClass BookClass;

#define TYPE_PAGE (page_get_type ())
#define PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE, Page))
#define PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE, PageClass))
#define IS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE))
#define IS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE))
#define PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE, PageClass))

typedef struct _Page Page;
typedef struct _PageClass PageClass;

#define TYPE_PAGE_VIEW (page_view_get_type ())
#define PAGE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_VIEW, PageView))
#define PAGE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_VIEW, PageViewClass))
#define IS_PAGE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_VIEW))
#define IS_PAGE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_VIEW))
#define PAGE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_VIEW, PageViewClass))

typedef struct _PageView PageView;
typedef struct _PageViewClass PageViewClass;
enum  {
	BOOK_VIEW_0_PROPERTY,
	BOOK_VIEW_BOOK_PROPERTY,
	BOOK_VIEW_SELECTED_PAGE_PROPERTY,
	BOOK_VIEW_X_OFFSET_PROPERTY,
	BOOK_VIEW_NUM_PROPERTIES
};
static GParamSpec* book_view_properties[BOOK_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	BOOK_VIEW_PAGE_SELECTED_SIGNAL,
	BOOK_VIEW_SHOW_PAGE_SIGNAL,
	BOOK_VIEW_SHOW_MENU_SIGNAL,
	BOOK_VIEW_NUM_SIGNALS
};
static guint book_view_signals[BOOK_VIEW_NUM_SIGNALS] = {0};

struct _BookView {
	GtkBox parent_instance;
	BookViewPrivate * priv;
};

struct _BookViewClass {
	GtkBoxClass parent_class;
};

struct _BookViewPrivate {
	Book* _book;
	GHashTable* page_data;
	gboolean need_layout;
	gboolean laying_out;
	gboolean show_selected_page;
	PageView* selected_page_view;
	GtkDrawingArea* drawing_area;
	GtkScrollbar* scroll;
	GtkAdjustment* adjustment;
	gchar* cursor;
	GtkEventControllerMotion* motion_controller;
	GtkEventControllerKey* key_controller;
	GtkGestureClick* primary_click_gesture;
	GtkGestureClick* secondary_click_gesture;
	GtkEventControllerFocus* focus_controller;
};

static gint BookView_private_offset;
static gpointer book_view_parent_class = NULL;

VALA_EXTERN GType book_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (BookView, g_object_unref)
VALA_EXTERN GType book_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Book, g_object_unref)
VALA_EXTERN GType page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Page, g_object_unref)
VALA_EXTERN GType page_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PageView, g_object_unref)
VALA_EXTERN Book* book_view_get_book (BookView* self);
static void book_view_add_cb (BookView* self,
                       Book* book,
                       Page* page);
static void _book_view_add_cb_book_page_added (Book* _sender,
                                        Page* page,
                                        gpointer self);
static void book_view_remove_cb (BookView* self,
                          Book* book,
                          Page* page);
static void _book_view_remove_cb_book_page_removed (Book* _sender,
                                             Page* page,
                                             gpointer self);
static void book_view_reorder_cb (BookView* self,
                           Book* book);
static void _book_view_reorder_cb_book_reordered (Book* _sender,
                                           gpointer self);
static void book_view_clear_cb (BookView* self,
                         Book* book);
static void _book_view_clear_cb_book_cleared (Book* _sender,
                                       gpointer self);
VALA_EXTERN void book_view_drawing_area_resize_cb (BookView* self);
static void _book_view_drawing_area_resize_cb_gtk_drawing_area_resize (GtkDrawingArea* _sender,
                                                                gint width,
                                                                gint height,
                                                                gpointer self);
static void book_view_motion_cb (BookView* self,
                          GtkEventControllerMotion* controler,
                          gdouble dx,
                          gdouble dy);
static void _book_view_motion_cb_gtk_event_controller_motion_motion (GtkEventControllerMotion* _sender,
                                                              gdouble x,
                                                              gdouble y,
                                                              gpointer self);
static gboolean book_view_key_cb (BookView* self,
                           GtkEventControllerKey* controler,
                           guint keyval,
                           guint keycode,
                           GdkModifierType state);
static gboolean _book_view_key_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                 guint keyval,
                                                                 guint keycode,
                                                                 GdkModifierType state,
                                                                 gpointer self);
static void book_view_primary_pressed_cb (BookView* self,
                                   GtkGestureClick* controler,
                                   gint n_press,
                                   gdouble x,
                                   gdouble y);
static void _book_view_primary_pressed_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                              gint n_press,
                                                              gdouble x,
                                                              gdouble y,
                                                              gpointer self);
static void book_view_primary_released_cb (BookView* self,
                                    GtkGestureClick* controler,
                                    gint n_press,
                                    gdouble x,
                                    gdouble y);
static void _book_view_primary_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                                gint n_press,
                                                                gdouble x,
                                                                gdouble y,
                                                                gpointer self);
static void book_view_secondary_pressed_cb (BookView* self,
                                     GtkGestureClick* controler,
                                     gint n_press,
                                     gdouble x,
                                     gdouble y);
static void _book_view_secondary_pressed_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                gint n_press,
                                                                gdouble x,
                                                                gdouble y,
                                                                gpointer self);
static void book_view_secondary_released_cb (BookView* self,
                                      GtkGestureClick* controler,
                                      gint n_press,
                                      gdouble x,
                                      gdouble y);
static void _book_view_secondary_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                                  gint n_press,
                                                                  gdouble x,
                                                                  gdouble y,
                                                                  gpointer self);
static void book_view_focus_cb (BookView* self,
                         GtkEventControllerFocus* controler);
static void _book_view_focus_cb_gtk_event_controller_focus_enter (GtkEventControllerFocus* _sender,
                                                           gpointer self);
static void _book_view_focus_cb_gtk_event_controller_focus_leave (GtkEventControllerFocus* _sender,
                                                           gpointer self);
static void book_view_scroll_cb (BookView* self,
                          GtkAdjustment* adjustment);
static void _book_view_scroll_cb_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                        gpointer self);
VALA_EXTERN BookView* book_view_new (Book* book);
VALA_EXTERN BookView* book_view_construct (GType object_type,
                               Book* book);
static void book_view_set_book (BookView* self,
                         Book* value);
VALA_EXTERN guint book_get_n_pages (Book* self);
VALA_EXTERN Page* book_get_page (Book* self,
                     gint page_number);
VALA_EXTERN void book_view_set_selected_page (BookView* self,
                                  Page* value);
static void _g_object_unref0_ (gpointer var);
VALA_EXTERN void book_view_draw_cb (BookView* self,
                        GtkDrawingArea* drawing_area,
                        cairo_t* context,
                        gint width,
                        gint height);
static void _book_view_draw_cb_gtk_drawing_area_draw_func (GtkDrawingArea* drawing_area,
                                                    cairo_t* cr,
                                                    gint width,
                                                    gint height,
                                                    gpointer self);
static PageView* book_view_get_nth_page (BookView* self,
                                  gint n);
static PageView* book_view_get_next_page (BookView* self,
                                   PageView* page);
VALA_EXTERN Page* page_view_get_page (PageView* self);
static PageView* book_view_get_prev_page (BookView* self,
                                   PageView* page);
static void book_view_page_view_changed_cb (BookView* self,
                                     PageView* page);
VALA_EXTERN void book_view_redraw (BookView* self);
static void book_view_page_view_size_changed_cb (BookView* self,
                                          PageView* page);
VALA_EXTERN PageView* page_view_new (Page* page);
VALA_EXTERN PageView* page_view_construct (GType object_type,
                               Page* page);
static void _book_view_page_view_changed_cb_page_view_changed (PageView* _sender,
                                                        gpointer self);
static void _book_view_page_view_size_changed_cb_page_view_size_changed (PageView* _sender,
                                                                  gpointer self);
static void book_view_set_selected_page_view (BookView* self,
                                       PageView* page);
VALA_EXTERN void page_view_set_selected (PageView* self,
                             gboolean value);
static void book_view_show_page_view (BookView* self,
                               PageView* page);
VALA_EXTERN gint page_view_get_x_offset (PageView* self);
VALA_EXTERN gint page_view_get_width (PageView* self);
VALA_EXTERN gint book_view_get_x_offset (BookView* self);
VALA_EXTERN void book_view_set_x_offset (BookView* self,
                             gint value);
static void book_view_select_page_view (BookView* self,
                                 PageView* page);
VALA_EXTERN Page* book_view_get_selected_page (BookView* self);
static void book_view_layout (BookView* self);
static void book_view_layout_into (BookView* self,
                            gint width,
                            gint height,
                            gint* book_width,
                            gint* book_height);
VALA_EXTERN gint page_get_dpi (Page* self);
VALA_EXTERN gint page_get_width (Page* self);
VALA_EXTERN gint page_get_height (Page* self);
VALA_EXTERN void page_view_set_width (PageView* self,
                          gint value);
VALA_EXTERN void page_view_set_height (PageView* self,
                           gint value);
VALA_EXTERN gint page_view_get_height (PageView* self);
VALA_EXTERN void page_view_set_x_offset (PageView* self,
                             gint value);
VALA_EXTERN void page_view_set_y_offset (PageView* self,
                             gint value);
static inline void _g_list_free__g_object_unref0_ (GList* self);
VALA_EXTERN void page_view_render (PageView* self,
                       cairo_t* context,
                       GdkRGBA* ruler_color);
VALA_EXTERN gboolean page_view_get_selected (PageView* self);
VALA_EXTERN gint page_view_get_y_offset (PageView* self);
static PageView* book_view_get_page_at (BookView* self,
                                 gint x,
                                 gint y,
                                 gint* x_,
                                 gint* y_);
static void book_view_button_cb (BookView* self,
                          GtkGestureClick* controler,
                          gint button,
                          gboolean press,
                          gint n_press,
                          gdouble dx,
                          gdouble dy);
VALA_EXTERN void page_view_button_press (PageView* self,
                             gint x,
                             gint y);
VALA_EXTERN void page_view_button_release (PageView* self,
                               gint x,
                               gint y);
static void book_view_set_cursor (BookView* self,
                           const gchar* cursor);
VALA_EXTERN void page_view_motion (PageView* self,
                       gint x,
                       gint y);
VALA_EXTERN const gchar* page_view_get_cursor (PageView* self);
VALA_EXTERN void book_view_select_next_page (BookView* self);
VALA_EXTERN void book_view_select_prev_page (BookView* self);
static void g_cclosure_user_marshal_VOID__OBJECT_DOUBLE_DOUBLE (GClosure * closure,
                                                         GValue * return_value,
                                                         guint n_param_values,
                                                         const GValue * param_values,
                                                         gpointer invocation_hint,
                                                         gpointer marshal_data);
static void book_view_finalize (GObject * obj);
static GType book_view_get_type_once (void);
static void _vala_book_view_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_book_view_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
book_view_get_instance_private (BookView* self)
{
	return G_STRUCT_MEMBER_P (self, BookView_private_offset);
}

static void
_book_view_add_cb_book_page_added (Book* _sender,
                                   Page* page,
                                   gpointer self)
{
#line 151 "../src/book-view.vala"
	book_view_add_cb ((BookView*) self, _sender, page);
#line 371 "book-view.c"
}

static void
_book_view_remove_cb_book_page_removed (Book* _sender,
                                        Page* page,
                                        gpointer self)
{
#line 152 "../src/book-view.vala"
	book_view_remove_cb ((BookView*) self, _sender, page);
#line 381 "book-view.c"
}

static void
_book_view_reorder_cb_book_reordered (Book* _sender,
                                      gpointer self)
{
#line 153 "../src/book-view.vala"
	book_view_reorder_cb ((BookView*) self, _sender);
#line 390 "book-view.c"
}

static void
_book_view_clear_cb_book_cleared (Book* _sender,
                                  gpointer self)
{
#line 154 "../src/book-view.vala"
	book_view_clear_cb ((BookView*) self, _sender);
#line 399 "book-view.c"
}

static void
_book_view_drawing_area_resize_cb_gtk_drawing_area_resize (GtkDrawingArea* _sender,
                                                           gint width,
                                                           gint height,
                                                           gpointer self)
{
#line 155 "../src/book-view.vala"
	book_view_drawing_area_resize_cb ((BookView*) self);
#line 410 "book-view.c"
}

static void
_book_view_motion_cb_gtk_event_controller_motion_motion (GtkEventControllerMotion* _sender,
                                                         gdouble x,
                                                         gdouble y,
                                                         gpointer self)
{
#line 156 "../src/book-view.vala"
	book_view_motion_cb ((BookView*) self, _sender, x, y);
#line 421 "book-view.c"
}

static gboolean
_book_view_key_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                        guint keyval,
                                                        guint keycode,
                                                        GdkModifierType state,
                                                        gpointer self)
{
	gboolean result;
	result = book_view_key_cb ((BookView*) self, _sender, keyval, keycode, state);
#line 157 "../src/book-view.vala"
	return result;
#line 435 "book-view.c"
}

static void
_book_view_primary_pressed_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                         gint n_press,
                                                         gdouble x,
                                                         gdouble y,
                                                         gpointer self)
{
#line 158 "../src/book-view.vala"
	book_view_primary_pressed_cb ((BookView*) self, _sender, n_press, x, y);
#line 447 "book-view.c"
}

static void
_book_view_primary_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                           gint n_press,
                                                           gdouble x,
                                                           gdouble y,
                                                           gpointer self)
{
#line 159 "../src/book-view.vala"
	book_view_primary_released_cb ((BookView*) self, _sender, n_press, x, y);
#line 459 "book-view.c"
}

static void
_book_view_secondary_pressed_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                           gint n_press,
                                                           gdouble x,
                                                           gdouble y,
                                                           gpointer self)
{
#line 160 "../src/book-view.vala"
	book_view_secondary_pressed_cb ((BookView*) self, _sender, n_press, x, y);
#line 471 "book-view.c"
}

static void
_book_view_secondary_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                             gint n_press,
                                                             gdouble x,
                                                             gdouble y,
                                                             gpointer self)
{
#line 161 "../src/book-view.vala"
	book_view_secondary_released_cb ((BookView*) self, _sender, n_press, x, y);
#line 483 "book-view.c"
}

static void
_book_view_focus_cb_gtk_event_controller_focus_enter (GtkEventControllerFocus* _sender,
                                                      gpointer self)
{
#line 162 "../src/book-view.vala"
	book_view_focus_cb ((BookView*) self, _sender);
#line 492 "book-view.c"
}

static void
_book_view_focus_cb_gtk_event_controller_focus_leave (GtkEventControllerFocus* _sender,
                                                      gpointer self)
{
#line 163 "../src/book-view.vala"
	book_view_focus_cb ((BookView*) self, _sender);
#line 501 "book-view.c"
}

static void
_book_view_scroll_cb_gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                   gpointer self)
{
#line 164 "../src/book-view.vala"
	book_view_scroll_cb ((BookView*) self, _sender);
#line 510 "book-view.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 102 "../src/book-view.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 518 "book-view.c"
}

static void
_book_view_draw_cb_gtk_drawing_area_draw_func (GtkDrawingArea* drawing_area,
                                               cairo_t* cr,
                                               gint width,
                                               gint height,
                                               gpointer self)
{
#line 109 "../src/book-view.vala"
	book_view_draw_cb ((BookView*) self, drawing_area, cr, width, height);
#line 530 "book-view.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 114 "../src/book-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 538 "book-view.c"
}

BookView*
book_view_construct (GType object_type,
                     Book* book)
{
	BookView * self = NULL;
	Page* _tmp6_;
	Page* _tmp7_;
	GHashFunc _tmp8_;
	GEqualFunc _tmp9_;
	GHashTable* _tmp10_;
	gchar* _tmp11_;
	GtkDrawingArea* _tmp12_;
	GtkDrawingArea* _tmp13_;
	GtkDrawingArea* _tmp14_;
	GtkDrawingArea* _tmp15_;
	GtkDrawingArea* _tmp16_;
	GtkDrawingArea* _tmp17_;
	GtkScrollbar* _tmp18_;
	GtkScrollbar* _tmp19_;
	GtkAdjustment* _tmp20_;
	GtkAdjustment* _tmp21_;
	GtkAdjustment* _tmp22_;
	GtkScrollbar* _tmp23_;
	GtkDrawingArea* _tmp24_;
	GtkEventControllerMotion* _tmp25_;
	GtkEventControllerMotion* _tmp26_;
	GtkDrawingArea* _tmp27_;
	GtkEventControllerMotion* _tmp28_;
	GtkEventController* _tmp29_;
	GtkEventControllerKey* _tmp30_;
	GtkEventControllerKey* _tmp31_;
	GtkDrawingArea* _tmp32_;
	GtkEventControllerKey* _tmp33_;
	GtkEventController* _tmp34_;
	GtkGestureClick* _tmp35_;
	GtkGestureClick* _tmp36_;
	GtkGestureClick* _tmp37_;
	GtkGestureClick* _tmp38_;
	GtkDrawingArea* _tmp39_;
	GtkGestureClick* _tmp40_;
	GtkEventController* _tmp41_;
	GtkGestureClick* _tmp42_;
	GtkGestureClick* _tmp43_;
	GtkGestureClick* _tmp44_;
	GtkGestureClick* _tmp45_;
	GtkDrawingArea* _tmp46_;
	GtkGestureClick* _tmp47_;
	GtkEventController* _tmp48_;
	GtkEventControllerFocus* _tmp49_;
	GtkEventControllerFocus* _tmp50_;
	GtkEventControllerFocus* _tmp51_;
	GtkDrawingArea* _tmp52_;
	GtkEventControllerFocus* _tmp53_;
	GtkEventController* _tmp54_;
	GtkAdjustment* _tmp55_;
	GtkDrawingArea* _tmp56_;
#line 81 "../src/book-view.vala"
	g_return_val_if_fail (book != NULL, NULL);
#line 83 "../src/book-view.vala"
	self = (BookView*) g_object_new (object_type, "orientation", GTK_ORIENTATION_VERTICAL, NULL);
#line 84 "../src/book-view.vala"
	book_view_set_book (self, book);
#line 603 "book-view.c"
	{
		gint i = 0;
#line 87 "../src/book-view.vala"
		i = 0;
#line 608 "book-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 87 "../src/book-view.vala"
			_tmp0_ = TRUE;
#line 87 "../src/book-view.vala"
			while (TRUE) {
#line 615 "book-view.c"
				guint _tmp2_;
				guint _tmp3_;
				Page* page = NULL;
				Page* _tmp4_;
				Page* _tmp5_;
#line 87 "../src/book-view.vala"
				if (!_tmp0_) {
#line 623 "book-view.c"
					gint _tmp1_;
#line 87 "../src/book-view.vala"
					_tmp1_ = i;
#line 87 "../src/book-view.vala"
					i = _tmp1_ + 1;
#line 629 "book-view.c"
				}
#line 87 "../src/book-view.vala"
				_tmp0_ = FALSE;
#line 87 "../src/book-view.vala"
				_tmp2_ = book_get_n_pages (book);
#line 87 "../src/book-view.vala"
				_tmp3_ = _tmp2_;
#line 87 "../src/book-view.vala"
				if (!(((guint) i) < _tmp3_)) {
#line 87 "../src/book-view.vala"
					break;
#line 641 "book-view.c"
				}
#line 89 "../src/book-view.vala"
				_tmp4_ = book_get_page (book, i);
#line 89 "../src/book-view.vala"
				page = _tmp4_;
#line 90 "../src/book-view.vala"
				_tmp5_ = page;
#line 90 "../src/book-view.vala"
				book_view_add_cb (self, book, _tmp5_);
#line 87 "../src/book-view.vala"
				_g_object_unref0 (page);
#line 653 "book-view.c"
			}
		}
	}
#line 93 "../src/book-view.vala"
	_tmp6_ = book_get_page (book, 0);
#line 93 "../src/book-view.vala"
	_tmp7_ = _tmp6_;
#line 93 "../src/book-view.vala"
	book_view_set_selected_page (self, _tmp7_);
#line 93 "../src/book-view.vala"
	_g_object_unref0 (_tmp7_);
#line 96 "../src/book-view.vala"
	g_signal_connect_object (book, "page-added", (GCallback) _book_view_add_cb_book_page_added, self, 0);
#line 97 "../src/book-view.vala"
	g_signal_connect_object (book, "page-removed", (GCallback) _book_view_remove_cb_book_page_removed, self, 0);
#line 98 "../src/book-view.vala"
	g_signal_connect_object (book, "reordered", (GCallback) _book_view_reorder_cb_book_reordered, self, 0);
#line 99 "../src/book-view.vala"
	g_signal_connect_object (book, "cleared", (GCallback) _book_view_clear_cb_book_cleared, self, 0);
#line 101 "../src/book-view.vala"
	self->priv->need_layout = TRUE;
#line 102 "../src/book-view.vala"
	_tmp8_ = g_direct_hash;
#line 102 "../src/book-view.vala"
	_tmp9_ = g_direct_equal;
#line 102 "../src/book-view.vala"
	_tmp10_ = g_hash_table_new_full (_tmp8_, _tmp9_, _g_object_unref0_, _g_object_unref0_);
#line 102 "../src/book-view.vala"
	_g_hash_table_unref0 (self->priv->page_data);
#line 102 "../src/book-view.vala"
	self->priv->page_data = _tmp10_;
#line 103 "../src/book-view.vala"
	_tmp11_ = g_strdup ("arrow");
#line 103 "../src/book-view.vala"
	_g_free0 (self->priv->cursor);
#line 103 "../src/book-view.vala"
	self->priv->cursor = _tmp11_;
#line 105 "../src/book-view.vala"
	_tmp12_ = (GtkDrawingArea*) gtk_drawing_area_new ();
#line 105 "../src/book-view.vala"
	g_object_ref_sink (_tmp12_);
#line 105 "../src/book-view.vala"
	_g_object_unref0 (self->priv->drawing_area);
#line 105 "../src/book-view.vala"
	self->priv->drawing_area = _tmp12_;
#line 106 "../src/book-view.vala"
	_tmp13_ = self->priv->drawing_area;
#line 106 "../src/book-view.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp13_, 200, 100);
#line 107 "../src/book-view.vala"
	_tmp14_ = self->priv->drawing_area;
#line 107 "../src/book-view.vala"
	gtk_widget_set_can_focus ((GtkWidget*) _tmp14_, TRUE);
#line 108 "../src/book-view.vala"
	_tmp15_ = self->priv->drawing_area;
#line 108 "../src/book-view.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp15_, TRUE);
#line 109 "../src/book-view.vala"
	_tmp16_ = self->priv->drawing_area;
#line 109 "../src/book-view.vala"
	gtk_drawing_area_set_draw_func (_tmp16_, _book_view_draw_cb_gtk_drawing_area_draw_func, g_object_ref (self), g_object_unref);
#line 111 "../src/book-view.vala"
	_tmp17_ = self->priv->drawing_area;
#line 111 "../src/book-view.vala"
	gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp17_);
#line 113 "../src/book-view.vala"
	_tmp18_ = (GtkScrollbar*) gtk_scrollbar_new (GTK_ORIENTATION_HORIZONTAL, NULL);
#line 113 "../src/book-view.vala"
	g_object_ref_sink (_tmp18_);
#line 113 "../src/book-view.vala"
	_g_object_unref0 (self->priv->scroll);
#line 113 "../src/book-view.vala"
	self->priv->scroll = _tmp18_;
#line 114 "../src/book-view.vala"
	_tmp19_ = self->priv->scroll;
#line 114 "../src/book-view.vala"
	_tmp20_ = gtk_scrollbar_get_adjustment (_tmp19_);
#line 114 "../src/book-view.vala"
	_tmp21_ = _tmp20_;
#line 114 "../src/book-view.vala"
	_tmp22_ = _g_object_ref0 (_tmp21_);
#line 114 "../src/book-view.vala"
	_g_object_unref0 (self->priv->adjustment);
#line 114 "../src/book-view.vala"
	self->priv->adjustment = _tmp22_;
#line 115 "../src/book-view.vala"
	_tmp23_ = self->priv->scroll;
#line 115 "../src/book-view.vala"
	gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp23_);
#line 117 "../src/book-view.vala"
	_tmp24_ = self->priv->drawing_area;
#line 117 "../src/book-view.vala"
	g_signal_connect_object (_tmp24_, "resize", (GCallback) _book_view_drawing_area_resize_cb_gtk_drawing_area_resize, self, 0);
#line 119 "../src/book-view.vala"
	_tmp25_ = (GtkEventControllerMotion*) gtk_event_controller_motion_new ();
#line 119 "../src/book-view.vala"
	_g_object_unref0 (self->priv->motion_controller);
#line 119 "../src/book-view.vala"
	self->priv->motion_controller = _tmp25_;
#line 120 "../src/book-view.vala"
	_tmp26_ = self->priv->motion_controller;
#line 120 "../src/book-view.vala"
	g_signal_connect_object (_tmp26_, "motion", (GCallback) _book_view_motion_cb_gtk_event_controller_motion_motion, self, 0);
#line 121 "../src/book-view.vala"
	_tmp27_ = self->priv->drawing_area;
#line 121 "../src/book-view.vala"
	_tmp28_ = self->priv->motion_controller;
#line 121 "../src/book-view.vala"
	_tmp29_ = _g_object_ref0 ((GtkEventController*) _tmp28_);
#line 121 "../src/book-view.vala"
	gtk_widget_add_controller ((GtkWidget*) _tmp27_, _tmp29_);
#line 123 "../src/book-view.vala"
	_tmp30_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
#line 123 "../src/book-view.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 123 "../src/book-view.vala"
	self->priv->key_controller = _tmp30_;
#line 124 "../src/book-view.vala"
	_tmp31_ = self->priv->key_controller;
#line 124 "../src/book-view.vala"
	g_signal_connect_object (_tmp31_, "key-pressed", (GCallback) _book_view_key_cb_gtk_event_controller_key_key_pressed, self, 0);
#line 125 "../src/book-view.vala"
	_tmp32_ = self->priv->drawing_area;
#line 125 "../src/book-view.vala"
	_tmp33_ = self->priv->key_controller;
#line 125 "../src/book-view.vala"
	_tmp34_ = _g_object_ref0 ((GtkEventController*) _tmp33_);
#line 125 "../src/book-view.vala"
	gtk_widget_add_controller ((GtkWidget*) _tmp32_, _tmp34_);
#line 127 "../src/book-view.vala"
	_tmp35_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 127 "../src/book-view.vala"
	_g_object_unref0 (self->priv->primary_click_gesture);
#line 127 "../src/book-view.vala"
	self->priv->primary_click_gesture = _tmp35_;
#line 128 "../src/book-view.vala"
	_tmp36_ = self->priv->primary_click_gesture;
#line 128 "../src/book-view.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp36_, (guint) GDK_BUTTON_PRIMARY);
#line 129 "../src/book-view.vala"
	_tmp37_ = self->priv->primary_click_gesture;
#line 129 "../src/book-view.vala"
	g_signal_connect_object (_tmp37_, "pressed", (GCallback) _book_view_primary_pressed_cb_gtk_gesture_click_pressed, self, 0);
#line 130 "../src/book-view.vala"
	_tmp38_ = self->priv->primary_click_gesture;
#line 130 "../src/book-view.vala"
	g_signal_connect_object (_tmp38_, "released", (GCallback) _book_view_primary_released_cb_gtk_gesture_click_released, self, 0);
#line 131 "../src/book-view.vala"
	_tmp39_ = self->priv->drawing_area;
#line 131 "../src/book-view.vala"
	_tmp40_ = self->priv->primary_click_gesture;
#line 131 "../src/book-view.vala"
	_tmp41_ = _g_object_ref0 ((GtkEventController*) _tmp40_);
#line 131 "../src/book-view.vala"
	gtk_widget_add_controller ((GtkWidget*) _tmp39_, _tmp41_);
#line 133 "../src/book-view.vala"
	_tmp42_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 133 "../src/book-view.vala"
	_g_object_unref0 (self->priv->secondary_click_gesture);
#line 133 "../src/book-view.vala"
	self->priv->secondary_click_gesture = _tmp42_;
#line 134 "../src/book-view.vala"
	_tmp43_ = self->priv->secondary_click_gesture;
#line 134 "../src/book-view.vala"
	gtk_gesture_single_set_button ((GtkGestureSingle*) _tmp43_, (guint) GDK_BUTTON_SECONDARY);
#line 135 "../src/book-view.vala"
	_tmp44_ = self->priv->secondary_click_gesture;
#line 135 "../src/book-view.vala"
	g_signal_connect_object (_tmp44_, "pressed", (GCallback) _book_view_secondary_pressed_cb_gtk_gesture_click_pressed, self, 0);
#line 136 "../src/book-view.vala"
	_tmp45_ = self->priv->secondary_click_gesture;
#line 136 "../src/book-view.vala"
	g_signal_connect_object (_tmp45_, "released", (GCallback) _book_view_secondary_released_cb_gtk_gesture_click_released, self, 0);
#line 137 "../src/book-view.vala"
	_tmp46_ = self->priv->drawing_area;
#line 137 "../src/book-view.vala"
	_tmp47_ = self->priv->secondary_click_gesture;
#line 137 "../src/book-view.vala"
	_tmp48_ = _g_object_ref0 ((GtkEventController*) _tmp47_);
#line 137 "../src/book-view.vala"
	gtk_widget_add_controller ((GtkWidget*) _tmp46_, _tmp48_);
#line 139 "../src/book-view.vala"
	_tmp49_ = (GtkEventControllerFocus*) gtk_event_controller_focus_new ();
#line 139 "../src/book-view.vala"
	_g_object_unref0 (self->priv->focus_controller);
#line 139 "../src/book-view.vala"
	self->priv->focus_controller = _tmp49_;
#line 140 "../src/book-view.vala"
	_tmp50_ = self->priv->focus_controller;
#line 140 "../src/book-view.vala"
	g_signal_connect_object (_tmp50_, "enter", (GCallback) _book_view_focus_cb_gtk_event_controller_focus_enter, self, G_CONNECT_AFTER);
#line 141 "../src/book-view.vala"
	_tmp51_ = self->priv->focus_controller;
#line 141 "../src/book-view.vala"
	g_signal_connect_object (_tmp51_, "leave", (GCallback) _book_view_focus_cb_gtk_event_controller_focus_leave, self, G_CONNECT_AFTER);
#line 142 "../src/book-view.vala"
	_tmp52_ = self->priv->drawing_area;
#line 142 "../src/book-view.vala"
	_tmp53_ = self->priv->focus_controller;
#line 142 "../src/book-view.vala"
	_tmp54_ = _g_object_ref0 ((GtkEventController*) _tmp53_);
#line 142 "../src/book-view.vala"
	gtk_widget_add_controller ((GtkWidget*) _tmp52_, _tmp54_);
#line 144 "../src/book-view.vala"
	_tmp55_ = self->priv->adjustment;
#line 144 "../src/book-view.vala"
	g_signal_connect_object (_tmp55_, "value-changed", (GCallback) _book_view_scroll_cb_gtk_adjustment_value_changed, self, 0);
#line 146 "../src/book-view.vala"
	_tmp56_ = self->priv->drawing_area;
#line 146 "../src/book-view.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp56_, TRUE);
#line 81 "../src/book-view.vala"
	return self;
#line 867 "book-view.c"
}

BookView*
book_view_new (Book* book)
{
#line 81 "../src/book-view.vala"
	return book_view_construct (TYPE_BOOK_VIEW, book);
#line 875 "book-view.c"
}

static PageView*
book_view_get_nth_page (BookView* self,
                        gint n)
{
	Page* page = NULL;
	Book* _tmp0_;
	Page* _tmp1_;
	GHashTable* _tmp2_;
	gconstpointer _tmp3_;
	PageView* _tmp4_;
	PageView* result;
#line 167 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 169 "../src/book-view.vala"
	_tmp0_ = self->priv->_book;
#line 169 "../src/book-view.vala"
	_tmp1_ = book_get_page (_tmp0_, n);
#line 169 "../src/book-view.vala"
	page = _tmp1_;
#line 170 "../src/book-view.vala"
	_tmp2_ = self->priv->page_data;
#line 170 "../src/book-view.vala"
	_tmp3_ = g_hash_table_lookup (_tmp2_, page);
#line 170 "../src/book-view.vala"
	_tmp4_ = _g_object_ref0 ((PageView*) _tmp3_);
#line 170 "../src/book-view.vala"
	result = _tmp4_;
#line 170 "../src/book-view.vala"
	_g_object_unref0 (page);
#line 170 "../src/book-view.vala"
	return result;
#line 909 "book-view.c"
}

static PageView*
book_view_get_next_page (BookView* self,
                         PageView* page)
{
	PageView* _tmp15_;
	PageView* result;
#line 173 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 173 "../src/book-view.vala"
	g_return_val_if_fail (page != NULL, NULL);
#line 922 "book-view.c"
	{
		gint i = 0;
#line 175 "../src/book-view.vala"
		i = 0;
#line 927 "book-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 175 "../src/book-view.vala"
			_tmp0_ = TRUE;
#line 175 "../src/book-view.vala"
			while (TRUE) {
#line 934 "book-view.c"
				Page* p = NULL;
				Book* _tmp2_;
				Page* _tmp3_;
				Page* _tmp4_;
				Page* _tmp5_;
				Page* _tmp6_;
				Page* _tmp7_;
#line 175 "../src/book-view.vala"
				if (!_tmp0_) {
#line 944 "book-view.c"
					gint _tmp1_;
#line 175 "../src/book-view.vala"
					_tmp1_ = i;
#line 175 "../src/book-view.vala"
					i = _tmp1_ + 1;
#line 950 "book-view.c"
				}
#line 175 "../src/book-view.vala"
				_tmp0_ = FALSE;
#line 177 "../src/book-view.vala"
				_tmp2_ = self->priv->_book;
#line 177 "../src/book-view.vala"
				_tmp3_ = book_get_page (_tmp2_, i);
#line 177 "../src/book-view.vala"
				p = _tmp3_;
#line 178 "../src/book-view.vala"
				_tmp4_ = p;
#line 178 "../src/book-view.vala"
				if (_tmp4_ == NULL) {
#line 179 "../src/book-view.vala"
					_g_object_unref0 (p);
#line 179 "../src/book-view.vala"
					break;
#line 968 "book-view.c"
				}
#line 180 "../src/book-view.vala"
				_tmp5_ = p;
#line 180 "../src/book-view.vala"
				_tmp6_ = page_view_get_page (page);
#line 180 "../src/book-view.vala"
				_tmp7_ = _tmp6_;
#line 180 "../src/book-view.vala"
				if (_tmp5_ == _tmp7_) {
#line 978 "book-view.c"
					Book* _tmp8_;
					Page* _tmp9_;
					Page* _tmp10_;
#line 182 "../src/book-view.vala"
					_tmp8_ = self->priv->_book;
#line 182 "../src/book-view.vala"
					_tmp9_ = book_get_page (_tmp8_, i + 1);
#line 182 "../src/book-view.vala"
					_g_object_unref0 (p);
#line 182 "../src/book-view.vala"
					p = _tmp9_;
#line 183 "../src/book-view.vala"
					_tmp10_ = p;
#line 183 "../src/book-view.vala"
					if (_tmp10_ != NULL) {
#line 994 "book-view.c"
						GHashTable* _tmp11_;
						Page* _tmp12_;
						gconstpointer _tmp13_;
						PageView* _tmp14_;
#line 184 "../src/book-view.vala"
						_tmp11_ = self->priv->page_data;
#line 184 "../src/book-view.vala"
						_tmp12_ = p;
#line 184 "../src/book-view.vala"
						_tmp13_ = g_hash_table_lookup (_tmp11_, _tmp12_);
#line 184 "../src/book-view.vala"
						_tmp14_ = _g_object_ref0 ((PageView*) _tmp13_);
#line 184 "../src/book-view.vala"
						result = _tmp14_;
#line 184 "../src/book-view.vala"
						_g_object_unref0 (p);
#line 184 "../src/book-view.vala"
						return result;
#line 1013 "book-view.c"
					}
				}
#line 175 "../src/book-view.vala"
				_g_object_unref0 (p);
#line 1018 "book-view.c"
			}
		}
	}
#line 188 "../src/book-view.vala"
	_tmp15_ = _g_object_ref0 (page);
#line 188 "../src/book-view.vala"
	result = _tmp15_;
#line 188 "../src/book-view.vala"
	return result;
#line 1028 "book-view.c"
}

static PageView*
book_view_get_prev_page (BookView* self,
                         PageView* page)
{
	PageView* prev_page = NULL;
	PageView* _tmp0_;
	PageView* _tmp13_;
	PageView* result;
#line 191 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 191 "../src/book-view.vala"
	g_return_val_if_fail (page != NULL, NULL);
#line 193 "../src/book-view.vala"
	_tmp0_ = _g_object_ref0 (page);
#line 193 "../src/book-view.vala"
	prev_page = _tmp0_;
#line 1047 "book-view.c"
	{
		gint i = 0;
#line 194 "../src/book-view.vala"
		i = 0;
#line 1052 "book-view.c"
		{
			gboolean _tmp1_ = FALSE;
#line 194 "../src/book-view.vala"
			_tmp1_ = TRUE;
#line 194 "../src/book-view.vala"
			while (TRUE) {
#line 1059 "book-view.c"
				Page* p = NULL;
				Book* _tmp3_;
				Page* _tmp4_;
				Page* _tmp5_;
				Page* _tmp6_;
				Page* _tmp7_;
				Page* _tmp8_;
				GHashTable* _tmp9_;
				Page* _tmp10_;
				gconstpointer _tmp11_;
				PageView* _tmp12_;
#line 194 "../src/book-view.vala"
				if (!_tmp1_) {
#line 1073 "book-view.c"
					gint _tmp2_;
#line 194 "../src/book-view.vala"
					_tmp2_ = i;
#line 194 "../src/book-view.vala"
					i = _tmp2_ + 1;
#line 1079 "book-view.c"
				}
#line 194 "../src/book-view.vala"
				_tmp1_ = FALSE;
#line 196 "../src/book-view.vala"
				_tmp3_ = self->priv->_book;
#line 196 "../src/book-view.vala"
				_tmp4_ = book_get_page (_tmp3_, i);
#line 196 "../src/book-view.vala"
				p = _tmp4_;
#line 197 "../src/book-view.vala"
				_tmp5_ = p;
#line 197 "../src/book-view.vala"
				if (_tmp5_ == NULL) {
#line 198 "../src/book-view.vala"
					_g_object_unref0 (p);
#line 198 "../src/book-view.vala"
					break;
#line 1097 "book-view.c"
				}
#line 199 "../src/book-view.vala"
				_tmp6_ = p;
#line 199 "../src/book-view.vala"
				_tmp7_ = page_view_get_page (page);
#line 199 "../src/book-view.vala"
				_tmp8_ = _tmp7_;
#line 199 "../src/book-view.vala"
				if (_tmp6_ == _tmp8_) {
#line 200 "../src/book-view.vala"
					result = prev_page;
#line 200 "../src/book-view.vala"
					_g_object_unref0 (p);
#line 200 "../src/book-view.vala"
					return result;
#line 1113 "book-view.c"
				}
#line 201 "../src/book-view.vala"
				_tmp9_ = self->priv->page_data;
#line 201 "../src/book-view.vala"
				_tmp10_ = p;
#line 201 "../src/book-view.vala"
				_tmp11_ = g_hash_table_lookup (_tmp9_, _tmp10_);
#line 201 "../src/book-view.vala"
				_tmp12_ = _g_object_ref0 ((PageView*) _tmp11_);
#line 201 "../src/book-view.vala"
				_g_object_unref0 (prev_page);
#line 201 "../src/book-view.vala"
				prev_page = _tmp12_;
#line 194 "../src/book-view.vala"
				_g_object_unref0 (p);
#line 1129 "book-view.c"
			}
		}
	}
#line 204 "../src/book-view.vala"
	_tmp13_ = _g_object_ref0 (page);
#line 204 "../src/book-view.vala"
	result = _tmp13_;
#line 204 "../src/book-view.vala"
	_g_object_unref0 (prev_page);
#line 204 "../src/book-view.vala"
	return result;
#line 1141 "book-view.c"
}

static void
book_view_page_view_changed_cb (BookView* self,
                                PageView* page)
{
#line 207 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 207 "../src/book-view.vala"
	g_return_if_fail (page != NULL);
#line 209 "../src/book-view.vala"
	book_view_redraw (self);
#line 1154 "book-view.c"
}

static void
book_view_page_view_size_changed_cb (BookView* self,
                                     PageView* page)
{
#line 212 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 212 "../src/book-view.vala"
	g_return_if_fail (page != NULL);
#line 214 "../src/book-view.vala"
	self->priv->need_layout = TRUE;
#line 215 "../src/book-view.vala"
	book_view_redraw (self);
#line 1169 "book-view.c"
}

static void
_book_view_page_view_changed_cb_page_view_changed (PageView* _sender,
                                                   gpointer self)
{
#line 221 "../src/book-view.vala"
	book_view_page_view_changed_cb ((BookView*) self, _sender);
#line 1178 "book-view.c"
}

static void
_book_view_page_view_size_changed_cb_page_view_size_changed (PageView* _sender,
                                                             gpointer self)
{
#line 222 "../src/book-view.vala"
	book_view_page_view_size_changed_cb ((BookView*) self, _sender);
#line 1187 "book-view.c"
}

static void
book_view_add_cb (BookView* self,
                  Book* book,
                  Page* page)
{
	PageView* page_view = NULL;
	PageView* _tmp0_;
	GHashTable* _tmp1_;
	Page* _tmp2_;
	PageView* _tmp3_;
#line 218 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 218 "../src/book-view.vala"
	g_return_if_fail (book != NULL);
#line 218 "../src/book-view.vala"
	g_return_if_fail (page != NULL);
#line 220 "../src/book-view.vala"
	_tmp0_ = page_view_new (page);
#line 220 "../src/book-view.vala"
	page_view = _tmp0_;
#line 221 "../src/book-view.vala"
	g_signal_connect_object (page_view, "changed", (GCallback) _book_view_page_view_changed_cb_page_view_changed, self, 0);
#line 222 "../src/book-view.vala"
	g_signal_connect_object (page_view, "size-changed", (GCallback) _book_view_page_view_size_changed_cb_page_view_size_changed, self, 0);
#line 223 "../src/book-view.vala"
	_tmp1_ = self->priv->page_data;
#line 223 "../src/book-view.vala"
	_tmp2_ = _g_object_ref0 (page);
#line 223 "../src/book-view.vala"
	_tmp3_ = _g_object_ref0 (page_view);
#line 223 "../src/book-view.vala"
	g_hash_table_insert (_tmp1_, _tmp2_, _tmp3_);
#line 224 "../src/book-view.vala"
	self->priv->need_layout = TRUE;
#line 225 "../src/book-view.vala"
	book_view_redraw (self);
#line 218 "../src/book-view.vala"
	_g_object_unref0 (page_view);
#line 1228 "book-view.c"
}

static void
book_view_set_selected_page_view (BookView* self,
                                  PageView* page)
{
	gboolean _tmp0_ = FALSE;
	PageView* _tmp1_;
	PageView* _tmp4_;
	PageView* _tmp5_;
	GtkDrawingArea* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
#line 228 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 231 "../src/book-view.vala"
	_tmp1_ = self->priv->selected_page_view;
#line 231 "../src/book-view.vala"
	if (_tmp1_ != NULL) {
#line 1248 "book-view.c"
		PageView* _tmp2_;
#line 231 "../src/book-view.vala"
		_tmp2_ = self->priv->selected_page_view;
#line 231 "../src/book-view.vala"
		_tmp0_ = page != _tmp2_;
#line 1254 "book-view.c"
	} else {
#line 231 "../src/book-view.vala"
		_tmp0_ = FALSE;
#line 1258 "book-view.c"
	}
#line 231 "../src/book-view.vala"
	if (_tmp0_) {
#line 1262 "book-view.c"
		PageView* _tmp3_;
#line 232 "../src/book-view.vala"
		_tmp3_ = self->priv->selected_page_view;
#line 232 "../src/book-view.vala"
		page_view_set_selected (_tmp3_, TRUE);
#line 1268 "book-view.c"
	}
#line 234 "../src/book-view.vala"
	_tmp4_ = _g_object_ref0 (page);
#line 234 "../src/book-view.vala"
	_g_object_unref0 (self->priv->selected_page_view);
#line 234 "../src/book-view.vala"
	self->priv->selected_page_view = _tmp4_;
#line 235 "../src/book-view.vala"
	book_view_redraw (self);
#line 236 "../src/book-view.vala"
	_tmp5_ = self->priv->selected_page_view;
#line 236 "../src/book-view.vala"
	if (_tmp5_ == NULL) {
#line 237 "../src/book-view.vala"
		return;
#line 1284 "book-view.c"
	}
#line 240 "../src/book-view.vala"
	_tmp6_ = self->priv->drawing_area;
#line 240 "../src/book-view.vala"
	g_object_get ((GtkWidget*) _tmp6_, "has-focus", &_tmp7_, NULL);
#line 240 "../src/book-view.vala"
	_tmp8_ = _tmp7_;
#line 240 "../src/book-view.vala"
	if (!_tmp8_) {
#line 1294 "book-view.c"
		PageView* _tmp9_;
#line 241 "../src/book-view.vala"
		_tmp9_ = self->priv->selected_page_view;
#line 241 "../src/book-view.vala"
		page_view_set_selected (_tmp9_, FALSE);
#line 1300 "book-view.c"
	} else {
		PageView* _tmp10_;
#line 243 "../src/book-view.vala"
		_tmp10_ = self->priv->selected_page_view;
#line 243 "../src/book-view.vala"
		page_view_set_selected (_tmp10_, TRUE);
#line 1307 "book-view.c"
	}
}

static void
book_view_show_page_view (BookView* self,
                          PageView* page)
{
	gboolean _tmp0_ = FALSE;
	GtkAllocation allocation = {0};
	GtkDrawingArea* _tmp2_;
	GtkAllocation _tmp3_ = {0};
	gint left_edge = 0;
	gint _tmp4_;
	gint _tmp5_;
	gint right_edge = 0;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
#line 246 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 248 "../src/book-view.vala"
	if (page == NULL) {
#line 248 "../src/book-view.vala"
		_tmp0_ = TRUE;
#line 1335 "book-view.c"
	} else {
		GtkScrollbar* _tmp1_;
#line 248 "../src/book-view.vala"
		_tmp1_ = self->priv->scroll;
#line 248 "../src/book-view.vala"
		_tmp0_ = !gtk_widget_get_visible ((GtkWidget*) _tmp1_);
#line 1342 "book-view.c"
	}
#line 248 "../src/book-view.vala"
	if (_tmp0_) {
#line 249 "../src/book-view.vala"
		return;
#line 1348 "book-view.c"
	}
#line 252 "../src/book-view.vala"
	_tmp2_ = self->priv->drawing_area;
#line 252 "../src/book-view.vala"
	gtk_widget_get_allocation ((GtkWidget*) _tmp2_, &_tmp3_);
#line 252 "../src/book-view.vala"
	allocation = _tmp3_;
#line 253 "../src/book-view.vala"
	_tmp4_ = page_view_get_x_offset (page);
#line 253 "../src/book-view.vala"
	_tmp5_ = _tmp4_;
#line 253 "../src/book-view.vala"
	left_edge = _tmp5_;
#line 254 "../src/book-view.vala"
	_tmp6_ = page_view_get_x_offset (page);
#line 254 "../src/book-view.vala"
	_tmp7_ = _tmp6_;
#line 254 "../src/book-view.vala"
	_tmp8_ = page_view_get_width (page);
#line 254 "../src/book-view.vala"
	_tmp9_ = _tmp8_;
#line 254 "../src/book-view.vala"
	right_edge = _tmp7_ + _tmp9_;
#line 256 "../src/book-view.vala"
	_tmp10_ = book_view_get_x_offset (self);
#line 256 "../src/book-view.vala"
	_tmp11_ = _tmp10_;
#line 256 "../src/book-view.vala"
	if ((left_edge - _tmp11_) < 0) {
#line 257 "../src/book-view.vala"
		book_view_set_x_offset (self, left_edge);
#line 1380 "book-view.c"
	} else {
		gint _tmp12_;
		gint _tmp13_;
		GtkAllocation _tmp14_;
#line 258 "../src/book-view.vala"
		_tmp12_ = book_view_get_x_offset (self);
#line 258 "../src/book-view.vala"
		_tmp13_ = _tmp12_;
#line 258 "../src/book-view.vala"
		_tmp14_ = allocation;
#line 258 "../src/book-view.vala"
		if ((right_edge - _tmp13_) > _tmp14_.width) {
#line 1393 "book-view.c"
			GtkAllocation _tmp15_;
#line 259 "../src/book-view.vala"
			_tmp15_ = allocation;
#line 259 "../src/book-view.vala"
			book_view_set_x_offset (self, right_edge - _tmp15_.width);
#line 1399 "book-view.c"
		}
	}
}

static void
book_view_select_page_view (BookView* self,
                            PageView* page)
{
	Page* p = NULL;
	PageView* _tmp0_;
	Page* _tmp4_;
#line 262 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 264 "../src/book-view.vala"
	p = NULL;
#line 266 "../src/book-view.vala"
	_tmp0_ = self->priv->selected_page_view;
#line 266 "../src/book-view.vala"
	if (_tmp0_ == page) {
#line 267 "../src/book-view.vala"
		_g_object_unref0 (p);
#line 267 "../src/book-view.vala"
		return;
#line 1423 "book-view.c"
	}
#line 269 "../src/book-view.vala"
	book_view_set_selected_page_view (self, page);
#line 271 "../src/book-view.vala"
	if (self->priv->need_layout) {
#line 272 "../src/book-view.vala"
		self->priv->show_selected_page = TRUE;
#line 1431 "book-view.c"
	} else {
#line 274 "../src/book-view.vala"
		book_view_show_page_view (self, page);
#line 1435 "book-view.c"
	}
#line 276 "../src/book-view.vala"
	if (page != NULL) {
#line 1439 "book-view.c"
		Page* _tmp1_;
		Page* _tmp2_;
		Page* _tmp3_;
#line 277 "../src/book-view.vala"
		_tmp1_ = page_view_get_page (page);
#line 277 "../src/book-view.vala"
		_tmp2_ = _tmp1_;
#line 277 "../src/book-view.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 277 "../src/book-view.vala"
		_g_object_unref0 (p);
#line 277 "../src/book-view.vala"
		p = _tmp3_;
#line 1453 "book-view.c"
	}
#line 278 "../src/book-view.vala"
	_tmp4_ = p;
#line 278 "../src/book-view.vala"
	g_signal_emit (self, book_view_signals[BOOK_VIEW_PAGE_SELECTED_SIGNAL], 0, _tmp4_);
#line 262 "../src/book-view.vala"
	_g_object_unref0 (p);
#line 1461 "book-view.c"
}

static void
book_view_remove_cb (BookView* self,
                     Book* book,
                     Page* page)
{
	PageView* new_selection = NULL;
	PageView* _tmp0_;
	PageView* _tmp1_;
	Page* _tmp2_;
	Page* _tmp3_;
	PageView* page_view = NULL;
	GHashTable* _tmp10_;
	gconstpointer _tmp11_;
	PageView* _tmp12_;
	guint _tmp13_;
	guint _tmp14_;
	GHashTable* _tmp15_;
	PageView* _tmp16_;
#line 281 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 281 "../src/book-view.vala"
	g_return_if_fail (book != NULL);
#line 281 "../src/book-view.vala"
	g_return_if_fail (page != NULL);
#line 283 "../src/book-view.vala"
	_tmp0_ = self->priv->selected_page_view;
#line 283 "../src/book-view.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 283 "../src/book-view.vala"
	new_selection = _tmp1_;
#line 286 "../src/book-view.vala"
	_tmp2_ = book_view_get_selected_page (self);
#line 286 "../src/book-view.vala"
	_tmp3_ = _tmp2_;
#line 286 "../src/book-view.vala"
	if (page == _tmp3_) {
#line 1500 "book-view.c"
		PageView* _tmp4_;
		PageView* _tmp5_;
		PageView* _tmp6_;
		PageView* _tmp7_;
#line 288 "../src/book-view.vala"
		_tmp4_ = self->priv->selected_page_view;
#line 288 "../src/book-view.vala"
		_tmp5_ = book_view_get_prev_page (self, _tmp4_);
#line 288 "../src/book-view.vala"
		_g_object_unref0 (new_selection);
#line 288 "../src/book-view.vala"
		new_selection = _tmp5_;
#line 289 "../src/book-view.vala"
		_tmp6_ = new_selection;
#line 289 "../src/book-view.vala"
		_tmp7_ = self->priv->selected_page_view;
#line 289 "../src/book-view.vala"
		if (_tmp6_ == _tmp7_) {
#line 1519 "book-view.c"
			PageView* _tmp8_;
			PageView* _tmp9_;
#line 290 "../src/book-view.vala"
			_tmp8_ = self->priv->selected_page_view;
#line 290 "../src/book-view.vala"
			_tmp9_ = book_view_get_next_page (self, _tmp8_);
#line 290 "../src/book-view.vala"
			_g_object_unref0 (new_selection);
#line 290 "../src/book-view.vala"
			new_selection = _tmp9_;
#line 1530 "book-view.c"
		}
#line 291 "../src/book-view.vala"
		_g_object_unref0 (self->priv->selected_page_view);
#line 291 "../src/book-view.vala"
		self->priv->selected_page_view = NULL;
#line 1536 "book-view.c"
	}
#line 294 "../src/book-view.vala"
	_tmp10_ = self->priv->page_data;
#line 294 "../src/book-view.vala"
	_tmp11_ = g_hash_table_lookup (_tmp10_, page);
#line 294 "../src/book-view.vala"
	_tmp12_ = _g_object_ref0 ((PageView*) _tmp11_);
#line 294 "../src/book-view.vala"
	page_view = _tmp12_;
#line 295 "../src/book-view.vala"
	g_signal_parse_name ("changed", TYPE_PAGE_VIEW, &_tmp13_, NULL, FALSE);
#line 295 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (page_view, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _book_view_page_view_changed_cb_page_view_changed, self);
#line 296 "../src/book-view.vala"
	g_signal_parse_name ("size-changed", TYPE_PAGE_VIEW, &_tmp14_, NULL, FALSE);
#line 296 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (page_view, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp14_, 0, NULL, (GCallback) _book_view_page_view_size_changed_cb_page_view_size_changed, self);
#line 297 "../src/book-view.vala"
	_tmp15_ = self->priv->page_data;
#line 297 "../src/book-view.vala"
	g_hash_table_remove (_tmp15_, page);
#line 299 "../src/book-view.vala"
	_tmp16_ = new_selection;
#line 299 "../src/book-view.vala"
	book_view_select_page_view (self, _tmp16_);
#line 301 "../src/book-view.vala"
	self->priv->need_layout = TRUE;
#line 302 "../src/book-view.vala"
	book_view_redraw (self);
#line 281 "../src/book-view.vala"
	_g_object_unref0 (page_view);
#line 281 "../src/book-view.vala"
	_g_object_unref0 (new_selection);
#line 1570 "book-view.c"
}

static void
book_view_reorder_cb (BookView* self,
                      Book* book)
{
#line 305 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 305 "../src/book-view.vala"
	g_return_if_fail (book != NULL);
#line 307 "../src/book-view.vala"
	self->priv->need_layout = TRUE;
#line 308 "../src/book-view.vala"
	book_view_redraw (self);
#line 1585 "book-view.c"
}

static void
book_view_clear_cb (BookView* self,
                    Book* book)
{
	GHashTable* _tmp0_;
#line 311 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 311 "../src/book-view.vala"
	g_return_if_fail (book != NULL);
#line 313 "../src/book-view.vala"
	_tmp0_ = self->priv->page_data;
#line 313 "../src/book-view.vala"
	g_hash_table_remove_all (_tmp0_);
#line 314 "../src/book-view.vala"
	_g_object_unref0 (self->priv->selected_page_view);
#line 314 "../src/book-view.vala"
	self->priv->selected_page_view = NULL;
#line 315 "../src/book-view.vala"
	g_signal_emit (self, book_view_signals[BOOK_VIEW_PAGE_SELECTED_SIGNAL], 0, NULL);
#line 316 "../src/book-view.vala"
	self->priv->need_layout = TRUE;
#line 317 "../src/book-view.vala"
	book_view_redraw (self);
#line 1611 "book-view.c"
}

void
book_view_drawing_area_resize_cb (BookView* self)
{
#line 320 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 322 "../src/book-view.vala"
	self->priv->need_layout = TRUE;
#line 325 "../src/book-view.vala"
	book_view_layout (self);
#line 1623 "book-view.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 328 "../src/book-view.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 1631 "book-view.c"
}

static void
book_view_layout_into (BookView* self,
                       gint width,
                       gint height,
                       gint* book_width,
                       gint* book_height)
{
	gint _vala_book_width = 0;
	gint _vala_book_height = 0;
	GList* pages = NULL;
	gint max_dpi = 0;
	GList* _tmp6_;
	gint max_width = 0;
	gint max_height = 0;
	GList* _tmp18_;
	gdouble aspect = 0.0;
	gdouble max_aspect = 0.0;
	gint spacing = 0;
	GList* _tmp36_;
	GList* _tmp62_;
	gint x_offset = 0;
	GList* _tmp63_;
#line 328 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 330 "../src/book-view.vala"
	pages = NULL;
#line 1660 "book-view.c"
	{
		gint i = 0;
#line 331 "../src/book-view.vala"
		i = 0;
#line 1665 "book-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 331 "../src/book-view.vala"
			_tmp0_ = TRUE;
#line 331 "../src/book-view.vala"
			while (TRUE) {
#line 1672 "book-view.c"
				Book* _tmp2_;
				guint _tmp3_;
				guint _tmp4_;
				PageView* _tmp5_;
#line 331 "../src/book-view.vala"
				if (!_tmp0_) {
#line 1679 "book-view.c"
					gint _tmp1_;
#line 331 "../src/book-view.vala"
					_tmp1_ = i;
#line 331 "../src/book-view.vala"
					i = _tmp1_ + 1;
#line 1685 "book-view.c"
				}
#line 331 "../src/book-view.vala"
				_tmp0_ = FALSE;
#line 331 "../src/book-view.vala"
				_tmp2_ = self->priv->_book;
#line 331 "../src/book-view.vala"
				_tmp3_ = book_get_n_pages (_tmp2_);
#line 331 "../src/book-view.vala"
				_tmp4_ = _tmp3_;
#line 331 "../src/book-view.vala"
				if (!(((guint) i) < _tmp4_)) {
#line 331 "../src/book-view.vala"
					break;
#line 1699 "book-view.c"
				}
#line 332 "../src/book-view.vala"
				_tmp5_ = book_view_get_nth_page (self, i);
#line 332 "../src/book-view.vala"
				pages = g_list_append (pages, _tmp5_);
#line 1705 "book-view.c"
			}
		}
	}
#line 335 "../src/book-view.vala"
	max_dpi = 0;
#line 336 "../src/book-view.vala"
	_tmp6_ = pages;
#line 1713 "book-view.c"
	{
		GList* page_collection = NULL;
		GList* page_it = NULL;
#line 336 "../src/book-view.vala"
		page_collection = _tmp6_;
#line 336 "../src/book-view.vala"
		for (page_it = page_collection; page_it != NULL; page_it = page_it->next) {
#line 1721 "book-view.c"
			PageView* _tmp7_;
			PageView* page = NULL;
#line 336 "../src/book-view.vala"
			_tmp7_ = _g_object_ref0 ((PageView*) page_it->data);
#line 336 "../src/book-view.vala"
			page = _tmp7_;
#line 1728 "book-view.c"
			{
				Page* p = NULL;
				PageView* _tmp8_;
				Page* _tmp9_;
				Page* _tmp10_;
				Page* _tmp11_;
				Page* _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
#line 338 "../src/book-view.vala"
				_tmp8_ = page;
#line 338 "../src/book-view.vala"
				_tmp9_ = page_view_get_page (_tmp8_);
#line 338 "../src/book-view.vala"
				_tmp10_ = _tmp9_;
#line 338 "../src/book-view.vala"
				_tmp11_ = _g_object_ref0 (_tmp10_);
#line 338 "../src/book-view.vala"
				p = _tmp11_;
#line 339 "../src/book-view.vala"
				_tmp12_ = p;
#line 339 "../src/book-view.vala"
				_tmp13_ = page_get_dpi (_tmp12_);
#line 339 "../src/book-view.vala"
				_tmp14_ = _tmp13_;
#line 339 "../src/book-view.vala"
				if (_tmp14_ > max_dpi) {
#line 1756 "book-view.c"
					Page* _tmp15_;
					gint _tmp16_;
					gint _tmp17_;
#line 340 "../src/book-view.vala"
					_tmp15_ = p;
#line 340 "../src/book-view.vala"
					_tmp16_ = page_get_dpi (_tmp15_);
#line 340 "../src/book-view.vala"
					_tmp17_ = _tmp16_;
#line 340 "../src/book-view.vala"
					max_dpi = _tmp17_;
#line 1768 "book-view.c"
				}
#line 336 "../src/book-view.vala"
				_g_object_unref0 (p);
#line 336 "../src/book-view.vala"
				_g_object_unref0 (page);
#line 1774 "book-view.c"
			}
		}
	}
#line 344 "../src/book-view.vala"
	max_width = 0;
#line 344 "../src/book-view.vala"
	max_height = 0;
#line 345 "../src/book-view.vala"
	_tmp18_ = pages;
#line 1784 "book-view.c"
	{
		GList* page_collection = NULL;
		GList* page_it = NULL;
#line 345 "../src/book-view.vala"
		page_collection = _tmp18_;
#line 345 "../src/book-view.vala"
		for (page_it = page_collection; page_it != NULL; page_it = page_it->next) {
#line 1792 "book-view.c"
			PageView* _tmp19_;
			PageView* page = NULL;
#line 345 "../src/book-view.vala"
			_tmp19_ = _g_object_ref0 ((PageView*) page_it->data);
#line 345 "../src/book-view.vala"
			page = _tmp19_;
#line 1799 "book-view.c"
			{
				Page* p = NULL;
				PageView* _tmp20_;
				Page* _tmp21_;
				Page* _tmp22_;
				Page* _tmp23_;
				gint w = 0;
				Page* _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
				gint h = 0;
				Page* _tmp27_;
				gint _tmp28_;
				gint _tmp29_;
				Page* _tmp30_;
				gint _tmp31_;
				gint _tmp32_;
				Page* _tmp33_;
				gint _tmp34_;
				gint _tmp35_;
#line 347 "../src/book-view.vala"
				_tmp20_ = page;
#line 347 "../src/book-view.vala"
				_tmp21_ = page_view_get_page (_tmp20_);
#line 347 "../src/book-view.vala"
				_tmp22_ = _tmp21_;
#line 347 "../src/book-view.vala"
				_tmp23_ = _g_object_ref0 (_tmp22_);
#line 347 "../src/book-view.vala"
				p = _tmp23_;
#line 348 "../src/book-view.vala"
				_tmp24_ = p;
#line 348 "../src/book-view.vala"
				_tmp25_ = page_get_width (_tmp24_);
#line 348 "../src/book-view.vala"
				_tmp26_ = _tmp25_;
#line 348 "../src/book-view.vala"
				w = _tmp26_;
#line 349 "../src/book-view.vala"
				_tmp27_ = p;
#line 349 "../src/book-view.vala"
				_tmp28_ = page_get_height (_tmp27_);
#line 349 "../src/book-view.vala"
				_tmp29_ = _tmp28_;
#line 349 "../src/book-view.vala"
				h = _tmp29_;
#line 352 "../src/book-view.vala"
				_tmp30_ = p;
#line 352 "../src/book-view.vala"
				_tmp31_ = page_get_dpi (_tmp30_);
#line 352 "../src/book-view.vala"
				_tmp32_ = _tmp31_;
#line 352 "../src/book-view.vala"
				w = (gint) (((((gdouble) w) * max_dpi) / _tmp32_) + 0.5);
#line 353 "../src/book-view.vala"
				_tmp33_ = p;
#line 353 "../src/book-view.vala"
				_tmp34_ = page_get_dpi (_tmp33_);
#line 353 "../src/book-view.vala"
				_tmp35_ = _tmp34_;
#line 353 "../src/book-view.vala"
				h = (gint) (((((gdouble) h) * max_dpi) / _tmp35_) + 0.5);
#line 355 "../src/book-view.vala"
				if (w > max_width) {
#line 356 "../src/book-view.vala"
					max_width = w;
#line 1866 "book-view.c"
				}
#line 357 "../src/book-view.vala"
				if (h > max_height) {
#line 358 "../src/book-view.vala"
					max_height = h;
#line 1872 "book-view.c"
				}
#line 345 "../src/book-view.vala"
				_g_object_unref0 (p);
#line 345 "../src/book-view.vala"
				_g_object_unref0 (page);
#line 1878 "book-view.c"
			}
		}
	}
#line 361 "../src/book-view.vala"
	aspect = ((gdouble) width) / height;
#line 362 "../src/book-view.vala"
	max_aspect = ((gdouble) max_width) / max_height;
#line 365 "../src/book-view.vala"
	spacing = 12;
#line 366 "../src/book-view.vala"
	_vala_book_width = 0;
#line 367 "../src/book-view.vala"
	_vala_book_height = 0;
#line 368 "../src/book-view.vala"
	_tmp36_ = pages;
#line 1894 "book-view.c"
	{
		GList* page_collection = NULL;
		GList* page_it = NULL;
#line 368 "../src/book-view.vala"
		page_collection = _tmp36_;
#line 368 "../src/book-view.vala"
		for (page_it = page_collection; page_it != NULL; page_it = page_it->next) {
#line 1902 "book-view.c"
			PageView* _tmp37_;
			PageView* page = NULL;
#line 368 "../src/book-view.vala"
			_tmp37_ = _g_object_ref0 ((PageView*) page_it->data);
#line 368 "../src/book-view.vala"
			page = _tmp37_;
#line 1909 "book-view.c"
			{
				Page* p = NULL;
				PageView* _tmp38_;
				Page* _tmp39_;
				Page* _tmp40_;
				Page* _tmp41_;
				gint h = 0;
				PageView* _tmp56_;
				gint _tmp57_;
				gint _tmp58_;
				PageView* _tmp59_;
				gint _tmp60_;
				gint _tmp61_;
#line 370 "../src/book-view.vala"
				_tmp38_ = page;
#line 370 "../src/book-view.vala"
				_tmp39_ = page_view_get_page (_tmp38_);
#line 370 "../src/book-view.vala"
				_tmp40_ = _tmp39_;
#line 370 "../src/book-view.vala"
				_tmp41_ = _g_object_ref0 (_tmp40_);
#line 370 "../src/book-view.vala"
				p = _tmp41_;
#line 373 "../src/book-view.vala"
				if (max_aspect > aspect) {
#line 1935 "book-view.c"
					gint w = 0;
					Page* _tmp42_;
					gint _tmp43_;
					gint _tmp44_;
					Page* _tmp45_;
					gint _tmp46_;
					gint _tmp47_;
					PageView* _tmp48_;
#line 376 "../src/book-view.vala"
					_tmp42_ = p;
#line 376 "../src/book-view.vala"
					_tmp43_ = page_get_width (_tmp42_);
#line 376 "../src/book-view.vala"
					_tmp44_ = _tmp43_;
#line 376 "../src/book-view.vala"
					_tmp45_ = p;
#line 376 "../src/book-view.vala"
					_tmp46_ = page_get_dpi (_tmp45_);
#line 376 "../src/book-view.vala"
					_tmp47_ = _tmp46_;
#line 376 "../src/book-view.vala"
					w = (gint) (((((gdouble) _tmp44_) * max_dpi) * width) / (_tmp47_ * max_width));
#line 377 "../src/book-view.vala"
					_tmp48_ = page;
#line 377 "../src/book-view.vala"
					page_view_set_width (_tmp48_, w);
#line 1962 "book-view.c"
				} else {
					gint h = 0;
					Page* _tmp49_;
					gint _tmp50_;
					gint _tmp51_;
					Page* _tmp52_;
					gint _tmp53_;
					gint _tmp54_;
					PageView* _tmp55_;
#line 382 "../src/book-view.vala"
					_tmp49_ = p;
#line 382 "../src/book-view.vala"
					_tmp50_ = page_get_height (_tmp49_);
#line 382 "../src/book-view.vala"
					_tmp51_ = _tmp50_;
#line 382 "../src/book-view.vala"
					_tmp52_ = p;
#line 382 "../src/book-view.vala"
					_tmp53_ = page_get_dpi (_tmp52_);
#line 382 "../src/book-view.vala"
					_tmp54_ = _tmp53_;
#line 382 "../src/book-view.vala"
					h = (gint) (((((gdouble) _tmp51_) * max_dpi) * height) / (_tmp54_ * max_height));
#line 383 "../src/book-view.vala"
					_tmp55_ = page;
#line 383 "../src/book-view.vala"
					page_view_set_height (_tmp55_, h);
#line 1990 "book-view.c"
				}
#line 386 "../src/book-view.vala"
				_tmp56_ = page;
#line 386 "../src/book-view.vala"
				_tmp57_ = page_view_get_height (_tmp56_);
#line 386 "../src/book-view.vala"
				_tmp58_ = _tmp57_;
#line 386 "../src/book-view.vala"
				h = _tmp58_;
#line 387 "../src/book-view.vala"
				if (h > _vala_book_height) {
#line 388 "../src/book-view.vala"
					_vala_book_height = h;
#line 2004 "book-view.c"
				}
#line 389 "../src/book-view.vala"
				_tmp59_ = page;
#line 389 "../src/book-view.vala"
				_tmp60_ = page_view_get_width (_tmp59_);
#line 389 "../src/book-view.vala"
				_tmp61_ = _tmp60_;
#line 389 "../src/book-view.vala"
				_vala_book_width = _vala_book_width + (_tmp61_ + spacing);
#line 368 "../src/book-view.vala"
				_g_object_unref0 (p);
#line 368 "../src/book-view.vala"
				_g_object_unref0 (page);
#line 2018 "book-view.c"
			}
		}
	}
#line 391 "../src/book-view.vala"
	_tmp62_ = pages;
#line 391 "../src/book-view.vala"
	if (_tmp62_ != NULL) {
#line 392 "../src/book-view.vala"
		_vala_book_width = _vala_book_width - spacing;
#line 2028 "book-view.c"
	}
#line 394 "../src/book-view.vala"
	x_offset = 0;
#line 395 "../src/book-view.vala"
	_tmp63_ = pages;
#line 2034 "book-view.c"
	{
		GList* page_collection = NULL;
		GList* page_it = NULL;
#line 395 "../src/book-view.vala"
		page_collection = _tmp63_;
#line 395 "../src/book-view.vala"
		for (page_it = page_collection; page_it != NULL; page_it = page_it->next) {
#line 2042 "book-view.c"
			PageView* _tmp64_;
			PageView* page = NULL;
#line 395 "../src/book-view.vala"
			_tmp64_ = _g_object_ref0 ((PageView*) page_it->data);
#line 395 "../src/book-view.vala"
			page = _tmp64_;
#line 2049 "book-view.c"
			{
				PageView* _tmp65_;
				PageView* _tmp66_;
				gint _tmp67_;
				gint _tmp68_;
				PageView* _tmp69_;
				PageView* _tmp70_;
				gint _tmp71_;
				gint _tmp72_;
#line 398 "../src/book-view.vala"
				_tmp65_ = page;
#line 398 "../src/book-view.vala"
				page_view_set_x_offset (_tmp65_, x_offset);
#line 399 "../src/book-view.vala"
				_tmp66_ = page;
#line 399 "../src/book-view.vala"
				_tmp67_ = page_view_get_width (_tmp66_);
#line 399 "../src/book-view.vala"
				_tmp68_ = _tmp67_;
#line 399 "../src/book-view.vala"
				x_offset += _tmp68_ + spacing;
#line 402 "../src/book-view.vala"
				_tmp69_ = page;
#line 402 "../src/book-view.vala"
				_tmp70_ = page;
#line 402 "../src/book-view.vala"
				_tmp71_ = page_view_get_height (_tmp70_);
#line 402 "../src/book-view.vala"
				_tmp72_ = _tmp71_;
#line 402 "../src/book-view.vala"
				page_view_set_y_offset (_tmp69_, (height - _tmp72_) / 2);
#line 395 "../src/book-view.vala"
				_g_object_unref0 (page);
#line 2083 "book-view.c"
			}
		}
	}
#line 328 "../src/book-view.vala"
	(pages == NULL) ? NULL : (pages = (_g_list_free__g_object_unref0_ (pages), NULL));
#line 328 "../src/book-view.vala"
	if (book_width) {
#line 328 "../src/book-view.vala"
		*book_width = _vala_book_width;
#line 2093 "book-view.c"
	}
#line 328 "../src/book-view.vala"
	if (book_height) {
#line 328 "../src/book-view.vala"
		*book_height = _vala_book_height;
#line 2099 "book-view.c"
	}
}

static void
book_view_layout (BookView* self)
{
	GtkAllocation allocation = {0};
	GtkDrawingArea* _tmp0_;
	GtkAllocation _tmp1_ = {0};
	GtkAllocation box_allocation = {0};
	GtkAllocation _tmp2_ = {0};
	gboolean right_aligned = FALSE;
	GtkAdjustment* _tmp3_;
	GtkAdjustment* _tmp4_;
	GtkAdjustment* _tmp5_;
	gint width = 0;
	GtkAllocation _tmp6_;
	gint height = 0;
	GtkAllocation _tmp7_;
	gint book_width = 0;
	gint book_height = 0;
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
	GtkAllocation _tmp10_;
#line 406 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 408 "../src/book-view.vala"
	if (!self->priv->need_layout) {
#line 409 "../src/book-view.vala"
		return;
#line 2130 "book-view.c"
	}
#line 411 "../src/book-view.vala"
	self->priv->laying_out = TRUE;
#line 414 "../src/book-view.vala"
	_tmp0_ = self->priv->drawing_area;
#line 414 "../src/book-view.vala"
	gtk_widget_get_allocation ((GtkWidget*) _tmp0_, &_tmp1_);
#line 414 "../src/book-view.vala"
	allocation = _tmp1_;
#line 416 "../src/book-view.vala"
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp2_);
#line 416 "../src/book-view.vala"
	box_allocation = _tmp2_;
#line 419 "../src/book-view.vala"
	right_aligned = TRUE;
#line 420 "../src/book-view.vala"
	_tmp3_ = self->priv->adjustment;
#line 420 "../src/book-view.vala"
	_tmp4_ = self->priv->adjustment;
#line 420 "../src/book-view.vala"
	_tmp5_ = self->priv->adjustment;
#line 420 "../src/book-view.vala"
	if (gtk_adjustment_get_value (_tmp3_) < (gtk_adjustment_get_upper (_tmp4_) - gtk_adjustment_get_page_size (_tmp5_))) {
#line 421 "../src/book-view.vala"
		right_aligned = FALSE;
#line 2156 "book-view.c"
	}
#line 424 "../src/book-view.vala"
	_tmp6_ = allocation;
#line 424 "../src/book-view.vala"
	width = (gint) _tmp6_.width;
#line 425 "../src/book-view.vala"
	_tmp7_ = box_allocation;
#line 425 "../src/book-view.vala"
	height = (gint) _tmp7_.height;
#line 427 "../src/book-view.vala"
	book_view_layout_into (self, width, height, &_tmp8_, &_tmp9_);
#line 427 "../src/book-view.vala"
	book_width = _tmp8_;
#line 427 "../src/book-view.vala"
	book_height = _tmp9_;
#line 430 "../src/book-view.vala"
	_tmp10_ = allocation;
#line 430 "../src/book-view.vala"
	if (book_width > _tmp10_.width) {
#line 2176 "book-view.c"
		GtkAllocation _tmp11_;
		gint _tmp12_ = 0;
		gint _tmp13_ = 0;
		GtkAdjustment* _tmp14_;
		GtkAdjustment* _tmp15_;
		GtkAdjustment* _tmp16_;
		GtkAllocation _tmp17_;
		gint max_offset = 0;
		GtkAllocation _tmp18_;
		gboolean _tmp19_ = FALSE;
		GtkScrollbar* _tmp22_;
#line 433 "../src/book-view.vala"
		_tmp11_ = allocation;
#line 433 "../src/book-view.vala"
		height = _tmp11_.height;
#line 434 "../src/book-view.vala"
		book_view_layout_into (self, width, height, &_tmp12_, &_tmp13_);
#line 434 "../src/book-view.vala"
		book_width = _tmp12_;
#line 434 "../src/book-view.vala"
		book_height = _tmp13_;
#line 437 "../src/book-view.vala"
		_tmp14_ = self->priv->adjustment;
#line 437 "../src/book-view.vala"
		gtk_adjustment_set_lower (_tmp14_, (gdouble) 0);
#line 438 "../src/book-view.vala"
		_tmp15_ = self->priv->adjustment;
#line 438 "../src/book-view.vala"
		gtk_adjustment_set_upper (_tmp15_, (gdouble) book_width);
#line 439 "../src/book-view.vala"
		_tmp16_ = self->priv->adjustment;
#line 439 "../src/book-view.vala"
		_tmp17_ = allocation;
#line 439 "../src/book-view.vala"
		gtk_adjustment_set_page_size (_tmp16_, (gdouble) _tmp17_.width);
#line 442 "../src/book-view.vala"
		_tmp18_ = allocation;
#line 442 "../src/book-view.vala"
		max_offset = book_width - _tmp18_.width;
#line 443 "../src/book-view.vala"
		if (right_aligned) {
#line 443 "../src/book-view.vala"
			_tmp19_ = TRUE;
#line 2220 "book-view.c"
		} else {
			gint _tmp20_;
			gint _tmp21_;
#line 443 "../src/book-view.vala"
			_tmp20_ = book_view_get_x_offset (self);
#line 443 "../src/book-view.vala"
			_tmp21_ = _tmp20_;
#line 443 "../src/book-view.vala"
			_tmp19_ = _tmp21_ > max_offset;
#line 2230 "book-view.c"
		}
#line 443 "../src/book-view.vala"
		if (_tmp19_) {
#line 444 "../src/book-view.vala"
			book_view_set_x_offset (self, max_offset);
#line 2236 "book-view.c"
		}
#line 446 "../src/book-view.vala"
		_tmp22_ = self->priv->scroll;
#line 446 "../src/book-view.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp22_, TRUE);
#line 2242 "book-view.c"
	} else {
		GtkScrollbar* _tmp23_;
		gint offset = 0;
		GtkAllocation _tmp24_;
		GtkAdjustment* _tmp25_;
		GtkAdjustment* _tmp26_;
		GtkAdjustment* _tmp27_;
#line 450 "../src/book-view.vala"
		_tmp23_ = self->priv->scroll;
#line 450 "../src/book-view.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp23_, FALSE);
#line 451 "../src/book-view.vala"
		_tmp24_ = allocation;
#line 451 "../src/book-view.vala"
		offset = (book_width - _tmp24_.width) / 2;
#line 452 "../src/book-view.vala"
		_tmp25_ = self->priv->adjustment;
#line 452 "../src/book-view.vala"
		gtk_adjustment_set_lower (_tmp25_, (gdouble) offset);
#line 453 "../src/book-view.vala"
		_tmp26_ = self->priv->adjustment;
#line 453 "../src/book-view.vala"
		gtk_adjustment_set_upper (_tmp26_, (gdouble) offset);
#line 454 "../src/book-view.vala"
		_tmp27_ = self->priv->adjustment;
#line 454 "../src/book-view.vala"
		gtk_adjustment_set_page_size (_tmp27_, (gdouble) 0);
#line 455 "../src/book-view.vala"
		book_view_set_x_offset (self, offset);
#line 2272 "book-view.c"
	}
#line 458 "../src/book-view.vala"
	if (self->priv->show_selected_page) {
#line 2276 "book-view.c"
		PageView* _tmp28_;
#line 459 "../src/book-view.vala"
		_tmp28_ = self->priv->selected_page_view;
#line 459 "../src/book-view.vala"
		book_view_show_page_view (self, _tmp28_);
#line 2282 "book-view.c"
	}
#line 461 "../src/book-view.vala"
	self->priv->need_layout = FALSE;
#line 462 "../src/book-view.vala"
	self->priv->show_selected_page = FALSE;
#line 463 "../src/book-view.vala"
	self->priv->laying_out = FALSE;
#line 2290 "book-view.c"
}

void
book_view_draw_cb (BookView* self,
                   GtkDrawingArea* drawing_area,
                   cairo_t* context,
                   gint width,
                   gint height)
{
	gdouble left = 0.0;
	gdouble top = 0.0;
	gdouble right = 0.0;
	gdouble bottom = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	GList* pages = NULL;
	GdkRGBA ruler_color = {0};
	GtkStyleContext* _tmp10_;
	GdkRGBA _tmp11_ = {0};
	GdkRGBA ruler_color_selected = {0};
	GdkRGBA _tmp12_ = {0};
	GList* _tmp13_;
#line 466 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 466 "../src/book-view.vala"
	g_return_if_fail (drawing_area != NULL);
#line 466 "../src/book-view.vala"
	g_return_if_fail (context != NULL);
#line 468 "../src/book-view.vala"
	book_view_layout (self);
#line 471 "../src/book-view.vala"
	cairo_clip_extents (context, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 471 "../src/book-view.vala"
	left = _tmp0_;
#line 471 "../src/book-view.vala"
	top = _tmp1_;
#line 471 "../src/book-view.vala"
	right = _tmp2_;
#line 471 "../src/book-view.vala"
	bottom = _tmp3_;
#line 473 "../src/book-view.vala"
	pages = NULL;
#line 2335 "book-view.c"
	{
		gint i = 0;
#line 474 "../src/book-view.vala"
		i = 0;
#line 2340 "book-view.c"
		{
			gboolean _tmp4_ = FALSE;
#line 474 "../src/book-view.vala"
			_tmp4_ = TRUE;
#line 474 "../src/book-view.vala"
			while (TRUE) {
#line 2347 "book-view.c"
				Book* _tmp6_;
				guint _tmp7_;
				guint _tmp8_;
				PageView* _tmp9_;
#line 474 "../src/book-view.vala"
				if (!_tmp4_) {
#line 2354 "book-view.c"
					gint _tmp5_;
#line 474 "../src/book-view.vala"
					_tmp5_ = i;
#line 474 "../src/book-view.vala"
					i = _tmp5_ + 1;
#line 2360 "book-view.c"
				}
#line 474 "../src/book-view.vala"
				_tmp4_ = FALSE;
#line 474 "../src/book-view.vala"
				_tmp6_ = self->priv->_book;
#line 474 "../src/book-view.vala"
				_tmp7_ = book_get_n_pages (_tmp6_);
#line 474 "../src/book-view.vala"
				_tmp8_ = _tmp7_;
#line 474 "../src/book-view.vala"
				if (!(((guint) i) < _tmp8_)) {
#line 474 "../src/book-view.vala"
					break;
#line 2374 "book-view.c"
				}
#line 475 "../src/book-view.vala"
				_tmp9_ = book_view_get_nth_page (self, i);
#line 475 "../src/book-view.vala"
				pages = g_list_append (pages, _tmp9_);
#line 2380 "book-view.c"
			}
		}
	}
#line 477 "../src/book-view.vala"
	_tmp10_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 477 "../src/book-view.vala"
	gtk_style_context_get_color (_tmp10_, &_tmp11_);
#line 477 "../src/book-view.vala"
	ruler_color = _tmp11_;
#line 478 "../src/book-view.vala"
	ruler_color_selected = _tmp12_;
#line 479 "../src/book-view.vala"
	gdk_rgba_parse (&ruler_color_selected, "#3584e4");
#line 482 "../src/book-view.vala"
	_tmp13_ = pages;
#line 2396 "book-view.c"
	{
		GList* page_collection = NULL;
		GList* page_it = NULL;
#line 482 "../src/book-view.vala"
		page_collection = _tmp13_;
#line 482 "../src/book-view.vala"
		for (page_it = page_collection; page_it != NULL; page_it = page_it->next) {
#line 2404 "book-view.c"
			PageView* _tmp14_;
			PageView* page = NULL;
#line 482 "../src/book-view.vala"
			_tmp14_ = _g_object_ref0 ((PageView*) page_it->data);
#line 482 "../src/book-view.vala"
			page = _tmp14_;
#line 2411 "book-view.c"
			{
				gint left_edge = 0;
				PageView* _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				gint _tmp19_;
				gint right_edge = 0;
				PageView* _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
				PageView* _tmp23_;
				gint _tmp24_;
				gint _tmp25_;
				gint _tmp26_;
				gint _tmp27_;
				gboolean _tmp28_ = FALSE;
				gint _tmp29_;
				gint _tmp30_;
				GdkRGBA _tmp31_ = {0};
				PageView* _tmp32_;
				PageView* _tmp33_;
				PageView* _tmp36_;
				PageView* _tmp37_;
				gboolean _tmp38_;
				gboolean _tmp39_;
#line 484 "../src/book-view.vala"
				_tmp15_ = page;
#line 484 "../src/book-view.vala"
				_tmp16_ = page_view_get_x_offset (_tmp15_);
#line 484 "../src/book-view.vala"
				_tmp17_ = _tmp16_;
#line 484 "../src/book-view.vala"
				_tmp18_ = book_view_get_x_offset (self);
#line 484 "../src/book-view.vala"
				_tmp19_ = _tmp18_;
#line 484 "../src/book-view.vala"
				left_edge = _tmp17_ - _tmp19_;
#line 485 "../src/book-view.vala"
				_tmp20_ = page;
#line 485 "../src/book-view.vala"
				_tmp21_ = page_view_get_x_offset (_tmp20_);
#line 485 "../src/book-view.vala"
				_tmp22_ = _tmp21_;
#line 485 "../src/book-view.vala"
				_tmp23_ = page;
#line 485 "../src/book-view.vala"
				_tmp24_ = page_view_get_width (_tmp23_);
#line 485 "../src/book-view.vala"
				_tmp25_ = _tmp24_;
#line 485 "../src/book-view.vala"
				_tmp26_ = book_view_get_x_offset (self);
#line 485 "../src/book-view.vala"
				_tmp27_ = _tmp26_;
#line 485 "../src/book-view.vala"
				right_edge = (_tmp22_ + _tmp25_) - _tmp27_;
#line 488 "../src/book-view.vala"
				if (((gdouble) right_edge) < left) {
#line 488 "../src/book-view.vala"
					_tmp28_ = TRUE;
#line 2472 "book-view.c"
				} else {
#line 488 "../src/book-view.vala"
					_tmp28_ = ((gdouble) left_edge) > right;
#line 2476 "book-view.c"
				}
#line 488 "../src/book-view.vala"
				if (_tmp28_) {
#line 489 "../src/book-view.vala"
					_g_object_unref0 (page);
#line 489 "../src/book-view.vala"
					continue;
#line 2484 "book-view.c"
				}
#line 491 "../src/book-view.vala"
				cairo_save (context);
#line 492 "../src/book-view.vala"
				_tmp29_ = book_view_get_x_offset (self);
#line 492 "../src/book-view.vala"
				_tmp30_ = _tmp29_;
#line 492 "../src/book-view.vala"
				cairo_translate (context, (gdouble) (-_tmp30_), (gdouble) 0);
#line 493 "../src/book-view.vala"
				_tmp32_ = page;
#line 493 "../src/book-view.vala"
				_tmp33_ = self->priv->selected_page_view;
#line 493 "../src/book-view.vala"
				if (_tmp32_ == _tmp33_) {
#line 2500 "book-view.c"
					GdkRGBA _tmp34_;
#line 493 "../src/book-view.vala"
					_tmp34_ = ruler_color_selected;
#line 493 "../src/book-view.vala"
					_tmp31_ = _tmp34_;
#line 2506 "book-view.c"
				} else {
					GdkRGBA _tmp35_;
#line 493 "../src/book-view.vala"
					_tmp35_ = ruler_color;
#line 493 "../src/book-view.vala"
					_tmp31_ = _tmp35_;
#line 2513 "book-view.c"
				}
#line 493 "../src/book-view.vala"
				_tmp36_ = page;
#line 493 "../src/book-view.vala"
				page_view_render (_tmp36_, context, &_tmp31_);
#line 494 "../src/book-view.vala"
				cairo_restore (context);
#line 496 "../src/book-view.vala"
				_tmp37_ = page;
#line 496 "../src/book-view.vala"
				_tmp38_ = page_view_get_selected (_tmp37_);
#line 496 "../src/book-view.vala"
				_tmp39_ = _tmp38_;
#line 496 "../src/book-view.vala"
				if (_tmp39_) {
#line 2529 "book-view.c"
					GtkStyleContext* _tmp40_;
					PageView* _tmp41_;
					gint _tmp42_;
					gint _tmp43_;
					gint _tmp44_;
					gint _tmp45_;
					PageView* _tmp46_;
					gint _tmp47_;
					gint _tmp48_;
					PageView* _tmp49_;
					gint _tmp50_;
					gint _tmp51_;
					PageView* _tmp52_;
					gint _tmp53_;
					gint _tmp54_;
#line 497 "../src/book-view.vala"
					_tmp40_ = gtk_widget_get_style_context ((GtkWidget*) drawing_area);
#line 497 "../src/book-view.vala"
					_tmp41_ = page;
#line 497 "../src/book-view.vala"
					_tmp42_ = page_view_get_x_offset (_tmp41_);
#line 497 "../src/book-view.vala"
					_tmp43_ = _tmp42_;
#line 497 "../src/book-view.vala"
					_tmp44_ = book_view_get_x_offset (self);
#line 497 "../src/book-view.vala"
					_tmp45_ = _tmp44_;
#line 497 "../src/book-view.vala"
					_tmp46_ = page;
#line 497 "../src/book-view.vala"
					_tmp47_ = page_view_get_y_offset (_tmp46_);
#line 497 "../src/book-view.vala"
					_tmp48_ = _tmp47_;
#line 497 "../src/book-view.vala"
					_tmp49_ = page;
#line 497 "../src/book-view.vala"
					_tmp50_ = page_view_get_width (_tmp49_);
#line 497 "../src/book-view.vala"
					_tmp51_ = _tmp50_;
#line 497 "../src/book-view.vala"
					_tmp52_ = page;
#line 497 "../src/book-view.vala"
					_tmp53_ = page_view_get_height (_tmp52_);
#line 497 "../src/book-view.vala"
					_tmp54_ = _tmp53_;
#line 497 "../src/book-view.vala"
					gtk_render_focus (_tmp40_, context, (gdouble) (_tmp43_ - _tmp45_), (gdouble) _tmp48_, (gdouble) _tmp51_, (gdouble) _tmp54_);
#line 2577 "book-view.c"
				}
#line 482 "../src/book-view.vala"
				_g_object_unref0 (page);
#line 2581 "book-view.c"
			}
		}
	}
#line 466 "../src/book-view.vala"
	(pages == NULL) ? NULL : (pages = (_g_list_free__g_object_unref0_ (pages), NULL));
#line 2587 "book-view.c"
}

static PageView*
book_view_get_page_at (BookView* self,
                       gint x,
                       gint y,
                       gint* x_,
                       gint* y_)
{
	gint _vala_x_ = 0;
	gint _vala_y_ = 0;
	PageView* result;
#line 505 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 507 "../src/book-view.vala"
	_vala_y_ = 0;
#line 507 "../src/book-view.vala"
	_vala_x_ = _vala_y_;
#line 2606 "book-view.c"
	{
		gint i = 0;
#line 508 "../src/book-view.vala"
		i = 0;
#line 2611 "book-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 508 "../src/book-view.vala"
			_tmp0_ = TRUE;
#line 508 "../src/book-view.vala"
			while (TRUE) {
#line 2618 "book-view.c"
				Book* _tmp2_;
				guint _tmp3_;
				guint _tmp4_;
				PageView* page = NULL;
				PageView* _tmp5_;
				gint left = 0;
				PageView* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
				gint right = 0;
				PageView* _tmp9_;
				gint _tmp10_;
				gint _tmp11_;
				gint top = 0;
				PageView* _tmp12_;
				gint _tmp13_;
				gint _tmp14_;
				gint bottom = 0;
				PageView* _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
				gboolean _tmp18_ = FALSE;
				gboolean _tmp19_ = FALSE;
				gboolean _tmp20_ = FALSE;
#line 508 "../src/book-view.vala"
				if (!_tmp0_) {
#line 2645 "book-view.c"
					gint _tmp1_;
#line 508 "../src/book-view.vala"
					_tmp1_ = i;
#line 508 "../src/book-view.vala"
					i = _tmp1_ + 1;
#line 2651 "book-view.c"
				}
#line 508 "../src/book-view.vala"
				_tmp0_ = FALSE;
#line 508 "../src/book-view.vala"
				_tmp2_ = self->priv->_book;
#line 508 "../src/book-view.vala"
				_tmp3_ = book_get_n_pages (_tmp2_);
#line 508 "../src/book-view.vala"
				_tmp4_ = _tmp3_;
#line 508 "../src/book-view.vala"
				if (!(((guint) i) < _tmp4_)) {
#line 508 "../src/book-view.vala"
					break;
#line 2665 "book-view.c"
				}
#line 510 "../src/book-view.vala"
				_tmp5_ = book_view_get_nth_page (self, i);
#line 510 "../src/book-view.vala"
				page = _tmp5_;
#line 511 "../src/book-view.vala"
				_tmp6_ = page;
#line 511 "../src/book-view.vala"
				_tmp7_ = page_view_get_x_offset (_tmp6_);
#line 511 "../src/book-view.vala"
				_tmp8_ = _tmp7_;
#line 511 "../src/book-view.vala"
				left = _tmp8_;
#line 512 "../src/book-view.vala"
				_tmp9_ = page;
#line 512 "../src/book-view.vala"
				_tmp10_ = page_view_get_width (_tmp9_);
#line 512 "../src/book-view.vala"
				_tmp11_ = _tmp10_;
#line 512 "../src/book-view.vala"
				right = left + _tmp11_;
#line 513 "../src/book-view.vala"
				_tmp12_ = page;
#line 513 "../src/book-view.vala"
				_tmp13_ = page_view_get_y_offset (_tmp12_);
#line 513 "../src/book-view.vala"
				_tmp14_ = _tmp13_;
#line 513 "../src/book-view.vala"
				top = _tmp14_;
#line 514 "../src/book-view.vala"
				_tmp15_ = page;
#line 514 "../src/book-view.vala"
				_tmp16_ = page_view_get_height (_tmp15_);
#line 514 "../src/book-view.vala"
				_tmp17_ = _tmp16_;
#line 514 "../src/book-view.vala"
				bottom = top + _tmp17_;
#line 515 "../src/book-view.vala"
				if (x >= left) {
#line 515 "../src/book-view.vala"
					_tmp20_ = x <= right;
#line 2707 "book-view.c"
				} else {
#line 515 "../src/book-view.vala"
					_tmp20_ = FALSE;
#line 2711 "book-view.c"
				}
#line 515 "../src/book-view.vala"
				if (_tmp20_) {
#line 515 "../src/book-view.vala"
					_tmp19_ = y >= top;
#line 2717 "book-view.c"
				} else {
#line 515 "../src/book-view.vala"
					_tmp19_ = FALSE;
#line 2721 "book-view.c"
				}
#line 515 "../src/book-view.vala"
				if (_tmp19_) {
#line 515 "../src/book-view.vala"
					_tmp18_ = y <= bottom;
#line 2727 "book-view.c"
				} else {
#line 515 "../src/book-view.vala"
					_tmp18_ = FALSE;
#line 2731 "book-view.c"
				}
#line 515 "../src/book-view.vala"
				if (_tmp18_) {
#line 517 "../src/book-view.vala"
					_vala_x_ = x - left;
#line 518 "../src/book-view.vala"
					_vala_y_ = y - top;
#line 519 "../src/book-view.vala"
					result = page;
#line 519 "../src/book-view.vala"
					if (x_) {
#line 519 "../src/book-view.vala"
						*x_ = _vala_x_;
#line 2745 "book-view.c"
					}
#line 519 "../src/book-view.vala"
					if (y_) {
#line 519 "../src/book-view.vala"
						*y_ = _vala_y_;
#line 2751 "book-view.c"
					}
#line 519 "../src/book-view.vala"
					return result;
#line 2755 "book-view.c"
				}
#line 508 "../src/book-view.vala"
				_g_object_unref0 (page);
#line 2759 "book-view.c"
			}
		}
	}
#line 523 "../src/book-view.vala"
	result = NULL;
#line 523 "../src/book-view.vala"
	if (x_) {
#line 523 "../src/book-view.vala"
		*x_ = _vala_x_;
#line 2769 "book-view.c"
	}
#line 523 "../src/book-view.vala"
	if (y_) {
#line 523 "../src/book-view.vala"
		*y_ = _vala_y_;
#line 2775 "book-view.c"
	}
#line 523 "../src/book-view.vala"
	return result;
#line 2779 "book-view.c"
}

static void
book_view_primary_pressed_cb (BookView* self,
                              GtkGestureClick* controler,
                              gint n_press,
                              gdouble x,
                              gdouble y)
{
#line 526 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 526 "../src/book-view.vala"
	g_return_if_fail (controler != NULL);
#line 528 "../src/book-view.vala"
	book_view_button_cb (self, controler, GDK_BUTTON_PRIMARY, TRUE, n_press, x, y);
#line 2795 "book-view.c"
}

static void
book_view_primary_released_cb (BookView* self,
                               GtkGestureClick* controler,
                               gint n_press,
                               gdouble x,
                               gdouble y)
{
#line 531 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 531 "../src/book-view.vala"
	g_return_if_fail (controler != NULL);
#line 533 "../src/book-view.vala"
	book_view_button_cb (self, controler, GDK_BUTTON_PRIMARY, FALSE, n_press, x, y);
#line 2811 "book-view.c"
}

static void
book_view_secondary_pressed_cb (BookView* self,
                                GtkGestureClick* controler,
                                gint n_press,
                                gdouble x,
                                gdouble y)
{
#line 536 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 536 "../src/book-view.vala"
	g_return_if_fail (controler != NULL);
#line 538 "../src/book-view.vala"
	book_view_button_cb (self, controler, GDK_BUTTON_SECONDARY, TRUE, n_press, x, y);
#line 2827 "book-view.c"
}

static void
book_view_secondary_released_cb (BookView* self,
                                 GtkGestureClick* controler,
                                 gint n_press,
                                 gdouble x,
                                 gdouble y)
{
#line 541 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 541 "../src/book-view.vala"
	g_return_if_fail (controler != NULL);
#line 543 "../src/book-view.vala"
	book_view_button_cb (self, controler, GDK_BUTTON_SECONDARY, FALSE, n_press, x, y);
#line 2843 "book-view.c"
}

static void
book_view_button_cb (BookView* self,
                     GtkGestureClick* controler,
                     gint button,
                     gboolean press,
                     gint n_press,
                     gdouble dx,
                     gdouble dy)
{
	GtkDrawingArea* _tmp0_;
	gint x = 0;
	gint y = 0;
	PageView* _tmp7_;
#line 546 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 546 "../src/book-view.vala"
	g_return_if_fail (controler != NULL);
#line 548 "../src/book-view.vala"
	book_view_layout (self);
#line 550 "../src/book-view.vala"
	_tmp0_ = self->priv->drawing_area;
#line 550 "../src/book-view.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp0_);
#line 552 "../src/book-view.vala"
	x = 0;
#line 552 "../src/book-view.vala"
	y = 0;
#line 553 "../src/book-view.vala"
	if (press) {
#line 2875 "book-view.c"
		gint _tmp1_;
		gint _tmp2_;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		PageView* _tmp5_;
		PageView* _tmp6_;
#line 554 "../src/book-view.vala"
		_tmp1_ = book_view_get_x_offset (self);
#line 554 "../src/book-view.vala"
		_tmp2_ = _tmp1_;
#line 554 "../src/book-view.vala"
		_tmp5_ = book_view_get_page_at (self, (gint) (((gint) dx) + _tmp2_), (gint) dy, &_tmp3_, &_tmp4_);
#line 554 "../src/book-view.vala"
		x = _tmp3_;
#line 554 "../src/book-view.vala"
		y = _tmp4_;
#line 554 "../src/book-view.vala"
		_tmp6_ = _tmp5_;
#line 554 "../src/book-view.vala"
		book_view_select_page_view (self, _tmp6_);
#line 554 "../src/book-view.vala"
		_g_object_unref0 (_tmp6_);
#line 2898 "book-view.c"
	}
#line 556 "../src/book-view.vala"
	_tmp7_ = self->priv->selected_page_view;
#line 556 "../src/book-view.vala"
	if (_tmp7_ == NULL) {
#line 557 "../src/book-view.vala"
		return;
#line 2906 "book-view.c"
	}
#line 560 "../src/book-view.vala"
	if (button == GDK_BUTTON_PRIMARY) {
#line 562 "../src/book-view.vala"
		if (press) {
#line 2912 "book-view.c"
			PageView* _tmp8_;
#line 563 "../src/book-view.vala"
			_tmp8_ = self->priv->selected_page_view;
#line 563 "../src/book-view.vala"
			page_view_button_press (_tmp8_, x, y);
#line 2918 "book-view.c"
		} else {
			gboolean _tmp9_ = FALSE;
#line 564 "../src/book-view.vala"
			if (press) {
#line 564 "../src/book-view.vala"
				_tmp9_ = n_press == 2;
#line 2925 "book-view.c"
			} else {
#line 564 "../src/book-view.vala"
				_tmp9_ = FALSE;
#line 2929 "book-view.c"
			}
#line 564 "../src/book-view.vala"
			if (_tmp9_) {
#line 2933 "book-view.c"
				Page* _tmp10_;
				Page* _tmp11_;
#line 565 "../src/book-view.vala"
				_tmp10_ = book_view_get_selected_page (self);
#line 565 "../src/book-view.vala"
				_tmp11_ = _tmp10_;
#line 565 "../src/book-view.vala"
				g_signal_emit (self, book_view_signals[BOOK_VIEW_SHOW_PAGE_SIGNAL], 0, _tmp11_);
#line 2942 "book-view.c"
			} else {
#line 566 "../src/book-view.vala"
				if (!press) {
#line 2946 "book-view.c"
					PageView* _tmp12_;
#line 567 "../src/book-view.vala"
					_tmp12_ = self->priv->selected_page_view;
#line 567 "../src/book-view.vala"
					page_view_button_release (_tmp12_, x, y);
#line 2952 "book-view.c"
				}
			}
		}
	}
#line 571 "../src/book-view.vala"
	if (button == GDK_BUTTON_SECONDARY) {
#line 2959 "book-view.c"
		GtkDrawingArea* _tmp13_;
#line 572 "../src/book-view.vala"
		_tmp13_ = self->priv->drawing_area;
#line 572 "../src/book-view.vala"
		g_signal_emit (self, book_view_signals[BOOK_VIEW_SHOW_MENU_SIGNAL], 0, (GtkWidget*) _tmp13_, dx, dy);
#line 2965 "book-view.c"
	}
}

static void
book_view_set_cursor (BookView* self,
                      const gchar* cursor)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GdkCursor* c = NULL;
	GdkCursor* _tmp2_;
	GtkDrawingArea* _tmp3_;
	GdkCursor* _tmp4_;
#line 575 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 575 "../src/book-view.vala"
	g_return_if_fail (cursor != NULL);
#line 577 "../src/book-view.vala"
	_tmp0_ = self->priv->cursor;
#line 577 "../src/book-view.vala"
	if (g_strcmp0 (_tmp0_, cursor) == 0) {
#line 578 "../src/book-view.vala"
		return;
#line 2989 "book-view.c"
	}
#line 579 "../src/book-view.vala"
	_tmp1_ = g_strdup (cursor);
#line 579 "../src/book-view.vala"
	_g_free0 (self->priv->cursor);
#line 579 "../src/book-view.vala"
	self->priv->cursor = _tmp1_;
#line 581 "../src/book-view.vala"
	_tmp2_ = gdk_cursor_new_from_name (cursor, NULL);
#line 581 "../src/book-view.vala"
	c = _tmp2_;
#line 582 "../src/book-view.vala"
	_tmp3_ = self->priv->drawing_area;
#line 582 "../src/book-view.vala"
	_tmp4_ = c;
#line 582 "../src/book-view.vala"
	gtk_widget_set_cursor ((GtkWidget*) _tmp3_, _tmp4_);
#line 575 "../src/book-view.vala"
	_g_object_unref0 (c);
#line 3009 "book-view.c"
}

static void
book_view_motion_cb (BookView* self,
                     GtkEventControllerMotion* controler,
                     gdouble dx,
                     gdouble dy)
{
	gchar* cursor = NULL;
	gchar* _tmp0_;
	gint event_x = 0;
	gint event_y = 0;
	GdkModifierType event_state = 0U;
	gboolean _tmp1_ = FALSE;
	PageView* _tmp2_;
	const gchar* _tmp27_;
#line 585 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 585 "../src/book-view.vala"
	g_return_if_fail (controler != NULL);
#line 587 "../src/book-view.vala"
	_tmp0_ = g_strdup ("arrow");
#line 587 "../src/book-view.vala"
	cursor = _tmp0_;
#line 589 "../src/book-view.vala"
	event_x = (gint) dx;
#line 590 "../src/book-view.vala"
	event_y = (gint) dy;
#line 592 "../src/book-view.vala"
	event_state = gtk_event_controller_get_current_event_state ((GtkEventController*) controler);
#line 595 "../src/book-view.vala"
	_tmp2_ = self->priv->selected_page_view;
#line 595 "../src/book-view.vala"
	if (_tmp2_ != NULL) {
#line 595 "../src/book-view.vala"
		_tmp1_ = (event_state & GDK_BUTTON1_MASK) != 0;
#line 3046 "book-view.c"
	} else {
#line 595 "../src/book-view.vala"
		_tmp1_ = FALSE;
#line 3050 "book-view.c"
	}
#line 595 "../src/book-view.vala"
	if (_tmp1_) {
#line 3054 "book-view.c"
		gint x = 0;
		gint _tmp3_;
		gint _tmp4_;
		PageView* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
		gint y = 0;
		PageView* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		PageView* _tmp11_;
		PageView* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
#line 597 "../src/book-view.vala"
		_tmp3_ = book_view_get_x_offset (self);
#line 597 "../src/book-view.vala"
		_tmp4_ = _tmp3_;
#line 597 "../src/book-view.vala"
		_tmp5_ = self->priv->selected_page_view;
#line 597 "../src/book-view.vala"
		_tmp6_ = page_view_get_x_offset (_tmp5_);
#line 597 "../src/book-view.vala"
		_tmp7_ = _tmp6_;
#line 597 "../src/book-view.vala"
		x = (gint) ((event_x + _tmp4_) - _tmp7_);
#line 598 "../src/book-view.vala"
		_tmp8_ = self->priv->selected_page_view;
#line 598 "../src/book-view.vala"
		_tmp9_ = page_view_get_y_offset (_tmp8_);
#line 598 "../src/book-view.vala"
		_tmp10_ = _tmp9_;
#line 598 "../src/book-view.vala"
		y = (gint) (event_y - _tmp10_);
#line 599 "../src/book-view.vala"
		_tmp11_ = self->priv->selected_page_view;
#line 599 "../src/book-view.vala"
		page_view_motion (_tmp11_, x, y);
#line 600 "../src/book-view.vala"
		_tmp12_ = self->priv->selected_page_view;
#line 600 "../src/book-view.vala"
		_tmp13_ = page_view_get_cursor (_tmp12_);
#line 600 "../src/book-view.vala"
		_tmp14_ = _tmp13_;
#line 600 "../src/book-view.vala"
		_tmp15_ = g_strdup (_tmp14_);
#line 600 "../src/book-view.vala"
		_g_free0 (cursor);
#line 600 "../src/book-view.vala"
		cursor = _tmp15_;
#line 3106 "book-view.c"
	} else {
		gint x = 0;
		gint y = 0;
		PageView* over_page = NULL;
		gint _tmp16_;
		gint _tmp17_;
		gint _tmp18_ = 0;
		gint _tmp19_ = 0;
		PageView* _tmp20_;
		PageView* _tmp21_;
#line 605 "../src/book-view.vala"
		_tmp16_ = book_view_get_x_offset (self);
#line 605 "../src/book-view.vala"
		_tmp17_ = _tmp16_;
#line 605 "../src/book-view.vala"
		_tmp20_ = book_view_get_page_at (self, (gint) (event_x + _tmp17_), (gint) event_y, &_tmp18_, &_tmp19_);
#line 605 "../src/book-view.vala"
		x = _tmp18_;
#line 605 "../src/book-view.vala"
		y = _tmp19_;
#line 605 "../src/book-view.vala"
		over_page = _tmp20_;
#line 606 "../src/book-view.vala"
		_tmp21_ = over_page;
#line 606 "../src/book-view.vala"
		if (_tmp21_ != NULL) {
#line 3133 "book-view.c"
			PageView* _tmp22_;
			PageView* _tmp23_;
			const gchar* _tmp24_;
			const gchar* _tmp25_;
			gchar* _tmp26_;
#line 608 "../src/book-view.vala"
			_tmp22_ = over_page;
#line 608 "../src/book-view.vala"
			page_view_motion (_tmp22_, x, y);
#line 609 "../src/book-view.vala"
			_tmp23_ = over_page;
#line 609 "../src/book-view.vala"
			_tmp24_ = page_view_get_cursor (_tmp23_);
#line 609 "../src/book-view.vala"
			_tmp25_ = _tmp24_;
#line 609 "../src/book-view.vala"
			_tmp26_ = g_strdup (_tmp25_);
#line 609 "../src/book-view.vala"
			_g_free0 (cursor);
#line 609 "../src/book-view.vala"
			cursor = _tmp26_;
#line 3155 "book-view.c"
		}
#line 595 "../src/book-view.vala"
		_g_object_unref0 (over_page);
#line 3159 "book-view.c"
	}
#line 613 "../src/book-view.vala"
	_tmp27_ = cursor;
#line 613 "../src/book-view.vala"
	book_view_set_cursor (self, _tmp27_);
#line 585 "../src/book-view.vala"
	_g_free0 (cursor);
#line 3167 "book-view.c"
}

static gboolean
book_view_key_cb (BookView* self,
                  GtkEventControllerKey* controler,
                  guint keyval,
                  guint keycode,
                  GdkModifierType state)
{
	gboolean result;
#line 616 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 616 "../src/book-view.vala"
	g_return_val_if_fail (controler != NULL, FALSE);
#line 618 "../src/book-view.vala"
	switch (keyval) {
#line 618 "../src/book-view.vala"
		case 0xff50:
#line 3186 "book-view.c"
		{
			Book* _tmp0_;
			Page* _tmp1_;
			Page* _tmp2_;
#line 621 "../src/book-view.vala"
			_tmp0_ = self->priv->_book;
#line 621 "../src/book-view.vala"
			_tmp1_ = book_get_page (_tmp0_, 0);
#line 621 "../src/book-view.vala"
			_tmp2_ = _tmp1_;
#line 621 "../src/book-view.vala"
			book_view_set_selected_page (self, _tmp2_);
#line 621 "../src/book-view.vala"
			_g_object_unref0 (_tmp2_);
#line 622 "../src/book-view.vala"
			result = TRUE;
#line 622 "../src/book-view.vala"
			return result;
#line 3205 "book-view.c"
		}
#line 618 "../src/book-view.vala"
		case 0xff51:
#line 3209 "book-view.c"
		{
			PageView* _tmp3_;
			PageView* _tmp4_;
			PageView* _tmp5_;
#line 624 "../src/book-view.vala"
			_tmp3_ = self->priv->selected_page_view;
#line 624 "../src/book-view.vala"
			_tmp4_ = book_view_get_prev_page (self, _tmp3_);
#line 624 "../src/book-view.vala"
			_tmp5_ = _tmp4_;
#line 624 "../src/book-view.vala"
			book_view_select_page_view (self, _tmp5_);
#line 624 "../src/book-view.vala"
			_g_object_unref0 (_tmp5_);
#line 625 "../src/book-view.vala"
			result = TRUE;
#line 625 "../src/book-view.vala"
			return result;
#line 3228 "book-view.c"
		}
#line 618 "../src/book-view.vala"
		case 0xff53:
#line 3232 "book-view.c"
		{
			PageView* _tmp6_;
			PageView* _tmp7_;
			PageView* _tmp8_;
#line 627 "../src/book-view.vala"
			_tmp6_ = self->priv->selected_page_view;
#line 627 "../src/book-view.vala"
			_tmp7_ = book_view_get_next_page (self, _tmp6_);
#line 627 "../src/book-view.vala"
			_tmp8_ = _tmp7_;
#line 627 "../src/book-view.vala"
			book_view_select_page_view (self, _tmp8_);
#line 627 "../src/book-view.vala"
			_g_object_unref0 (_tmp8_);
#line 628 "../src/book-view.vala"
			result = TRUE;
#line 628 "../src/book-view.vala"
			return result;
#line 3251 "book-view.c"
		}
#line 618 "../src/book-view.vala"
		case 0xFF57:
#line 3255 "book-view.c"
		{
			Book* _tmp9_;
			Book* _tmp10_;
			guint _tmp11_;
			guint _tmp12_;
			Page* _tmp13_;
			Page* _tmp14_;
#line 630 "../src/book-view.vala"
			_tmp9_ = self->priv->_book;
#line 630 "../src/book-view.vala"
			_tmp10_ = self->priv->_book;
#line 630 "../src/book-view.vala"
			_tmp11_ = book_get_n_pages (_tmp10_);
#line 630 "../src/book-view.vala"
			_tmp12_ = _tmp11_;
#line 630 "../src/book-view.vala"
			_tmp13_ = book_get_page (_tmp9_, ((gint) _tmp12_) - 1);
#line 630 "../src/book-view.vala"
			_tmp14_ = _tmp13_;
#line 630 "../src/book-view.vala"
			book_view_set_selected_page (self, _tmp14_);
#line 630 "../src/book-view.vala"
			_g_object_unref0 (_tmp14_);
#line 631 "../src/book-view.vala"
			result = TRUE;
#line 631 "../src/book-view.vala"
			return result;
#line 3283 "book-view.c"
		}
		default:
		{
#line 634 "../src/book-view.vala"
			result = FALSE;
#line 634 "../src/book-view.vala"
			return result;
#line 3291 "book-view.c"
		}
	}
}

static void
book_view_focus_cb (BookView* self,
                    GtkEventControllerFocus* controler)
{
	PageView* _tmp0_;
#line 638 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 638 "../src/book-view.vala"
	g_return_if_fail (controler != NULL);
#line 640 "../src/book-view.vala"
	_tmp0_ = self->priv->selected_page_view;
#line 640 "../src/book-view.vala"
	book_view_set_selected_page_view (self, _tmp0_);
#line 3309 "book-view.c"
}

static void
book_view_scroll_cb (BookView* self,
                     GtkAdjustment* adjustment)
{
#line 643 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 643 "../src/book-view.vala"
	g_return_if_fail (adjustment != NULL);
#line 645 "../src/book-view.vala"
	if (!self->priv->laying_out) {
#line 646 "../src/book-view.vala"
		book_view_redraw (self);
#line 3324 "book-view.c"
	}
}

void
book_view_redraw (BookView* self)
{
	GtkDrawingArea* _tmp0_;
#line 649 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 651 "../src/book-view.vala"
	_tmp0_ = self->priv->drawing_area;
#line 651 "../src/book-view.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp0_);
#line 3338 "book-view.c"
}

void
book_view_select_next_page (BookView* self)
{
	PageView* _tmp0_;
	PageView* _tmp1_;
	PageView* _tmp2_;
#line 654 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 656 "../src/book-view.vala"
	_tmp0_ = self->priv->selected_page_view;
#line 656 "../src/book-view.vala"
	_tmp1_ = book_view_get_next_page (self, _tmp0_);
#line 656 "../src/book-view.vala"
	_tmp2_ = _tmp1_;
#line 656 "../src/book-view.vala"
	book_view_select_page_view (self, _tmp2_);
#line 656 "../src/book-view.vala"
	_g_object_unref0 (_tmp2_);
#line 3359 "book-view.c"
}

void
book_view_select_prev_page (BookView* self)
{
	PageView* _tmp0_;
	PageView* _tmp1_;
	PageView* _tmp2_;
#line 659 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 661 "../src/book-view.vala"
	_tmp0_ = self->priv->selected_page_view;
#line 661 "../src/book-view.vala"
	_tmp1_ = book_view_get_prev_page (self, _tmp0_);
#line 661 "../src/book-view.vala"
	_tmp2_ = _tmp1_;
#line 661 "../src/book-view.vala"
	book_view_select_page_view (self, _tmp2_);
#line 661 "../src/book-view.vala"
	_g_object_unref0 (_tmp2_);
#line 3380 "book-view.c"
}

Book*
book_view_get_book (BookView* self)
{
	Book* result;
	Book* _tmp0_;
#line 18 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 18 "../src/book-view.vala"
	_tmp0_ = self->priv->_book;
#line 18 "../src/book-view.vala"
	result = _tmp0_;
#line 18 "../src/book-view.vala"
	return result;
#line 3396 "book-view.c"
}

static void
book_view_set_book (BookView* self,
                    Book* value)
{
	Book* old_value;
#line 18 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 18 "../src/book-view.vala"
	old_value = book_view_get_book (self);
#line 18 "../src/book-view.vala"
	if (old_value != value) {
#line 3410 "book-view.c"
		Book* _tmp0_;
#line 18 "../src/book-view.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 18 "../src/book-view.vala"
		_g_object_unref0 (self->priv->_book);
#line 18 "../src/book-view.vala"
		self->priv->_book = _tmp0_;
#line 18 "../src/book-view.vala"
		g_object_notify_by_pspec ((GObject *) self, book_view_properties[BOOK_VIEW_BOOK_PROPERTY]);
#line 3420 "book-view.c"
	}
}

Page*
book_view_get_selected_page (BookView* self)
{
	Page* result;
	PageView* _tmp0_;
#line 30 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../src/book-view.vala"
	_tmp0_ = self->priv->selected_page_view;
#line 32 "../src/book-view.vala"
	if (_tmp0_ != NULL) {
#line 3435 "book-view.c"
		PageView* _tmp1_;
		Page* _tmp2_;
		Page* _tmp3_;
#line 33 "../src/book-view.vala"
		_tmp1_ = self->priv->selected_page_view;
#line 33 "../src/book-view.vala"
		_tmp2_ = page_view_get_page (_tmp1_);
#line 33 "../src/book-view.vala"
		_tmp3_ = _tmp2_;
#line 33 "../src/book-view.vala"
		result = _tmp3_;
#line 33 "../src/book-view.vala"
		return result;
#line 3449 "book-view.c"
	} else {
#line 35 "../src/book-view.vala"
		result = NULL;
#line 35 "../src/book-view.vala"
		return result;
#line 3455 "book-view.c"
	}
}

void
book_view_set_selected_page (BookView* self,
                             Page* value)
{
	Page* _tmp0_;
	Page* _tmp1_;
#line 37 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/book-view.vala"
	_tmp0_ = book_view_get_selected_page (self);
#line 39 "../src/book-view.vala"
	_tmp1_ = _tmp0_;
#line 39 "../src/book-view.vala"
	if (_tmp1_ == value) {
#line 40 "../src/book-view.vala"
		return;
#line 3475 "book-view.c"
	}
#line 42 "../src/book-view.vala"
	if (value != NULL) {
#line 3479 "book-view.c"
		GHashTable* _tmp2_;
		gconstpointer _tmp3_;
#line 43 "../src/book-view.vala"
		_tmp2_ = self->priv->page_data;
#line 43 "../src/book-view.vala"
		_tmp3_ = g_hash_table_lookup (_tmp2_, value);
#line 43 "../src/book-view.vala"
		book_view_select_page_view (self, (PageView*) _tmp3_);
#line 3488 "book-view.c"
	} else {
#line 45 "../src/book-view.vala"
		book_view_select_page_view (self, NULL);
#line 3492 "book-view.c"
	}
#line 37 "../src/book-view.vala"
	g_object_notify_by_pspec ((GObject *) self, book_view_properties[BOOK_VIEW_SELECTED_PAGE_PROPERTY]);
#line 3496 "book-view.c"
}

gint
book_view_get_x_offset (BookView* self)
{
	gint result;
	GtkAdjustment* _tmp0_;
#line 71 "../src/book-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 73 "../src/book-view.vala"
	_tmp0_ = self->priv->adjustment;
#line 73 "../src/book-view.vala"
	result = (gint) gtk_adjustment_get_value (_tmp0_);
#line 73 "../src/book-view.vala"
	return result;
#line 3512 "book-view.c"
}

void
book_view_set_x_offset (BookView* self,
                        gint value)
{
	GtkAdjustment* _tmp0_;
#line 75 "../src/book-view.vala"
	g_return_if_fail (self != NULL);
#line 77 "../src/book-view.vala"
	_tmp0_ = self->priv->adjustment;
#line 77 "../src/book-view.vala"
	gtk_adjustment_set_value (_tmp0_, (gdouble) value);
#line 75 "../src/book-view.vala"
	g_object_notify_by_pspec ((GObject *) self, book_view_properties[BOOK_VIEW_X_OFFSET_PROPERTY]);
#line 3528 "book-view.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_DOUBLE_DOUBLE (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_DOUBLE_DOUBLE) (gpointer data1, gpointer arg_1, gdouble arg_2, gdouble arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_DOUBLE_DOUBLE callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 15 "../src/book-view.vala"
	g_return_if_fail (n_param_values == 4);
#line 15 "../src/book-view.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 15 "../src/book-view.vala"
		data1 = closure->data;
#line 15 "../src/book-view.vala"
		data2 = param_values->data[0].v_pointer;
#line 3553 "book-view.c"
	} else {
#line 15 "../src/book-view.vala"
		data1 = param_values->data[0].v_pointer;
#line 15 "../src/book-view.vala"
		data2 = closure->data;
#line 3559 "book-view.c"
	}
#line 15 "../src/book-view.vala"
	callback = (GMarshalFunc_VOID__OBJECT_DOUBLE_DOUBLE) (marshal_data ? marshal_data : cc->callback);
#line 15 "../src/book-view.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_double (param_values + 2), g_value_get_double (param_values + 3), data2);
#line 3565 "book-view.c"
}

static void
book_view_class_init (BookViewClass * klass,
                      gpointer klass_data)
{
#line 15 "../src/book-view.vala"
	book_view_parent_class = g_type_class_peek_parent (klass);
#line 15 "../src/book-view.vala"
	g_type_class_adjust_private_offset (klass, &BookView_private_offset);
#line 15 "../src/book-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_book_view_get_property;
#line 15 "../src/book-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_book_view_set_property;
#line 15 "../src/book-view.vala"
	G_OBJECT_CLASS (klass)->finalize = book_view_finalize;
#line 15 "../src/book-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOOK_VIEW_BOOK_PROPERTY, book_view_properties[BOOK_VIEW_BOOK_PROPERTY] = g_param_spec_object ("book", "book", "book", TYPE_BOOK, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 15 "../src/book-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOOK_VIEW_SELECTED_PAGE_PROPERTY, book_view_properties[BOOK_VIEW_SELECTED_PAGE_PROPERTY] = g_param_spec_object ("selected-page", "selected-page", "selected-page", TYPE_PAGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15 "../src/book-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), BOOK_VIEW_X_OFFSET_PROPERTY, book_view_properties[BOOK_VIEW_X_OFFSET_PROPERTY] = g_param_spec_int ("x-offset", "x-offset", "x-offset", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 15 "../src/book-view.vala"
	book_view_signals[BOOK_VIEW_PAGE_SELECTED_SIGNAL] = g_signal_new ("page-selected", TYPE_BOOK_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_PAGE);
#line 15 "../src/book-view.vala"
	book_view_signals[BOOK_VIEW_SHOW_PAGE_SIGNAL] = g_signal_new ("show-page", TYPE_BOOK_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_PAGE);
#line 15 "../src/book-view.vala"
	book_view_signals[BOOK_VIEW_SHOW_MENU_SIGNAL] = g_signal_new ("show-menu", TYPE_BOOK_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_DOUBLE_DOUBLE, G_TYPE_NONE, 3, gtk_widget_get_type (), G_TYPE_DOUBLE, G_TYPE_DOUBLE);
#line 3594 "book-view.c"
}

static void
book_view_instance_init (BookView * self,
                         gpointer klass)
{
#line 15 "../src/book-view.vala"
	self->priv = book_view_get_instance_private (self);
#line 27 "../src/book-view.vala"
	self->priv->selected_page_view = NULL;
#line 3605 "book-view.c"
}

static void
book_view_finalize (GObject * obj)
{
	BookView * self;
	Book* _tmp0_;
	guint _tmp1_;
	Book* _tmp2_;
	guint _tmp3_;
	Book* _tmp4_;
	guint _tmp5_;
	Book* _tmp6_;
	guint _tmp7_;
	GtkDrawingArea* _tmp8_;
	guint _tmp9_;
	GtkEventControllerMotion* _tmp10_;
	guint _tmp11_;
	GtkEventControllerKey* _tmp12_;
	guint _tmp13_;
	GtkGestureClick* _tmp14_;
	guint _tmp15_;
	GtkGestureClick* _tmp16_;
	guint _tmp17_;
	GtkGestureClick* _tmp18_;
	guint _tmp19_;
	GtkGestureClick* _tmp20_;
	guint _tmp21_;
	GtkEventControllerFocus* _tmp22_;
	guint _tmp23_;
	GtkEventControllerFocus* _tmp24_;
	guint _tmp25_;
	GtkAdjustment* _tmp26_;
	guint _tmp27_;
#line 15 "../src/book-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BOOK_VIEW, BookView);
#line 151 "../src/book-view.vala"
	_tmp0_ = self->priv->_book;
#line 151 "../src/book-view.vala"
	g_signal_parse_name ("page-added", TYPE_BOOK, &_tmp1_, NULL, FALSE);
#line 151 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _book_view_add_cb_book_page_added, self);
#line 152 "../src/book-view.vala"
	_tmp2_ = self->priv->_book;
#line 152 "../src/book-view.vala"
	g_signal_parse_name ("page-removed", TYPE_BOOK, &_tmp3_, NULL, FALSE);
#line 152 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _book_view_remove_cb_book_page_removed, self);
#line 153 "../src/book-view.vala"
	_tmp4_ = self->priv->_book;
#line 153 "../src/book-view.vala"
	g_signal_parse_name ("reordered", TYPE_BOOK, &_tmp5_, NULL, FALSE);
#line 153 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _book_view_reorder_cb_book_reordered, self);
#line 154 "../src/book-view.vala"
	_tmp6_ = self->priv->_book;
#line 154 "../src/book-view.vala"
	g_signal_parse_name ("cleared", TYPE_BOOK, &_tmp7_, NULL, FALSE);
#line 154 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _book_view_clear_cb_book_cleared, self);
#line 155 "../src/book-view.vala"
	_tmp8_ = self->priv->drawing_area;
#line 155 "../src/book-view.vala"
	g_signal_parse_name ("resize", gtk_drawing_area_get_type (), &_tmp9_, NULL, FALSE);
#line 155 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _book_view_drawing_area_resize_cb_gtk_drawing_area_resize, self);
#line 156 "../src/book-view.vala"
	_tmp10_ = self->priv->motion_controller;
#line 156 "../src/book-view.vala"
	g_signal_parse_name ("motion", gtk_event_controller_motion_get_type (), &_tmp11_, NULL, FALSE);
#line 156 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _book_view_motion_cb_gtk_event_controller_motion_motion, self);
#line 157 "../src/book-view.vala"
	_tmp12_ = self->priv->key_controller;
#line 157 "../src/book-view.vala"
	g_signal_parse_name ("key-pressed", gtk_event_controller_key_get_type (), &_tmp13_, NULL, FALSE);
#line 157 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp12_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp13_, 0, NULL, (GCallback) _book_view_key_cb_gtk_event_controller_key_key_pressed, self);
#line 158 "../src/book-view.vala"
	_tmp14_ = self->priv->primary_click_gesture;
#line 158 "../src/book-view.vala"
	g_signal_parse_name ("pressed", gtk_gesture_click_get_type (), &_tmp15_, NULL, FALSE);
#line 158 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp14_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp15_, 0, NULL, (GCallback) _book_view_primary_pressed_cb_gtk_gesture_click_pressed, self);
#line 159 "../src/book-view.vala"
	_tmp16_ = self->priv->primary_click_gesture;
#line 159 "../src/book-view.vala"
	g_signal_parse_name ("released", gtk_gesture_click_get_type (), &_tmp17_, NULL, FALSE);
#line 159 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp16_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp17_, 0, NULL, (GCallback) _book_view_primary_released_cb_gtk_gesture_click_released, self);
#line 160 "../src/book-view.vala"
	_tmp18_ = self->priv->secondary_click_gesture;
#line 160 "../src/book-view.vala"
	g_signal_parse_name ("pressed", gtk_gesture_click_get_type (), &_tmp19_, NULL, FALSE);
#line 160 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp18_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp19_, 0, NULL, (GCallback) _book_view_secondary_pressed_cb_gtk_gesture_click_pressed, self);
#line 161 "../src/book-view.vala"
	_tmp20_ = self->priv->secondary_click_gesture;
#line 161 "../src/book-view.vala"
	g_signal_parse_name ("released", gtk_gesture_click_get_type (), &_tmp21_, NULL, FALSE);
#line 161 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp20_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp21_, 0, NULL, (GCallback) _book_view_secondary_released_cb_gtk_gesture_click_released, self);
#line 162 "../src/book-view.vala"
	_tmp22_ = self->priv->focus_controller;
#line 162 "../src/book-view.vala"
	g_signal_parse_name ("enter", gtk_event_controller_focus_get_type (), &_tmp23_, NULL, FALSE);
#line 162 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp22_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp23_, 0, NULL, (GCallback) _book_view_focus_cb_gtk_event_controller_focus_enter, self);
#line 163 "../src/book-view.vala"
	_tmp24_ = self->priv->focus_controller;
#line 163 "../src/book-view.vala"
	g_signal_parse_name ("leave", gtk_event_controller_focus_get_type (), &_tmp25_, NULL, FALSE);
#line 163 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp24_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp25_, 0, NULL, (GCallback) _book_view_focus_cb_gtk_event_controller_focus_leave, self);
#line 164 "../src/book-view.vala"
	_tmp26_ = self->priv->adjustment;
#line 164 "../src/book-view.vala"
	g_signal_parse_name ("value-changed", gtk_adjustment_get_type (), &_tmp27_, NULL, FALSE);
#line 164 "../src/book-view.vala"
	g_signal_handlers_disconnect_matched (_tmp26_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp27_, 0, NULL, (GCallback) _book_view_scroll_cb_gtk_adjustment_value_changed, self);
#line 18 "../src/book-view.vala"
	_g_object_unref0 (self->priv->_book);
#line 19 "../src/book-view.vala"
	_g_hash_table_unref0 (self->priv->page_data);
#line 27 "../src/book-view.vala"
	_g_object_unref0 (self->priv->selected_page_view);
#line 50 "../src/book-view.vala"
	_g_object_unref0 (self->priv->drawing_area);
#line 53 "../src/book-view.vala"
	_g_object_unref0 (self->priv->scroll);
#line 54 "../src/book-view.vala"
	_g_object_unref0 (self->priv->adjustment);
#line 56 "../src/book-view.vala"
	_g_free0 (self->priv->cursor);
#line 58 "../src/book-view.vala"
	_g_object_unref0 (self->priv->motion_controller);
#line 59 "../src/book-view.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 60 "../src/book-view.vala"
	_g_object_unref0 (self->priv->primary_click_gesture);
#line 61 "../src/book-view.vala"
	_g_object_unref0 (self->priv->secondary_click_gesture);
#line 62 "../src/book-view.vala"
	_g_object_unref0 (self->priv->focus_controller);
#line 15 "../src/book-view.vala"
	G_OBJECT_CLASS (book_view_parent_class)->finalize (obj);
#line 3752 "book-view.c"
}

static GType
book_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BookViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) book_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BookView), 0, (GInstanceInitFunc) book_view_instance_init, NULL };
	GType book_view_type_id;
	book_view_type_id = g_type_register_static (gtk_box_get_type (), "BookView", &g_define_type_info, 0);
	BookView_private_offset = g_type_add_instance_private (book_view_type_id, sizeof (BookViewPrivate));
	return book_view_type_id;
}

GType
book_view_get_type (void)
{
	static volatile gsize book_view_type_id__once = 0;
	if (g_once_init_enter (&book_view_type_id__once)) {
		GType book_view_type_id;
		book_view_type_id = book_view_get_type_once ();
		g_once_init_leave (&book_view_type_id__once, book_view_type_id);
	}
	return book_view_type_id__once;
}

static void
_vala_book_view_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	BookView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BOOK_VIEW, BookView);
#line 15 "../src/book-view.vala"
	switch (property_id) {
#line 15 "../src/book-view.vala"
		case BOOK_VIEW_BOOK_PROPERTY:
#line 15 "../src/book-view.vala"
		g_value_set_object (value, book_view_get_book (self));
#line 15 "../src/book-view.vala"
		break;
#line 15 "../src/book-view.vala"
		case BOOK_VIEW_SELECTED_PAGE_PROPERTY:
#line 15 "../src/book-view.vala"
		g_value_set_object (value, book_view_get_selected_page (self));
#line 15 "../src/book-view.vala"
		break;
#line 15 "../src/book-view.vala"
		case BOOK_VIEW_X_OFFSET_PROPERTY:
#line 15 "../src/book-view.vala"
		g_value_set_int (value, book_view_get_x_offset (self));
#line 15 "../src/book-view.vala"
		break;
#line 3805 "book-view.c"
		default:
#line 15 "../src/book-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 15 "../src/book-view.vala"
		break;
#line 3811 "book-view.c"
	}
}

static void
_vala_book_view_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	BookView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BOOK_VIEW, BookView);
#line 15 "../src/book-view.vala"
	switch (property_id) {
#line 15 "../src/book-view.vala"
		case BOOK_VIEW_BOOK_PROPERTY:
#line 15 "../src/book-view.vala"
		book_view_set_book (self, g_value_get_object (value));
#line 15 "../src/book-view.vala"
		break;
#line 15 "../src/book-view.vala"
		case BOOK_VIEW_SELECTED_PAGE_PROPERTY:
#line 15 "../src/book-view.vala"
		book_view_set_selected_page (self, g_value_get_object (value));
#line 15 "../src/book-view.vala"
		break;
#line 15 "../src/book-view.vala"
		case BOOK_VIEW_X_OFFSET_PROPERTY:
#line 15 "../src/book-view.vala"
		book_view_set_x_offset (self, g_value_get_int (value));
#line 15 "../src/book-view.vala"
		break;
#line 3843 "book-view.c"
		default:
#line 15 "../src/book-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 15 "../src/book-view.vala"
		break;
#line 3849 "book-view.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

