/* page-view.c generated by valac 0.56.14, the Vala compiler
 * generated from page-view.vala, do not modify */

/*
 * Copyright (C) 2009-2015 Canonical Ltd.
 * Author: Robert Ancell <robert.ancell@canonical.com>
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <cairo-gobject.h>
#include <gdk/gdk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	CROP_LOCATION_NONE = 0,
	CROP_LOCATION_MIDDLE,
	CROP_LOCATION_TOP,
	CROP_LOCATION_BOTTOM,
	CROP_LOCATION_LEFT,
	CROP_LOCATION_RIGHT,
	CROP_LOCATION_TOP_LEFT,
	CROP_LOCATION_TOP_RIGHT,
	CROP_LOCATION_BOTTOM_LEFT,
	CROP_LOCATION_BOTTOM_RIGHT
} CropLocation;

#define TYPE_CROP_LOCATION (crop_location_get_type ())

#define TYPE_PAGE_VIEW (page_view_get_type ())
#define PAGE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_VIEW, PageView))
#define PAGE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_VIEW, PageViewClass))
#define IS_PAGE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_VIEW))
#define IS_PAGE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_VIEW))
#define PAGE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_VIEW, PageViewClass))

typedef struct _PageView PageView;
typedef struct _PageViewClass PageViewClass;
typedef struct _PageViewPrivate PageViewPrivate;

#define TYPE_PAGE (page_get_type ())
#define PAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE, Page))
#define PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE, PageClass))
#define IS_PAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE))
#define IS_PAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE))
#define PAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE, PageClass))

typedef struct _Page Page;
typedef struct _PageClass PageClass;

#define TYPE_PAGE_VIEW_TEXTURE (page_view_texture_get_type ())
#define PAGE_VIEW_TEXTURE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PAGE_VIEW_TEXTURE, PageViewTexture))
#define PAGE_VIEW_TEXTURE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PAGE_VIEW_TEXTURE, PageViewTextureClass))
#define IS_PAGE_VIEW_TEXTURE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PAGE_VIEW_TEXTURE))
#define IS_PAGE_VIEW_TEXTURE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PAGE_VIEW_TEXTURE))
#define PAGE_VIEW_TEXTURE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PAGE_VIEW_TEXTURE, PageViewTextureClass))

typedef struct _PageViewTexture PageViewTexture;
typedef struct _PageViewTextureClass PageViewTextureClass;
enum  {
	PAGE_VIEW_0_PROPERTY,
	PAGE_VIEW_PAGE_PROPERTY,
	PAGE_VIEW_SELECTED_PROPERTY,
	PAGE_VIEW_X_OFFSET_PROPERTY,
	PAGE_VIEW_Y_OFFSET_PROPERTY,
	PAGE_VIEW_CURSOR_PROPERTY,
	PAGE_VIEW_WIDTH_PROPERTY,
	PAGE_VIEW_HEIGHT_PROPERTY,
	PAGE_VIEW_NUM_PROPERTIES
};
static GParamSpec* page_view_properties[PAGE_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef enum  {
	SCAN_DIRECTION_TOP_TO_BOTTOM,
	SCAN_DIRECTION_LEFT_TO_RIGHT,
	SCAN_DIRECTION_BOTTOM_TO_TOP,
	SCAN_DIRECTION_RIGHT_TO_LEFT
} ScanDirection;

#define TYPE_SCAN_DIRECTION (scan_direction_get_type ())
enum  {
	PAGE_VIEW_SIZE_CHANGED_SIGNAL,
	PAGE_VIEW_CHANGED_SIGNAL,
	PAGE_VIEW_NUM_SIGNALS
};
static guint page_view_signals[PAGE_VIEW_NUM_SIGNALS] = {0};

struct _PageView {
	GObject parent_instance;
	PageViewPrivate * priv;
};

struct _PageViewClass {
	GObjectClass parent_class;
};

struct _PageViewPrivate {
	Page* _page;
	PageViewTexture* page_texture;
	gboolean selected_;
	gint ruler_width;
	gint border_width;
	gboolean update_image;
	gint width_;
	gint height_;
	gint _x_offset;
	gint _y_offset;
	CropLocation crop_location;
	gdouble selected_crop_px;
	gdouble selected_crop_py;
	gint selected_crop_x;
	gint selected_crop_y;
	gint selected_crop_w;
	gint selected_crop_h;
	gchar* _cursor;
	gint animate_n_segments;
	gint animate_segment;
	guint animate_timeout;
};

static gint PageView_private_offset;
static gpointer page_view_parent_class = NULL;

VALA_EXTERN GType crop_location_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType page_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PageView, g_object_unref)
VALA_EXTERN GType page_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Page, g_object_unref)
VALA_EXTERN GType page_view_texture_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PageViewTexture, g_object_unref)
VALA_EXTERN Page* page_view_get_page (PageView* self);
static void page_view_page_pixels_changed_cb (PageView* self,
                                       Page* p);
static void _page_view_page_pixels_changed_cb_page_pixels_changed (Page* _sender,
                                                            gpointer self);
static void page_view_page_size_changed_cb (PageView* self,
                                     Page* p);
static void _page_view_page_size_changed_cb_page_size_changed (Page* _sender,
                                                        gpointer self);
static void page_view_page_overlay_changed_cb (PageView* self,
                                        Page* p);
static void _page_view_page_overlay_changed_cb_page_crop_changed (Page* _sender,
                                                           gpointer self);
static void _page_view_page_overlay_changed_cb_page_scan_line_changed (Page* _sender,
                                                                gpointer self);
static void page_view_scan_direction_changed_cb (PageView* self,
                                          Page* p);
static void _page_view_scan_direction_changed_cb_page_scan_direction_changed (Page* _sender,
                                                                       gpointer self);
static void page_view_new_buffer_cb (PageView* self);
static void _page_view_new_buffer_cb_page_view_texture_new_buffer (PageViewTexture* _sender,
                                                            gpointer self);
VALA_EXTERN PageView* page_view_new (Page* page);
VALA_EXTERN PageView* page_view_construct (GType object_type,
                               Page* page);
static void page_view_set_page (PageView* self,
                         Page* value);
VALA_EXTERN PageViewTexture* page_view_texture_new (Page* page);
VALA_EXTERN PageViewTexture* page_view_texture_construct (GType object_type,
                                              Page* page);
static gint page_view_get_preview_width (PageView* self);
static gint page_view_get_preview_height (PageView* self);
static gint page_view_page_to_screen_x (PageView* self,
                                 gint x);
VALA_EXTERN gint page_get_width (Page* self);
static gint page_view_page_to_screen_y (PageView* self,
                                 gint y);
VALA_EXTERN gint page_get_height (Page* self);
static gint page_view_screen_to_page_x (PageView* self,
                                 gint x);
static gint page_view_screen_to_page_y (PageView* self,
                                 gint y);
static CropLocation page_view_get_crop_location (PageView* self,
                                          gint x,
                                          gint y);
VALA_EXTERN gboolean page_get_has_crop (Page* self);
VALA_EXTERN gint page_get_crop_x (Page* self);
VALA_EXTERN gint page_get_crop_y (Page* self);
VALA_EXTERN gint page_get_crop_width (Page* self);
VALA_EXTERN gint page_get_crop_height (Page* self);
VALA_EXTERN const gchar* page_get_crop_name (Page* self);
VALA_EXTERN void page_view_button_press (PageView* self,
                             gint x,
                             gint y);
VALA_EXTERN void page_view_motion (PageView* self,
                       gint x,
                       gint y);
static void page_view_set_cursor (PageView* self,
                           const gchar* value);
VALA_EXTERN void page_move_crop (Page* self,
                     gint x,
                     gint y);
VALA_EXTERN void page_set_custom_crop (Page* self,
                           gint width,
                           gint height);
VALA_EXTERN void page_view_button_release (PageView* self,
                               gint x,
                               gint y);
static gboolean page_view_animation_cb (PageView* self);
static void page_view_update_animation (PageView* self);
VALA_EXTERN gboolean page_get_is_scanning (Page* self);
VALA_EXTERN gboolean page_get_has_data (Page* self);
static gboolean _page_view_animation_cb_gsource_func (gpointer self);
VALA_EXTERN void page_view_render (PageView* self,
                       cairo_t* context,
                       GdkRGBA* ruler_color);
VALA_EXTERN void page_view_texture_request_resize (PageViewTexture* self,
                                       gint width,
                                       gint height);
VALA_EXTERN void page_view_texture_queue_update (PageViewTexture* self,
                                     GError** error);
VALA_EXTERN gint page_view_get_x_offset (PageView* self);
VALA_EXTERN gint page_view_get_y_offset (PageView* self);
VALA_EXTERN GdkPixbuf* page_view_texture_get_pixbuf (PageViewTexture* self);
VALA_EXTERN gint page_get_dpi (Page* self);
VALA_EXTERN gint page_get_scan_line (Page* self);
VALA_EXTERN GType scan_direction_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ScanDirection page_get_scan_direction (Page* self);
VALA_EXTERN void page_view_texture_request_update (PageViewTexture* self);
VALA_EXTERN gboolean page_view_get_selected (PageView* self);
VALA_EXTERN void page_view_set_selected (PageView* self,
                             gboolean value);
VALA_EXTERN void page_view_set_x_offset (PageView* self,
                             gint value);
VALA_EXTERN void page_view_set_y_offset (PageView* self,
                             gint value);
VALA_EXTERN const gchar* page_view_get_cursor (PageView* self);
VALA_EXTERN gint page_view_get_width (PageView* self);
VALA_EXTERN void page_view_set_width (PageView* self,
                          gint value);
VALA_EXTERN gint page_view_get_height (PageView* self);
VALA_EXTERN void page_view_set_height (PageView* self,
                           gint value);
static void page_view_finalize (GObject * obj);
static GType page_view_get_type_once (void);
static void _vala_page_view_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_page_view_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static GType
crop_location_get_type_once (void)
{
	static const GEnumValue values[] = {{CROP_LOCATION_NONE, "CROP_LOCATION_NONE", "none"}, {CROP_LOCATION_MIDDLE, "CROP_LOCATION_MIDDLE", "middle"}, {CROP_LOCATION_TOP, "CROP_LOCATION_TOP", "top"}, {CROP_LOCATION_BOTTOM, "CROP_LOCATION_BOTTOM", "bottom"}, {CROP_LOCATION_LEFT, "CROP_LOCATION_LEFT", "left"}, {CROP_LOCATION_RIGHT, "CROP_LOCATION_RIGHT", "right"}, {CROP_LOCATION_TOP_LEFT, "CROP_LOCATION_TOP_LEFT", "top-left"}, {CROP_LOCATION_TOP_RIGHT, "CROP_LOCATION_TOP_RIGHT", "top-right"}, {CROP_LOCATION_BOTTOM_LEFT, "CROP_LOCATION_BOTTOM_LEFT", "bottom-left"}, {CROP_LOCATION_BOTTOM_RIGHT, "CROP_LOCATION_BOTTOM_RIGHT", "bottom-right"}, {0, NULL, NULL}};
	GType crop_location_type_id;
	crop_location_type_id = g_enum_register_static ("CropLocation", values);
	return crop_location_type_id;
}

GType
crop_location_get_type (void)
{
	static volatile gsize crop_location_type_id__once = 0;
	if (g_once_init_enter (&crop_location_type_id__once)) {
		GType crop_location_type_id;
		crop_location_type_id = crop_location_get_type_once ();
		g_once_init_leave (&crop_location_type_id__once, crop_location_type_id);
	}
	return crop_location_type_id__once;
}

static inline gpointer
page_view_get_instance_private (PageView* self)
{
	return G_STRUCT_MEMBER_P (self, PageView_private_offset);
}

static void
_page_view_page_pixels_changed_cb_page_pixels_changed (Page* _sender,
                                                       gpointer self)
{
#line 96 "../src/page-view.vala"
	page_view_page_pixels_changed_cb ((PageView*) self, _sender);
#line 309 "page-view.c"
}

static void
_page_view_page_size_changed_cb_page_size_changed (Page* _sender,
                                                   gpointer self)
{
#line 97 "../src/page-view.vala"
	page_view_page_size_changed_cb ((PageView*) self, _sender);
#line 318 "page-view.c"
}

static void
_page_view_page_overlay_changed_cb_page_crop_changed (Page* _sender,
                                                      gpointer self)
{
#line 98 "../src/page-view.vala"
	page_view_page_overlay_changed_cb ((PageView*) self, _sender);
#line 327 "page-view.c"
}

static void
_page_view_page_overlay_changed_cb_page_scan_line_changed (Page* _sender,
                                                           gpointer self)
{
#line 99 "../src/page-view.vala"
	page_view_page_overlay_changed_cb ((PageView*) self, _sender);
#line 336 "page-view.c"
}

static void
_page_view_scan_direction_changed_cb_page_scan_direction_changed (Page* _sender,
                                                                  gpointer self)
{
#line 100 "../src/page-view.vala"
	page_view_scan_direction_changed_cb ((PageView*) self, _sender);
#line 345 "page-view.c"
}

static void
_page_view_new_buffer_cb_page_view_texture_new_buffer (PageViewTexture* _sender,
                                                       gpointer self)
{
#line 102 "../src/page-view.vala"
	page_view_new_buffer_cb ((PageView*) self);
#line 354 "page-view.c"
}

PageView*
page_view_construct (GType object_type,
                     Page* page)
{
	PageView * self = NULL;
	PageViewTexture* _tmp0_;
	PageViewTexture* _tmp1_;
#line 81 "../src/page-view.vala"
	g_return_val_if_fail (page != NULL, NULL);
#line 81 "../src/page-view.vala"
	self = (PageView*) g_object_new (object_type, NULL);
#line 83 "../src/page-view.vala"
	page_view_set_page (self, page);
#line 84 "../src/page-view.vala"
	g_signal_connect_object (page, "pixels-changed", (GCallback) _page_view_page_pixels_changed_cb_page_pixels_changed, self, 0);
#line 85 "../src/page-view.vala"
	g_signal_connect_object (page, "size-changed", (GCallback) _page_view_page_size_changed_cb_page_size_changed, self, 0);
#line 86 "../src/page-view.vala"
	g_signal_connect_object (page, "crop-changed", (GCallback) _page_view_page_overlay_changed_cb_page_crop_changed, self, 0);
#line 87 "../src/page-view.vala"
	g_signal_connect_object (page, "scan-line-changed", (GCallback) _page_view_page_overlay_changed_cb_page_scan_line_changed, self, 0);
#line 88 "../src/page-view.vala"
	g_signal_connect_object (page, "scan-direction-changed", (GCallback) _page_view_scan_direction_changed_cb_page_scan_direction_changed, self, 0);
#line 90 "../src/page-view.vala"
	_tmp0_ = page_view_texture_new (page);
#line 90 "../src/page-view.vala"
	_g_object_unref0 (self->priv->page_texture);
#line 90 "../src/page-view.vala"
	self->priv->page_texture = _tmp0_;
#line 91 "../src/page-view.vala"
	_tmp1_ = self->priv->page_texture;
#line 91 "../src/page-view.vala"
	g_signal_connect_object (_tmp1_, "new-buffer", (GCallback) _page_view_new_buffer_cb_page_view_texture_new_buffer, self, 0);
#line 81 "../src/page-view.vala"
	return self;
#line 392 "page-view.c"
}

PageView*
page_view_new (Page* page)
{
#line 81 "../src/page-view.vala"
	return page_view_construct (TYPE_PAGE_VIEW, page);
#line 400 "page-view.c"
}

static void
page_view_new_buffer_cb (PageView* self)
{
#line 105 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 107 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 410 "page-view.c"
}

static gint
page_view_get_preview_width (PageView* self)
{
	gint result;
#line 110 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 112 "../src/page-view.vala"
	result = self->priv->width_ - ((self->priv->border_width + self->priv->ruler_width) * 2);
#line 112 "../src/page-view.vala"
	return result;
#line 423 "page-view.c"
}

static gint
page_view_get_preview_height (PageView* self)
{
	gint result;
#line 115 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 117 "../src/page-view.vala"
	result = self->priv->height_ - ((self->priv->border_width + self->priv->ruler_width) * 2);
#line 117 "../src/page-view.vala"
	return result;
#line 436 "page-view.c"
}

static gint
page_view_page_to_screen_x (PageView* self,
                            gint x)
{
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint result;
#line 120 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 122 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 122 "../src/page-view.vala"
	_tmp1_ = page_get_width (_tmp0_);
#line 122 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 122 "../src/page-view.vala"
	result = (gint) (((((gdouble) x) * page_view_get_preview_width (self)) / _tmp2_) + 0.5);
#line 122 "../src/page-view.vala"
	return result;
#line 459 "page-view.c"
}

static gint
page_view_page_to_screen_y (PageView* self,
                            gint y)
{
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint result;
#line 125 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 127 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 127 "../src/page-view.vala"
	_tmp1_ = page_get_height (_tmp0_);
#line 127 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 127 "../src/page-view.vala"
	result = (gint) (((((gdouble) y) * page_view_get_preview_height (self)) / _tmp2_) + 0.5);
#line 127 "../src/page-view.vala"
	return result;
#line 482 "page-view.c"
}

static gint
page_view_screen_to_page_x (PageView* self,
                            gint x)
{
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint result;
#line 130 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 132 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 132 "../src/page-view.vala"
	_tmp1_ = page_get_width (_tmp0_);
#line 132 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 132 "../src/page-view.vala"
	result = (gint) (((((gdouble) x) * _tmp2_) / page_view_get_preview_width (self)) + 0.5);
#line 132 "../src/page-view.vala"
	return result;
#line 505 "page-view.c"
}

static gint
page_view_screen_to_page_y (PageView* self,
                            gint y)
{
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint result;
#line 135 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 137 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 137 "../src/page-view.vala"
	_tmp1_ = page_get_height (_tmp0_);
#line 137 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 137 "../src/page-view.vala"
	result = (gint) (((((gdouble) y) * _tmp2_) / page_view_get_preview_height (self)) + 0.5);
#line 137 "../src/page-view.vala"
	return result;
#line 528 "page-view.c"
}

static CropLocation
page_view_get_crop_location (PageView* self,
                             gint x,
                             gint y)
{
	Page* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gint cx = 0;
	Page* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint cy = 0;
	Page* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint cw = 0;
	Page* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint ch = 0;
	Page* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint dx = 0;
	gint dy = 0;
	gint dw = 0;
	gint dh = 0;
	gint ix = 0;
	gint iy = 0;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_ = FALSE;
	gchar* name = NULL;
	Page* _tmp18_;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	const gchar* _tmp22_;
	gint crop_border = 0;
	gboolean _tmp23_ = FALSE;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	CropLocation result;
#line 140 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 142 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 142 "../src/page-view.vala"
	_tmp1_ = page_get_has_crop (_tmp0_);
#line 142 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 142 "../src/page-view.vala"
	if (!_tmp2_) {
#line 143 "../src/page-view.vala"
		result = CROP_LOCATION_NONE;
#line 143 "../src/page-view.vala"
		return result;
#line 590 "page-view.c"
	}
#line 145 "../src/page-view.vala"
	_tmp3_ = self->priv->_page;
#line 145 "../src/page-view.vala"
	_tmp4_ = page_get_crop_x (_tmp3_);
#line 145 "../src/page-view.vala"
	_tmp5_ = _tmp4_;
#line 145 "../src/page-view.vala"
	cx = _tmp5_;
#line 146 "../src/page-view.vala"
	_tmp6_ = self->priv->_page;
#line 146 "../src/page-view.vala"
	_tmp7_ = page_get_crop_y (_tmp6_);
#line 146 "../src/page-view.vala"
	_tmp8_ = _tmp7_;
#line 146 "../src/page-view.vala"
	cy = _tmp8_;
#line 147 "../src/page-view.vala"
	_tmp9_ = self->priv->_page;
#line 147 "../src/page-view.vala"
	_tmp10_ = page_get_crop_width (_tmp9_);
#line 147 "../src/page-view.vala"
	_tmp11_ = _tmp10_;
#line 147 "../src/page-view.vala"
	cw = _tmp11_;
#line 148 "../src/page-view.vala"
	_tmp12_ = self->priv->_page;
#line 148 "../src/page-view.vala"
	_tmp13_ = page_get_crop_height (_tmp12_);
#line 148 "../src/page-view.vala"
	_tmp14_ = _tmp13_;
#line 148 "../src/page-view.vala"
	ch = _tmp14_;
#line 149 "../src/page-view.vala"
	dx = (page_view_page_to_screen_x (self, cx) + self->priv->border_width) + self->priv->ruler_width;
#line 150 "../src/page-view.vala"
	dy = (page_view_page_to_screen_y (self, cy) + self->priv->border_width) + self->priv->ruler_width;
#line 151 "../src/page-view.vala"
	dw = (page_view_page_to_screen_x (self, cw) + self->priv->border_width) + self->priv->ruler_width;
#line 152 "../src/page-view.vala"
	dh = (page_view_page_to_screen_y (self, ch) + self->priv->border_width) + self->priv->ruler_width;
#line 153 "../src/page-view.vala"
	ix = x - dx;
#line 154 "../src/page-view.vala"
	iy = y - dy;
#line 156 "../src/page-view.vala"
	if (ix < 0) {
#line 156 "../src/page-view.vala"
		_tmp17_ = TRUE;
#line 640 "page-view.c"
	} else {
#line 156 "../src/page-view.vala"
		_tmp17_ = ix > dw;
#line 644 "page-view.c"
	}
#line 156 "../src/page-view.vala"
	if (_tmp17_) {
#line 156 "../src/page-view.vala"
		_tmp16_ = TRUE;
#line 650 "page-view.c"
	} else {
#line 156 "../src/page-view.vala"
		_tmp16_ = iy < 0;
#line 654 "page-view.c"
	}
#line 156 "../src/page-view.vala"
	if (_tmp16_) {
#line 156 "../src/page-view.vala"
		_tmp15_ = TRUE;
#line 660 "page-view.c"
	} else {
#line 156 "../src/page-view.vala"
		_tmp15_ = iy > dh;
#line 664 "page-view.c"
	}
#line 156 "../src/page-view.vala"
	if (_tmp15_) {
#line 157 "../src/page-view.vala"
		result = CROP_LOCATION_NONE;
#line 157 "../src/page-view.vala"
		return result;
#line 672 "page-view.c"
	}
#line 160 "../src/page-view.vala"
	_tmp18_ = self->priv->_page;
#line 160 "../src/page-view.vala"
	_tmp19_ = page_get_crop_name (_tmp18_);
#line 160 "../src/page-view.vala"
	_tmp20_ = _tmp19_;
#line 160 "../src/page-view.vala"
	_tmp21_ = g_strdup (_tmp20_);
#line 160 "../src/page-view.vala"
	name = _tmp21_;
#line 161 "../src/page-view.vala"
	_tmp22_ = name;
#line 161 "../src/page-view.vala"
	if (_tmp22_ != NULL) {
#line 162 "../src/page-view.vala"
		result = CROP_LOCATION_MIDDLE;
#line 162 "../src/page-view.vala"
		_g_free0 (name);
#line 162 "../src/page-view.vala"
		return result;
#line 694 "page-view.c"
	}
#line 165 "../src/page-view.vala"
	crop_border = 20;
#line 166 "../src/page-view.vala"
	if (dw < (crop_border * 3)) {
#line 167 "../src/page-view.vala"
		crop_border = dw / 3;
#line 702 "page-view.c"
	}
#line 168 "../src/page-view.vala"
	if (dh < (crop_border * 3)) {
#line 169 "../src/page-view.vala"
		crop_border = dh / 3;
#line 708 "page-view.c"
	}
#line 172 "../src/page-view.vala"
	if (ix < crop_border) {
#line 172 "../src/page-view.vala"
		_tmp23_ = iy < crop_border;
#line 714 "page-view.c"
	} else {
#line 172 "../src/page-view.vala"
		_tmp23_ = FALSE;
#line 718 "page-view.c"
	}
#line 172 "../src/page-view.vala"
	if (_tmp23_) {
#line 173 "../src/page-view.vala"
		result = CROP_LOCATION_TOP_LEFT;
#line 173 "../src/page-view.vala"
		_g_free0 (name);
#line 173 "../src/page-view.vala"
		return result;
#line 728 "page-view.c"
	}
#line 175 "../src/page-view.vala"
	if (ix > (dw - crop_border)) {
#line 175 "../src/page-view.vala"
		_tmp24_ = iy < crop_border;
#line 734 "page-view.c"
	} else {
#line 175 "../src/page-view.vala"
		_tmp24_ = FALSE;
#line 738 "page-view.c"
	}
#line 175 "../src/page-view.vala"
	if (_tmp24_) {
#line 176 "../src/page-view.vala"
		result = CROP_LOCATION_TOP_RIGHT;
#line 176 "../src/page-view.vala"
		_g_free0 (name);
#line 176 "../src/page-view.vala"
		return result;
#line 748 "page-view.c"
	}
#line 178 "../src/page-view.vala"
	if (ix < crop_border) {
#line 178 "../src/page-view.vala"
		_tmp25_ = iy > (dh - crop_border);
#line 754 "page-view.c"
	} else {
#line 178 "../src/page-view.vala"
		_tmp25_ = FALSE;
#line 758 "page-view.c"
	}
#line 178 "../src/page-view.vala"
	if (_tmp25_) {
#line 179 "../src/page-view.vala"
		result = CROP_LOCATION_BOTTOM_LEFT;
#line 179 "../src/page-view.vala"
		_g_free0 (name);
#line 179 "../src/page-view.vala"
		return result;
#line 768 "page-view.c"
	}
#line 181 "../src/page-view.vala"
	if (ix > (dw - crop_border)) {
#line 181 "../src/page-view.vala"
		_tmp26_ = iy > (dh - crop_border);
#line 774 "page-view.c"
	} else {
#line 181 "../src/page-view.vala"
		_tmp26_ = FALSE;
#line 778 "page-view.c"
	}
#line 181 "../src/page-view.vala"
	if (_tmp26_) {
#line 182 "../src/page-view.vala"
		result = CROP_LOCATION_BOTTOM_RIGHT;
#line 182 "../src/page-view.vala"
		_g_free0 (name);
#line 182 "../src/page-view.vala"
		return result;
#line 788 "page-view.c"
	}
#line 185 "../src/page-view.vala"
	if (ix < crop_border) {
#line 186 "../src/page-view.vala"
		result = CROP_LOCATION_LEFT;
#line 186 "../src/page-view.vala"
		_g_free0 (name);
#line 186 "../src/page-view.vala"
		return result;
#line 798 "page-view.c"
	}
#line 188 "../src/page-view.vala"
	if (ix > (dw - crop_border)) {
#line 189 "../src/page-view.vala"
		result = CROP_LOCATION_RIGHT;
#line 189 "../src/page-view.vala"
		_g_free0 (name);
#line 189 "../src/page-view.vala"
		return result;
#line 808 "page-view.c"
	}
#line 191 "../src/page-view.vala"
	if (iy < crop_border) {
#line 192 "../src/page-view.vala"
		result = CROP_LOCATION_TOP;
#line 192 "../src/page-view.vala"
		_g_free0 (name);
#line 192 "../src/page-view.vala"
		return result;
#line 818 "page-view.c"
	}
#line 194 "../src/page-view.vala"
	if (iy > (dh - crop_border)) {
#line 195 "../src/page-view.vala"
		result = CROP_LOCATION_BOTTOM;
#line 195 "../src/page-view.vala"
		_g_free0 (name);
#line 195 "../src/page-view.vala"
		return result;
#line 828 "page-view.c"
	}
#line 198 "../src/page-view.vala"
	result = CROP_LOCATION_MIDDLE;
#line 198 "../src/page-view.vala"
	_g_free0 (name);
#line 198 "../src/page-view.vala"
	return result;
#line 836 "page-view.c"
}

void
page_view_button_press (PageView* self,
                        gint x,
                        gint y)
{
	CropLocation location = 0;
#line 201 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 204 "../src/page-view.vala"
	location = page_view_get_crop_location (self, x, y);
#line 205 "../src/page-view.vala"
	if (location != CROP_LOCATION_NONE) {
#line 851 "page-view.c"
		Page* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		Page* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		Page* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		Page* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
#line 207 "../src/page-view.vala"
		self->priv->crop_location = location;
#line 208 "../src/page-view.vala"
		self->priv->selected_crop_px = (gdouble) x;
#line 209 "../src/page-view.vala"
		self->priv->selected_crop_py = (gdouble) y;
#line 210 "../src/page-view.vala"
		_tmp0_ = self->priv->_page;
#line 210 "../src/page-view.vala"
		_tmp1_ = page_get_crop_x (_tmp0_);
#line 210 "../src/page-view.vala"
		_tmp2_ = _tmp1_;
#line 210 "../src/page-view.vala"
		self->priv->selected_crop_x = _tmp2_;
#line 211 "../src/page-view.vala"
		_tmp3_ = self->priv->_page;
#line 211 "../src/page-view.vala"
		_tmp4_ = page_get_crop_y (_tmp3_);
#line 211 "../src/page-view.vala"
		_tmp5_ = _tmp4_;
#line 211 "../src/page-view.vala"
		self->priv->selected_crop_y = _tmp5_;
#line 212 "../src/page-view.vala"
		_tmp6_ = self->priv->_page;
#line 212 "../src/page-view.vala"
		_tmp7_ = page_get_crop_width (_tmp6_);
#line 212 "../src/page-view.vala"
		_tmp8_ = _tmp7_;
#line 212 "../src/page-view.vala"
		self->priv->selected_crop_w = _tmp8_;
#line 213 "../src/page-view.vala"
		_tmp9_ = self->priv->_page;
#line 213 "../src/page-view.vala"
		_tmp10_ = page_get_crop_height (_tmp9_);
#line 213 "../src/page-view.vala"
		_tmp11_ = _tmp10_;
#line 213 "../src/page-view.vala"
		self->priv->selected_crop_h = _tmp11_;
#line 902 "page-view.c"
	}
}

void
page_view_motion (PageView* self,
                  gint x,
                  gint y)
{
	CropLocation location = 0;
	gchar* cursor = NULL;
	gint pw = 0;
	Page* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gint ph = 0;
	Page* _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gint cw = 0;
	Page* _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	gint ch = 0;
	Page* _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	gint dx = 0;
	gint dy = 0;
	gint new_x = 0;
	gint new_y = 0;
	gint new_w = 0;
	gint new_h = 0;
	gint min_size = 0;
	gboolean _tmp23_ = FALSE;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp27_ = FALSE;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp29_ = FALSE;
	gboolean _tmp30_ = FALSE;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_ = FALSE;
	gboolean _tmp33_ = FALSE;
	gboolean _tmp34_ = FALSE;
	gboolean _tmp35_ = FALSE;
	gboolean _tmp36_ = FALSE;
	gboolean _tmp37_ = FALSE;
	gboolean _tmp38_ = FALSE;
	Page* _tmp39_;
	gboolean _tmp40_ = FALSE;
#line 217 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 219 "../src/page-view.vala"
	location = page_view_get_crop_location (self, x, y);
#line 222 "../src/page-view.vala"
	switch (location) {
#line 222 "../src/page-view.vala"
		case CROP_LOCATION_MIDDLE:
#line 962 "page-view.c"
		{
			gchar* _tmp0_;
#line 225 "../src/page-view.vala"
			_tmp0_ = g_strdup ("hand1");
#line 225 "../src/page-view.vala"
			_g_free0 (cursor);
#line 225 "../src/page-view.vala"
			cursor = _tmp0_;
#line 226 "../src/page-view.vala"
			break;
#line 973 "page-view.c"
		}
#line 222 "../src/page-view.vala"
		case CROP_LOCATION_TOP:
#line 977 "page-view.c"
		{
			gchar* _tmp1_;
#line 228 "../src/page-view.vala"
			_tmp1_ = g_strdup ("top_side");
#line 228 "../src/page-view.vala"
			_g_free0 (cursor);
#line 228 "../src/page-view.vala"
			cursor = _tmp1_;
#line 229 "../src/page-view.vala"
			break;
#line 988 "page-view.c"
		}
#line 222 "../src/page-view.vala"
		case CROP_LOCATION_BOTTOM:
#line 992 "page-view.c"
		{
			gchar* _tmp2_;
#line 231 "../src/page-view.vala"
			_tmp2_ = g_strdup ("bottom_side");
#line 231 "../src/page-view.vala"
			_g_free0 (cursor);
#line 231 "../src/page-view.vala"
			cursor = _tmp2_;
#line 232 "../src/page-view.vala"
			break;
#line 1003 "page-view.c"
		}
#line 222 "../src/page-view.vala"
		case CROP_LOCATION_LEFT:
#line 1007 "page-view.c"
		{
			gchar* _tmp3_;
#line 234 "../src/page-view.vala"
			_tmp3_ = g_strdup ("left_side");
#line 234 "../src/page-view.vala"
			_g_free0 (cursor);
#line 234 "../src/page-view.vala"
			cursor = _tmp3_;
#line 235 "../src/page-view.vala"
			break;
#line 1018 "page-view.c"
		}
#line 222 "../src/page-view.vala"
		case CROP_LOCATION_RIGHT:
#line 1022 "page-view.c"
		{
			gchar* _tmp4_;
#line 237 "../src/page-view.vala"
			_tmp4_ = g_strdup ("right_side");
#line 237 "../src/page-view.vala"
			_g_free0 (cursor);
#line 237 "../src/page-view.vala"
			cursor = _tmp4_;
#line 238 "../src/page-view.vala"
			break;
#line 1033 "page-view.c"
		}
#line 222 "../src/page-view.vala"
		case CROP_LOCATION_TOP_LEFT:
#line 1037 "page-view.c"
		{
			gchar* _tmp5_;
#line 240 "../src/page-view.vala"
			_tmp5_ = g_strdup ("top_left_corner");
#line 240 "../src/page-view.vala"
			_g_free0 (cursor);
#line 240 "../src/page-view.vala"
			cursor = _tmp5_;
#line 241 "../src/page-view.vala"
			break;
#line 1048 "page-view.c"
		}
#line 222 "../src/page-view.vala"
		case CROP_LOCATION_TOP_RIGHT:
#line 1052 "page-view.c"
		{
			gchar* _tmp6_;
#line 243 "../src/page-view.vala"
			_tmp6_ = g_strdup ("top_right_corner");
#line 243 "../src/page-view.vala"
			_g_free0 (cursor);
#line 243 "../src/page-view.vala"
			cursor = _tmp6_;
#line 244 "../src/page-view.vala"
			break;
#line 1063 "page-view.c"
		}
#line 222 "../src/page-view.vala"
		case CROP_LOCATION_BOTTOM_LEFT:
#line 1067 "page-view.c"
		{
			gchar* _tmp7_;
#line 246 "../src/page-view.vala"
			_tmp7_ = g_strdup ("bottom_left_corner");
#line 246 "../src/page-view.vala"
			_g_free0 (cursor);
#line 246 "../src/page-view.vala"
			cursor = _tmp7_;
#line 247 "../src/page-view.vala"
			break;
#line 1078 "page-view.c"
		}
#line 222 "../src/page-view.vala"
		case CROP_LOCATION_BOTTOM_RIGHT:
#line 1082 "page-view.c"
		{
			gchar* _tmp8_;
#line 249 "../src/page-view.vala"
			_tmp8_ = g_strdup ("bottom_right_corner");
#line 249 "../src/page-view.vala"
			_g_free0 (cursor);
#line 249 "../src/page-view.vala"
			cursor = _tmp8_;
#line 250 "../src/page-view.vala"
			break;
#line 1093 "page-view.c"
		}
		default:
		{
			gchar* _tmp9_;
#line 252 "../src/page-view.vala"
			_tmp9_ = g_strdup ("arrow");
#line 252 "../src/page-view.vala"
			_g_free0 (cursor);
#line 252 "../src/page-view.vala"
			cursor = _tmp9_;
#line 253 "../src/page-view.vala"
			break;
#line 1106 "page-view.c"
		}
	}
#line 256 "../src/page-view.vala"
	if (self->priv->crop_location == CROP_LOCATION_NONE) {
#line 1111 "page-view.c"
		const gchar* _tmp10_;
#line 258 "../src/page-view.vala"
		_tmp10_ = cursor;
#line 258 "../src/page-view.vala"
		page_view_set_cursor (self, _tmp10_);
#line 259 "../src/page-view.vala"
		_g_free0 (cursor);
#line 259 "../src/page-view.vala"
		return;
#line 1121 "page-view.c"
	}
#line 263 "../src/page-view.vala"
	_tmp11_ = self->priv->_page;
#line 263 "../src/page-view.vala"
	_tmp12_ = page_get_width (_tmp11_);
#line 263 "../src/page-view.vala"
	_tmp13_ = _tmp12_;
#line 263 "../src/page-view.vala"
	pw = _tmp13_;
#line 264 "../src/page-view.vala"
	_tmp14_ = self->priv->_page;
#line 264 "../src/page-view.vala"
	_tmp15_ = page_get_height (_tmp14_);
#line 264 "../src/page-view.vala"
	_tmp16_ = _tmp15_;
#line 264 "../src/page-view.vala"
	ph = _tmp16_;
#line 265 "../src/page-view.vala"
	_tmp17_ = self->priv->_page;
#line 265 "../src/page-view.vala"
	_tmp18_ = page_get_crop_width (_tmp17_);
#line 265 "../src/page-view.vala"
	_tmp19_ = _tmp18_;
#line 265 "../src/page-view.vala"
	cw = _tmp19_;
#line 266 "../src/page-view.vala"
	_tmp20_ = self->priv->_page;
#line 266 "../src/page-view.vala"
	_tmp21_ = page_get_crop_height (_tmp20_);
#line 266 "../src/page-view.vala"
	_tmp22_ = _tmp21_;
#line 266 "../src/page-view.vala"
	ch = _tmp22_;
#line 268 "../src/page-view.vala"
	dx = page_view_screen_to_page_x (self, x - ((gint) self->priv->selected_crop_px));
#line 269 "../src/page-view.vala"
	dy = page_view_screen_to_page_y (self, y - ((gint) self->priv->selected_crop_py));
#line 271 "../src/page-view.vala"
	new_x = self->priv->selected_crop_x;
#line 272 "../src/page-view.vala"
	new_y = self->priv->selected_crop_y;
#line 273 "../src/page-view.vala"
	new_w = self->priv->selected_crop_w;
#line 274 "../src/page-view.vala"
	new_h = self->priv->selected_crop_h;
#line 277 "../src/page-view.vala"
	min_size = page_view_screen_to_page_x (self, 15);
#line 278 "../src/page-view.vala"
	if (self->priv->crop_location == CROP_LOCATION_TOP_LEFT) {
#line 278 "../src/page-view.vala"
		_tmp24_ = TRUE;
#line 1173 "page-view.c"
	} else {
#line 279 "../src/page-view.vala"
		_tmp24_ = self->priv->crop_location == CROP_LOCATION_LEFT;
#line 1177 "page-view.c"
	}
#line 278 "../src/page-view.vala"
	if (_tmp24_) {
#line 278 "../src/page-view.vala"
		_tmp23_ = TRUE;
#line 1183 "page-view.c"
	} else {
#line 280 "../src/page-view.vala"
		_tmp23_ = self->priv->crop_location == CROP_LOCATION_BOTTOM_LEFT;
#line 1187 "page-view.c"
	}
#line 278 "../src/page-view.vala"
	if (_tmp23_) {
#line 282 "../src/page-view.vala"
		if (dx > (new_w - min_size)) {
#line 283 "../src/page-view.vala"
			dx = new_w - min_size;
#line 1195 "page-view.c"
		}
#line 284 "../src/page-view.vala"
		if ((new_x + dx) < 0) {
#line 285 "../src/page-view.vala"
			dx = -new_x;
#line 1201 "page-view.c"
		}
	}
#line 287 "../src/page-view.vala"
	if (self->priv->crop_location == CROP_LOCATION_TOP_LEFT) {
#line 287 "../src/page-view.vala"
		_tmp26_ = TRUE;
#line 1208 "page-view.c"
	} else {
#line 288 "../src/page-view.vala"
		_tmp26_ = self->priv->crop_location == CROP_LOCATION_TOP;
#line 1212 "page-view.c"
	}
#line 287 "../src/page-view.vala"
	if (_tmp26_) {
#line 287 "../src/page-view.vala"
		_tmp25_ = TRUE;
#line 1218 "page-view.c"
	} else {
#line 289 "../src/page-view.vala"
		_tmp25_ = self->priv->crop_location == CROP_LOCATION_TOP_RIGHT;
#line 1222 "page-view.c"
	}
#line 287 "../src/page-view.vala"
	if (_tmp25_) {
#line 291 "../src/page-view.vala"
		if (dy > (new_h - min_size)) {
#line 292 "../src/page-view.vala"
			dy = new_h - min_size;
#line 1230 "page-view.c"
		}
#line 293 "../src/page-view.vala"
		if ((new_y + dy) < 0) {
#line 294 "../src/page-view.vala"
			dy = -new_y;
#line 1236 "page-view.c"
		}
	}
#line 297 "../src/page-view.vala"
	if (self->priv->crop_location == CROP_LOCATION_TOP_RIGHT) {
#line 297 "../src/page-view.vala"
		_tmp28_ = TRUE;
#line 1243 "page-view.c"
	} else {
#line 298 "../src/page-view.vala"
		_tmp28_ = self->priv->crop_location == CROP_LOCATION_RIGHT;
#line 1247 "page-view.c"
	}
#line 297 "../src/page-view.vala"
	if (_tmp28_) {
#line 297 "../src/page-view.vala"
		_tmp27_ = TRUE;
#line 1253 "page-view.c"
	} else {
#line 299 "../src/page-view.vala"
		_tmp27_ = self->priv->crop_location == CROP_LOCATION_BOTTOM_RIGHT;
#line 1257 "page-view.c"
	}
#line 297 "../src/page-view.vala"
	if (_tmp27_) {
#line 301 "../src/page-view.vala"
		if (dx < (min_size - new_w)) {
#line 302 "../src/page-view.vala"
			dx = min_size - new_w;
#line 1265 "page-view.c"
		}
#line 303 "../src/page-view.vala"
		if (((new_x + new_w) + dx) > pw) {
#line 304 "../src/page-view.vala"
			dx = (pw - new_x) - new_w;
#line 1271 "page-view.c"
		}
	}
#line 306 "../src/page-view.vala"
	if (self->priv->crop_location == CROP_LOCATION_BOTTOM_LEFT) {
#line 306 "../src/page-view.vala"
		_tmp30_ = TRUE;
#line 1278 "page-view.c"
	} else {
#line 307 "../src/page-view.vala"
		_tmp30_ = self->priv->crop_location == CROP_LOCATION_BOTTOM;
#line 1282 "page-view.c"
	}
#line 306 "../src/page-view.vala"
	if (_tmp30_) {
#line 306 "../src/page-view.vala"
		_tmp29_ = TRUE;
#line 1288 "page-view.c"
	} else {
#line 308 "../src/page-view.vala"
		_tmp29_ = self->priv->crop_location == CROP_LOCATION_BOTTOM_RIGHT;
#line 1292 "page-view.c"
	}
#line 306 "../src/page-view.vala"
	if (_tmp29_) {
#line 310 "../src/page-view.vala"
		if (dy < (min_size - new_h)) {
#line 311 "../src/page-view.vala"
			dy = min_size - new_h;
#line 1300 "page-view.c"
		}
#line 312 "../src/page-view.vala"
		if (((new_y + new_h) + dy) > ph) {
#line 313 "../src/page-view.vala"
			dy = (ph - new_y) - new_h;
#line 1306 "page-view.c"
		}
	}
#line 315 "../src/page-view.vala"
	if (self->priv->crop_location == CROP_LOCATION_MIDDLE) {
#line 317 "../src/page-view.vala"
		if (((new_x + dx) + new_w) > pw) {
#line 318 "../src/page-view.vala"
			dx = (pw - new_x) - new_w;
#line 1315 "page-view.c"
		}
#line 319 "../src/page-view.vala"
		if ((new_x + dx) < 0) {
#line 320 "../src/page-view.vala"
			dx = -new_x;
#line 1321 "page-view.c"
		}
#line 321 "../src/page-view.vala"
		if (((new_y + dy) + new_h) > ph) {
#line 322 "../src/page-view.vala"
			dy = (ph - new_y) - new_h;
#line 1327 "page-view.c"
		}
#line 323 "../src/page-view.vala"
		if ((new_y + dy) < 0) {
#line 324 "../src/page-view.vala"
			dy = -new_y;
#line 1333 "page-view.c"
		}
	}
#line 328 "../src/page-view.vala"
	if (self->priv->crop_location == CROP_LOCATION_MIDDLE) {
#line 330 "../src/page-view.vala"
		new_x += dx;
#line 331 "../src/page-view.vala"
		new_y += dy;
#line 1342 "page-view.c"
	}
#line 333 "../src/page-view.vala"
	if (self->priv->crop_location == CROP_LOCATION_TOP_LEFT) {
#line 333 "../src/page-view.vala"
		_tmp32_ = TRUE;
#line 1348 "page-view.c"
	} else {
#line 334 "../src/page-view.vala"
		_tmp32_ = self->priv->crop_location == CROP_LOCATION_LEFT;
#line 1352 "page-view.c"
	}
#line 333 "../src/page-view.vala"
	if (_tmp32_) {
#line 333 "../src/page-view.vala"
		_tmp31_ = TRUE;
#line 1358 "page-view.c"
	} else {
#line 335 "../src/page-view.vala"
		_tmp31_ = self->priv->crop_location == CROP_LOCATION_BOTTOM_LEFT;
#line 1362 "page-view.c"
	}
#line 333 "../src/page-view.vala"
	if (_tmp31_) {
#line 337 "../src/page-view.vala"
		new_x += dx;
#line 338 "../src/page-view.vala"
		new_w -= dx;
#line 1370 "page-view.c"
	}
#line 340 "../src/page-view.vala"
	if (self->priv->crop_location == CROP_LOCATION_TOP_LEFT) {
#line 340 "../src/page-view.vala"
		_tmp34_ = TRUE;
#line 1376 "page-view.c"
	} else {
#line 341 "../src/page-view.vala"
		_tmp34_ = self->priv->crop_location == CROP_LOCATION_TOP;
#line 1380 "page-view.c"
	}
#line 340 "../src/page-view.vala"
	if (_tmp34_) {
#line 340 "../src/page-view.vala"
		_tmp33_ = TRUE;
#line 1386 "page-view.c"
	} else {
#line 342 "../src/page-view.vala"
		_tmp33_ = self->priv->crop_location == CROP_LOCATION_TOP_RIGHT;
#line 1390 "page-view.c"
	}
#line 340 "../src/page-view.vala"
	if (_tmp33_) {
#line 344 "../src/page-view.vala"
		new_y += dy;
#line 345 "../src/page-view.vala"
		new_h -= dy;
#line 1398 "page-view.c"
	}
#line 348 "../src/page-view.vala"
	if (self->priv->crop_location == CROP_LOCATION_TOP_RIGHT) {
#line 348 "../src/page-view.vala"
		_tmp36_ = TRUE;
#line 1404 "page-view.c"
	} else {
#line 349 "../src/page-view.vala"
		_tmp36_ = self->priv->crop_location == CROP_LOCATION_RIGHT;
#line 1408 "page-view.c"
	}
#line 348 "../src/page-view.vala"
	if (_tmp36_) {
#line 348 "../src/page-view.vala"
		_tmp35_ = TRUE;
#line 1414 "page-view.c"
	} else {
#line 350 "../src/page-view.vala"
		_tmp35_ = self->priv->crop_location == CROP_LOCATION_BOTTOM_RIGHT;
#line 1418 "page-view.c"
	}
#line 348 "../src/page-view.vala"
	if (_tmp35_) {
#line 351 "../src/page-view.vala"
		new_w += dx;
#line 1424 "page-view.c"
	}
#line 352 "../src/page-view.vala"
	if (self->priv->crop_location == CROP_LOCATION_BOTTOM_LEFT) {
#line 352 "../src/page-view.vala"
		_tmp38_ = TRUE;
#line 1430 "page-view.c"
	} else {
#line 353 "../src/page-view.vala"
		_tmp38_ = self->priv->crop_location == CROP_LOCATION_BOTTOM;
#line 1434 "page-view.c"
	}
#line 352 "../src/page-view.vala"
	if (_tmp38_) {
#line 352 "../src/page-view.vala"
		_tmp37_ = TRUE;
#line 1440 "page-view.c"
	} else {
#line 354 "../src/page-view.vala"
		_tmp37_ = self->priv->crop_location == CROP_LOCATION_BOTTOM_RIGHT;
#line 1444 "page-view.c"
	}
#line 352 "../src/page-view.vala"
	if (_tmp37_) {
#line 355 "../src/page-view.vala"
		new_h += dy;
#line 1450 "page-view.c"
	}
#line 357 "../src/page-view.vala"
	_tmp39_ = self->priv->_page;
#line 357 "../src/page-view.vala"
	page_move_crop (_tmp39_, new_x, new_y);
#line 360 "../src/page-view.vala"
	if (new_w != cw) {
#line 360 "../src/page-view.vala"
		_tmp40_ = TRUE;
#line 1460 "page-view.c"
	} else {
#line 360 "../src/page-view.vala"
		_tmp40_ = new_h != ch;
#line 1464 "page-view.c"
	}
#line 360 "../src/page-view.vala"
	if (_tmp40_) {
#line 1468 "page-view.c"
		Page* _tmp41_;
#line 361 "../src/page-view.vala"
		_tmp41_ = self->priv->_page;
#line 361 "../src/page-view.vala"
		page_set_custom_crop (_tmp41_, new_w, new_h);
#line 1474 "page-view.c"
	}
#line 217 "../src/page-view.vala"
	_g_free0 (cursor);
#line 1478 "page-view.c"
}

void
page_view_button_release (PageView* self,
                          gint x,
                          gint y)
{
#line 364 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 367 "../src/page-view.vala"
	self->priv->crop_location = CROP_LOCATION_NONE;
#line 368 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 1492 "page-view.c"
}

static gboolean
page_view_animation_cb (PageView* self)
{
	gboolean result;
#line 371 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 373 "../src/page-view.vala"
	self->priv->animate_segment = (self->priv->animate_segment + 1) % self->priv->animate_n_segments;
#line 374 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 375 "../src/page-view.vala"
	result = TRUE;
#line 375 "../src/page-view.vala"
	return result;
#line 1509 "page-view.c"
}

static gboolean
_page_view_animation_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = page_view_animation_cb ((PageView*) self);
#line 391 "../src/page-view.vala"
	return result;
#line 1519 "page-view.c"
}

static void
page_view_update_animation (PageView* self)
{
	gboolean animate = FALSE;
	gboolean is_animating = FALSE;
	gboolean _tmp0_ = FALSE;
	Page* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 378 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 382 "../src/page-view.vala"
	_tmp1_ = self->priv->_page;
#line 382 "../src/page-view.vala"
	_tmp2_ = page_get_is_scanning (_tmp1_);
#line 382 "../src/page-view.vala"
	_tmp3_ = _tmp2_;
#line 382 "../src/page-view.vala"
	if (_tmp3_) {
#line 1541 "page-view.c"
		Page* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 382 "../src/page-view.vala"
		_tmp4_ = self->priv->_page;
#line 382 "../src/page-view.vala"
		_tmp5_ = page_get_has_data (_tmp4_);
#line 382 "../src/page-view.vala"
		_tmp6_ = _tmp5_;
#line 382 "../src/page-view.vala"
		_tmp0_ = !_tmp6_;
#line 1553 "page-view.c"
	} else {
#line 382 "../src/page-view.vala"
		_tmp0_ = FALSE;
#line 1557 "page-view.c"
	}
#line 382 "../src/page-view.vala"
	animate = _tmp0_;
#line 383 "../src/page-view.vala"
	is_animating = self->priv->animate_timeout != ((guint) 0);
#line 384 "../src/page-view.vala"
	if (animate == is_animating) {
#line 385 "../src/page-view.vala"
		return;
#line 1567 "page-view.c"
	}
#line 387 "../src/page-view.vala"
	if (animate) {
#line 389 "../src/page-view.vala"
		self->priv->animate_segment = 0;
#line 390 "../src/page-view.vala"
		if (self->priv->animate_timeout == ((guint) 0)) {
#line 391 "../src/page-view.vala"
			self->priv->animate_timeout = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 150, _page_view_animation_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 1577 "page-view.c"
		}
	} else {
#line 395 "../src/page-view.vala"
		if (self->priv->animate_timeout != ((guint) 0)) {
#line 396 "../src/page-view.vala"
			g_source_remove (self->priv->animate_timeout);
#line 1584 "page-view.c"
		}
#line 397 "../src/page-view.vala"
		self->priv->animate_timeout = (guint) 0;
#line 1588 "page-view.c"
	}
}

void
page_view_render (PageView* self,
                  cairo_t* context,
                  GdkRGBA* ruler_color)
{
	PageViewTexture* _tmp0_;
	gint w = 0;
	gint h = 0;
	gint _tmp4_;
	gint _tmp5_;
	PageViewTexture* _tmp6_;
	GdkPixbuf* _tmp7_;
	GdkPixbuf* _tmp8_;
	GdkRGBA _tmp23_;
	gint ruler_tick = 0;
	gdouble line = 0.0;
	gint big_ruler_tick = 0;
	gboolean _tmp36_ = FALSE;
	Page* _tmp37_;
	gboolean _tmp38_;
	gboolean _tmp39_;
	Page* _tmp49_;
	gboolean _tmp50_;
	gboolean _tmp51_;
	GError* _inner_error0_ = NULL;
#line 404 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 404 "../src/page-view.vala"
	g_return_if_fail (context != NULL);
#line 404 "../src/page-view.vala"
	g_return_if_fail (ruler_color != NULL);
#line 406 "../src/page-view.vala"
	page_view_update_animation (self);
#line 408 "../src/page-view.vala"
	_tmp0_ = self->priv->page_texture;
#line 408 "../src/page-view.vala"
	page_view_texture_request_resize (_tmp0_, page_view_get_preview_width (self), page_view_get_preview_height (self));
#line 1629 "page-view.c"
	{
		PageViewTexture* _tmp1_;
#line 411 "../src/page-view.vala"
		_tmp1_ = self->priv->page_texture;
#line 411 "../src/page-view.vala"
		page_view_texture_queue_update (_tmp1_, &_inner_error0_);
#line 411 "../src/page-view.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1638 "page-view.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
#line 410 "../src/page-view.vala"
		e = _inner_error0_;
#line 410 "../src/page-view.vala"
		_inner_error0_ = NULL;
#line 415 "../src/page-view.vala"
		_tmp2_ = e;
#line 415 "../src/page-view.vala"
		_tmp3_ = _tmp2_->message;
#line 415 "../src/page-view.vala"
		g_warning ("page-view.vala:415: Failed to queue_update of the texture: %s", _tmp3_);
#line 417 "../src/page-view.vala"
		g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 410 "../src/page-view.vala"
		_g_error_free0 (e);
#line 1662 "page-view.c"
	}
	__finally0:
#line 410 "../src/page-view.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 410 "../src/page-view.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 410 "../src/page-view.vala"
		g_clear_error (&_inner_error0_);
#line 410 "../src/page-view.vala"
		return;
#line 1673 "page-view.c"
	}
#line 420 "../src/page-view.vala"
	w = page_view_get_preview_width (self);
#line 421 "../src/page-view.vala"
	h = page_view_get_preview_height (self);
#line 423 "../src/page-view.vala"
	cairo_set_line_width (context, (gdouble) 1);
#line 424 "../src/page-view.vala"
	_tmp4_ = self->priv->_x_offset;
#line 424 "../src/page-view.vala"
	_tmp5_ = self->priv->_y_offset;
#line 424 "../src/page-view.vala"
	cairo_translate (context, (gdouble) _tmp4_, (gdouble) _tmp5_);
#line 427 "../src/page-view.vala"
	cairo_translate (context, (gdouble) (self->priv->border_width + self->priv->ruler_width), (gdouble) (self->priv->border_width + self->priv->ruler_width));
#line 429 "../src/page-view.vala"
	_tmp6_ = self->priv->page_texture;
#line 429 "../src/page-view.vala"
	_tmp7_ = page_view_texture_get_pixbuf (_tmp6_);
#line 429 "../src/page-view.vala"
	_tmp8_ = _tmp7_;
#line 429 "../src/page-view.vala"
	if (_tmp8_ != NULL) {
#line 1697 "page-view.c"
		gfloat x_scale = 0.0F;
		PageViewTexture* _tmp9_;
		GdkPixbuf* _tmp10_;
		GdkPixbuf* _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gfloat y_scale = 0.0F;
		PageViewTexture* _tmp14_;
		GdkPixbuf* _tmp15_;
		GdkPixbuf* _tmp16_;
		gint _tmp17_;
		gint _tmp18_;
		PageViewTexture* _tmp19_;
		GdkPixbuf* _tmp20_;
		GdkPixbuf* _tmp21_;
#line 431 "../src/page-view.vala"
		_tmp9_ = self->priv->page_texture;
#line 431 "../src/page-view.vala"
		_tmp10_ = page_view_texture_get_pixbuf (_tmp9_);
#line 431 "../src/page-view.vala"
		_tmp11_ = _tmp10_;
#line 431 "../src/page-view.vala"
		_tmp12_ = gdk_pixbuf_get_width (_tmp11_);
#line 431 "../src/page-view.vala"
		_tmp13_ = _tmp12_;
#line 431 "../src/page-view.vala"
		x_scale = ((gfloat) w) / ((gfloat) _tmp13_);
#line 432 "../src/page-view.vala"
		_tmp14_ = self->priv->page_texture;
#line 432 "../src/page-view.vala"
		_tmp15_ = page_view_texture_get_pixbuf (_tmp14_);
#line 432 "../src/page-view.vala"
		_tmp16_ = _tmp15_;
#line 432 "../src/page-view.vala"
		_tmp17_ = gdk_pixbuf_get_height (_tmp16_);
#line 432 "../src/page-view.vala"
		_tmp18_ = _tmp17_;
#line 432 "../src/page-view.vala"
		y_scale = ((gfloat) h) / ((gfloat) _tmp18_);
#line 434 "../src/page-view.vala"
		cairo_save (context);
#line 435 "../src/page-view.vala"
		cairo_scale (context, (gdouble) x_scale, (gdouble) y_scale);
#line 438 "../src/page-view.vala"
		_tmp19_ = self->priv->page_texture;
#line 438 "../src/page-view.vala"
		_tmp20_ = page_view_texture_get_pixbuf (_tmp19_);
#line 438 "../src/page-view.vala"
		_tmp21_ = _tmp20_;
#line 438 "../src/page-view.vala"
		gdk_cairo_set_source_pixbuf (context, _tmp21_, (gdouble) 0, (gdouble) 0);
#line 439 "../src/page-view.vala"
		cairo_paint (context);
#line 440 "../src/page-view.vala"
		cairo_restore (context);
#line 1753 "page-view.c"
	} else {
		GdkRGBA _tmp22_ = {0};
#line 444 "../src/page-view.vala"
		_tmp22_.red = 1.0f;
#line 444 "../src/page-view.vala"
		_tmp22_.green = 1.0f;
#line 444 "../src/page-view.vala"
		_tmp22_.blue = 1.0f;
#line 444 "../src/page-view.vala"
		_tmp22_.alpha = 1.0f;
#line 444 "../src/page-view.vala"
		gdk_cairo_set_source_rgba (context, &_tmp22_);
#line 445 "../src/page-view.vala"
		cairo_rectangle (context, (gdouble) 0, 0.0, (gdouble) w, (gdouble) h);
#line 446 "../src/page-view.vala"
		cairo_fill (context);
#line 1770 "page-view.c"
	}
#line 450 "../src/page-view.vala"
	_tmp23_ = *ruler_color;
#line 450 "../src/page-view.vala"
	gdk_cairo_set_source_rgba (context, &_tmp23_);
#line 451 "../src/page-view.vala"
	cairo_set_line_width (context, (gdouble) self->priv->border_width);
#line 453 "../src/page-view.vala"
	cairo_rectangle (context, (gdouble) 0, 0.0, (gdouble) w, (gdouble) h);
#line 457 "../src/page-view.vala"
	cairo_stroke (context);
#line 460 "../src/page-view.vala"
	cairo_set_line_width (context, (gdouble) 1);
#line 461 "../src/page-view.vala"
	ruler_tick = 0;
#line 462 "../src/page-view.vala"
	line = 0.0;
#line 463 "../src/page-view.vala"
	big_ruler_tick = 5;
#line 465 "../src/page-view.vala"
	while (TRUE) {
#line 1792 "page-view.c"
		Page* _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
		Page* _tmp27_;
		gint _tmp28_;
		gint _tmp29_;
#line 465 "../src/page-view.vala"
		_tmp24_ = self->priv->_page;
#line 465 "../src/page-view.vala"
		_tmp25_ = page_get_width (_tmp24_);
#line 465 "../src/page-view.vala"
		_tmp26_ = _tmp25_;
#line 465 "../src/page-view.vala"
		if (!(ruler_tick <= _tmp26_)) {
#line 465 "../src/page-view.vala"
			break;
#line 1809 "page-view.c"
		}
#line 467 "../src/page-view.vala"
		line = page_view_page_to_screen_x (self, ruler_tick) + 0.5;
#line 468 "../src/page-view.vala"
		if (big_ruler_tick == 5) {
#line 470 "../src/page-view.vala"
			cairo_move_to (context, line, (gdouble) 0);
#line 471 "../src/page-view.vala"
			cairo_line_to (context, line, (gdouble) (-self->priv->ruler_width));
#line 472 "../src/page-view.vala"
			cairo_move_to (context, line, (gdouble) h);
#line 473 "../src/page-view.vala"
			cairo_line_to (context, line, (gdouble) (h + self->priv->ruler_width));
#line 474 "../src/page-view.vala"
			big_ruler_tick = 0;
#line 1825 "page-view.c"
		} else {
#line 478 "../src/page-view.vala"
			cairo_move_to (context, line, (gdouble) -2);
#line 479 "../src/page-view.vala"
			cairo_line_to (context, line, (gdouble) -5);
#line 480 "../src/page-view.vala"
			cairo_move_to (context, line, (gdouble) (h + 2));
#line 481 "../src/page-view.vala"
			cairo_line_to (context, line, (gdouble) (h + 5));
#line 1835 "page-view.c"
		}
#line 483 "../src/page-view.vala"
		_tmp27_ = self->priv->_page;
#line 483 "../src/page-view.vala"
		_tmp28_ = page_get_dpi (_tmp27_);
#line 483 "../src/page-view.vala"
		_tmp29_ = _tmp28_;
#line 483 "../src/page-view.vala"
		ruler_tick = ruler_tick + (_tmp29_ / 5);
#line 484 "../src/page-view.vala"
		big_ruler_tick = big_ruler_tick + 1;
#line 1847 "page-view.c"
	}
#line 486 "../src/page-view.vala"
	cairo_stroke (context);
#line 489 "../src/page-view.vala"
	ruler_tick = 0;
#line 490 "../src/page-view.vala"
	line = 0.0;
#line 491 "../src/page-view.vala"
	big_ruler_tick = 5;
#line 492 "../src/page-view.vala"
	while (TRUE) {
#line 1859 "page-view.c"
		Page* _tmp30_;
		gint _tmp31_;
		gint _tmp32_;
		Page* _tmp33_;
		gint _tmp34_;
		gint _tmp35_;
#line 492 "../src/page-view.vala"
		_tmp30_ = self->priv->_page;
#line 492 "../src/page-view.vala"
		_tmp31_ = page_get_height (_tmp30_);
#line 492 "../src/page-view.vala"
		_tmp32_ = _tmp31_;
#line 492 "../src/page-view.vala"
		if (!(ruler_tick <= _tmp32_)) {
#line 492 "../src/page-view.vala"
			break;
#line 1876 "page-view.c"
		}
#line 494 "../src/page-view.vala"
		line = page_view_page_to_screen_y (self, ruler_tick) + 0.5;
#line 496 "../src/page-view.vala"
		if (big_ruler_tick == 5) {
#line 498 "../src/page-view.vala"
			cairo_move_to (context, (gdouble) 0, line);
#line 499 "../src/page-view.vala"
			cairo_line_to (context, (gdouble) (-self->priv->ruler_width), line);
#line 501 "../src/page-view.vala"
			cairo_move_to (context, (gdouble) w, line);
#line 502 "../src/page-view.vala"
			cairo_line_to (context, (gdouble) (w + self->priv->ruler_width), line);
#line 503 "../src/page-view.vala"
			big_ruler_tick = 0;
#line 1892 "page-view.c"
		} else {
#line 507 "../src/page-view.vala"
			cairo_move_to (context, (gdouble) -2, line);
#line 508 "../src/page-view.vala"
			cairo_line_to (context, (gdouble) -5, line);
#line 510 "../src/page-view.vala"
			cairo_move_to (context, (gdouble) (w + 2), line);
#line 511 "../src/page-view.vala"
			cairo_line_to (context, (gdouble) (w + 5), line);
#line 1902 "page-view.c"
		}
#line 513 "../src/page-view.vala"
		_tmp33_ = self->priv->_page;
#line 513 "../src/page-view.vala"
		_tmp34_ = page_get_dpi (_tmp33_);
#line 513 "../src/page-view.vala"
		_tmp35_ = _tmp34_;
#line 513 "../src/page-view.vala"
		ruler_tick = ruler_tick + (_tmp35_ / 5);
#line 514 "../src/page-view.vala"
		big_ruler_tick = big_ruler_tick + 1;
#line 1914 "page-view.c"
	}
#line 516 "../src/page-view.vala"
	cairo_stroke (context);
#line 519 "../src/page-view.vala"
	_tmp37_ = self->priv->_page;
#line 519 "../src/page-view.vala"
	_tmp38_ = page_get_is_scanning (_tmp37_);
#line 519 "../src/page-view.vala"
	_tmp39_ = _tmp38_;
#line 519 "../src/page-view.vala"
	if (_tmp39_) {
#line 1926 "page-view.c"
		Page* _tmp40_;
		gint _tmp41_;
		gint _tmp42_;
#line 519 "../src/page-view.vala"
		_tmp40_ = self->priv->_page;
#line 519 "../src/page-view.vala"
		_tmp41_ = page_get_scan_line (_tmp40_);
#line 519 "../src/page-view.vala"
		_tmp42_ = _tmp41_;
#line 519 "../src/page-view.vala"
		_tmp36_ = _tmp42_ > 0;
#line 1938 "page-view.c"
	} else {
#line 519 "../src/page-view.vala"
		_tmp36_ = FALSE;
#line 1942 "page-view.c"
	}
#line 519 "../src/page-view.vala"
	if (_tmp36_) {
#line 1946 "page-view.c"
		gint scan_line = 0;
		Page* _tmp43_;
		gint _tmp44_;
		gint _tmp45_;
		gdouble s = 0.0;
		gdouble x1 = 0.0;
		gdouble y1 = 0.0;
		gdouble x2 = 0.0;
		gdouble y2 = 0.0;
		Page* _tmp46_;
		ScanDirection _tmp47_;
		ScanDirection _tmp48_;
#line 521 "../src/page-view.vala"
		_tmp43_ = self->priv->_page;
#line 521 "../src/page-view.vala"
		_tmp44_ = page_get_scan_line (_tmp43_);
#line 521 "../src/page-view.vala"
		_tmp45_ = _tmp44_;
#line 521 "../src/page-view.vala"
		scan_line = _tmp45_;
#line 525 "../src/page-view.vala"
		_tmp46_ = self->priv->_page;
#line 525 "../src/page-view.vala"
		_tmp47_ = page_get_scan_direction (_tmp46_);
#line 525 "../src/page-view.vala"
		_tmp48_ = _tmp47_;
#line 525 "../src/page-view.vala"
		switch (_tmp48_) {
#line 525 "../src/page-view.vala"
			case SCAN_DIRECTION_TOP_TO_BOTTOM:
#line 1977 "page-view.c"
			{
#line 528 "../src/page-view.vala"
				s = (gdouble) page_view_page_to_screen_y (self, scan_line);
#line 529 "../src/page-view.vala"
				x1 = (gdouble) 0;
#line 529 "../src/page-view.vala"
				y1 = s + 0.5;
#line 530 "../src/page-view.vala"
				x2 = (gdouble) w;
#line 530 "../src/page-view.vala"
				y2 = s + 0.5;
#line 531 "../src/page-view.vala"
				break;
#line 1991 "page-view.c"
			}
#line 525 "../src/page-view.vala"
			case SCAN_DIRECTION_BOTTOM_TO_TOP:
#line 1995 "page-view.c"
			{
#line 533 "../src/page-view.vala"
				s = (gdouble) page_view_page_to_screen_y (self, scan_line);
#line 534 "../src/page-view.vala"
				x1 = (gdouble) 0;
#line 534 "../src/page-view.vala"
				y1 = (h - s) + 0.5;
#line 535 "../src/page-view.vala"
				x2 = (gdouble) w;
#line 535 "../src/page-view.vala"
				y2 = (h - s) + 0.5;
#line 536 "../src/page-view.vala"
				break;
#line 2009 "page-view.c"
			}
#line 525 "../src/page-view.vala"
			case SCAN_DIRECTION_LEFT_TO_RIGHT:
#line 2013 "page-view.c"
			{
#line 538 "../src/page-view.vala"
				s = (gdouble) page_view_page_to_screen_x (self, scan_line);
#line 539 "../src/page-view.vala"
				x1 = s + 0.5;
#line 539 "../src/page-view.vala"
				y1 = (gdouble) 0;
#line 540 "../src/page-view.vala"
				x2 = s + 0.5;
#line 540 "../src/page-view.vala"
				y2 = (gdouble) h;
#line 541 "../src/page-view.vala"
				break;
#line 2027 "page-view.c"
			}
#line 525 "../src/page-view.vala"
			case SCAN_DIRECTION_RIGHT_TO_LEFT:
#line 2031 "page-view.c"
			{
#line 543 "../src/page-view.vala"
				s = (gdouble) page_view_page_to_screen_x (self, scan_line);
#line 544 "../src/page-view.vala"
				x1 = (w - s) + 0.5;
#line 544 "../src/page-view.vala"
				y1 = (gdouble) 0;
#line 545 "../src/page-view.vala"
				x2 = (w - s) + 0.5;
#line 545 "../src/page-view.vala"
				y2 = (gdouble) h;
#line 546 "../src/page-view.vala"
				break;
#line 2045 "page-view.c"
			}
			default:
			{
#line 548 "../src/page-view.vala"
				y2 = (gdouble) 0;
#line 548 "../src/page-view.vala"
				x2 = y2;
#line 548 "../src/page-view.vala"
				y1 = x2;
#line 548 "../src/page-view.vala"
				x1 = y1;
#line 549 "../src/page-view.vala"
				break;
#line 2059 "page-view.c"
			}
		}
#line 552 "../src/page-view.vala"
		cairo_move_to (context, x1, y1);
#line 553 "../src/page-view.vala"
		cairo_line_to (context, x2, y2);
#line 554 "../src/page-view.vala"
		cairo_set_source_rgb (context, 1.0, 0.0, 0.0);
#line 555 "../src/page-view.vala"
		cairo_stroke (context);
#line 2070 "page-view.c"
	}
#line 559 "../src/page-view.vala"
	_tmp49_ = self->priv->_page;
#line 559 "../src/page-view.vala"
	_tmp50_ = page_get_has_crop (_tmp49_);
#line 559 "../src/page-view.vala"
	_tmp51_ = _tmp50_;
#line 559 "../src/page-view.vala"
	if (_tmp51_) {
#line 2080 "page-view.c"
		gint x = 0;
		Page* _tmp52_;
		gint _tmp53_;
		gint _tmp54_;
		gint y = 0;
		Page* _tmp55_;
		gint _tmp56_;
		gint _tmp57_;
		gint crop_width = 0;
		Page* _tmp58_;
		gint _tmp59_;
		gint _tmp60_;
		gint crop_height = 0;
		Page* _tmp61_;
		gint _tmp62_;
		gint _tmp63_;
		gint dx = 0;
		gint dy = 0;
		gint dw = 0;
		gint dh = 0;
#line 561 "../src/page-view.vala"
		_tmp52_ = self->priv->_page;
#line 561 "../src/page-view.vala"
		_tmp53_ = page_get_crop_x (_tmp52_);
#line 561 "../src/page-view.vala"
		_tmp54_ = _tmp53_;
#line 561 "../src/page-view.vala"
		x = _tmp54_;
#line 562 "../src/page-view.vala"
		_tmp55_ = self->priv->_page;
#line 562 "../src/page-view.vala"
		_tmp56_ = page_get_crop_y (_tmp55_);
#line 562 "../src/page-view.vala"
		_tmp57_ = _tmp56_;
#line 562 "../src/page-view.vala"
		y = _tmp57_;
#line 563 "../src/page-view.vala"
		_tmp58_ = self->priv->_page;
#line 563 "../src/page-view.vala"
		_tmp59_ = page_get_crop_width (_tmp58_);
#line 563 "../src/page-view.vala"
		_tmp60_ = _tmp59_;
#line 563 "../src/page-view.vala"
		crop_width = _tmp60_;
#line 564 "../src/page-view.vala"
		_tmp61_ = self->priv->_page;
#line 564 "../src/page-view.vala"
		_tmp62_ = page_get_crop_height (_tmp61_);
#line 564 "../src/page-view.vala"
		_tmp63_ = _tmp62_;
#line 564 "../src/page-view.vala"
		crop_height = _tmp63_;
#line 566 "../src/page-view.vala"
		dx = page_view_page_to_screen_x (self, x);
#line 567 "../src/page-view.vala"
		dy = page_view_page_to_screen_y (self, y);
#line 568 "../src/page-view.vala"
		dw = page_view_page_to_screen_x (self, crop_width);
#line 569 "../src/page-view.vala"
		dh = page_view_page_to_screen_y (self, crop_height);
#line 572 "../src/page-view.vala"
		cairo_rectangle (context, (gdouble) 0, (gdouble) 0, (gdouble) w, (gdouble) h);
#line 573 "../src/page-view.vala"
		cairo_new_sub_path (context);
#line 574 "../src/page-view.vala"
		cairo_rectangle (context, (gdouble) dx, (gdouble) dy, (gdouble) dw, (gdouble) dh);
#line 575 "../src/page-view.vala"
		cairo_set_fill_rule (context, CAIRO_FILL_RULE_EVEN_ODD);
#line 576 "../src/page-view.vala"
		cairo_set_source_rgba (context, 0.25, 0.25, 0.25, 0.2);
#line 577 "../src/page-view.vala"
		cairo_fill (context);
#line 580 "../src/page-view.vala"
		cairo_set_source_rgb (context, 1.0, 1.0, 1.0);
#line 581 "../src/page-view.vala"
		cairo_move_to (context, (gdouble) (-self->priv->border_width), dy - 1.5);
#line 582 "../src/page-view.vala"
		cairo_line_to (context, (gdouble) (self->priv->border_width + w), dy - 1.5);
#line 583 "../src/page-view.vala"
		cairo_move_to (context, (gdouble) (-self->priv->border_width), (dy + dh) + 1.5);
#line 584 "../src/page-view.vala"
		cairo_line_to (context, (gdouble) (self->priv->border_width + w), (dy + dh) + 1.5);
#line 585 "../src/page-view.vala"
		cairo_stroke (context);
#line 587 "../src/page-view.vala"
		cairo_move_to (context, dx - 1.5, (gdouble) (-self->priv->border_width));
#line 588 "../src/page-view.vala"
		cairo_line_to (context, dx - 1.5, (gdouble) (self->priv->border_width + h));
#line 589 "../src/page-view.vala"
		cairo_move_to (context, (dx + dw) + 1.5, (gdouble) (-self->priv->border_width));
#line 590 "../src/page-view.vala"
		cairo_line_to (context, (dx + dw) + 1.5, (gdouble) (self->priv->border_width + h));
#line 591 "../src/page-view.vala"
		cairo_stroke (context);
#line 593 "../src/page-view.vala"
		cairo_rectangle (context, dx - 0.5, dy - 0.5, (gdouble) (dw + 1), (gdouble) (dh + 1));
#line 594 "../src/page-view.vala"
		cairo_set_source_rgb (context, 0.0, 0.0, 0.0);
#line 595 "../src/page-view.vala"
		cairo_stroke (context);
#line 2181 "page-view.c"
	}
}

static void
page_view_page_pixels_changed_cb (PageView* self,
                                  Page* p)
{
	PageViewTexture* _tmp0_;
#line 641 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 641 "../src/page-view.vala"
	g_return_if_fail (p != NULL);
#line 644 "../src/page-view.vala"
	self->priv->update_image = TRUE;
#line 645 "../src/page-view.vala"
	_tmp0_ = self->priv->page_texture;
#line 645 "../src/page-view.vala"
	page_view_texture_request_update (_tmp0_);
#line 646 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 2202 "page-view.c"
}

static void
page_view_page_size_changed_cb (PageView* self,
                                Page* p)
{
#line 649 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 649 "../src/page-view.vala"
	g_return_if_fail (p != NULL);
#line 652 "../src/page-view.vala"
	self->priv->update_image = TRUE;
#line 653 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL], 0);
#line 654 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 2219 "page-view.c"
}

static void
page_view_page_overlay_changed_cb (PageView* self,
                                   Page* p)
{
#line 657 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 657 "../src/page-view.vala"
	g_return_if_fail (p != NULL);
#line 659 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 2232 "page-view.c"
}

static void
page_view_scan_direction_changed_cb (PageView* self,
                                     Page* p)
{
	PageViewTexture* _tmp0_;
#line 662 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 662 "../src/page-view.vala"
	g_return_if_fail (p != NULL);
#line 665 "../src/page-view.vala"
	self->priv->update_image = TRUE;
#line 666 "../src/page-view.vala"
	_tmp0_ = self->priv->page_texture;
#line 666 "../src/page-view.vala"
	page_view_texture_request_update (_tmp0_);
#line 667 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL], 0);
#line 668 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 2254 "page-view.c"
}

Page*
page_view_get_page (PageView* self)
{
	Page* result;
	Page* _tmp0_;
#line 29 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 29 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 29 "../src/page-view.vala"
	result = _tmp0_;
#line 29 "../src/page-view.vala"
	return result;
#line 2270 "page-view.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 29 "../src/page-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 2278 "page-view.c"
}

static void
page_view_set_page (PageView* self,
                    Page* value)
{
	Page* old_value;
#line 29 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/page-view.vala"
	old_value = page_view_get_page (self);
#line 29 "../src/page-view.vala"
	if (old_value != value) {
#line 2292 "page-view.c"
		Page* _tmp0_;
#line 29 "../src/page-view.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 29 "../src/page-view.vala"
		_g_object_unref0 (self->priv->_page);
#line 29 "../src/page-view.vala"
		self->priv->_page = _tmp0_;
#line 29 "../src/page-view.vala"
		g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_PAGE_PROPERTY]);
#line 2302 "page-view.c"
	}
}

gboolean
page_view_get_selected (PageView* self)
{
	gboolean result;
#line 38 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 38 "../src/page-view.vala"
	result = self->priv->selected_;
#line 38 "../src/page-view.vala"
	return result;
#line 2316 "page-view.c"
}

void
page_view_set_selected (PageView* self,
                        gboolean value)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp11_;
	gboolean _tmp12_;
#line 39 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/page-view.vala"
	_tmp2_ = page_view_get_selected (self);
#line 41 "../src/page-view.vala"
	_tmp3_ = _tmp2_;
#line 41 "../src/page-view.vala"
	if (_tmp3_) {
#line 2337 "page-view.c"
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 41 "../src/page-view.vala"
		_tmp4_ = page_view_get_selected (self);
#line 41 "../src/page-view.vala"
		_tmp5_ = _tmp4_;
#line 41 "../src/page-view.vala"
		_tmp1_ = _tmp5_;
#line 2346 "page-view.c"
	} else {
#line 41 "../src/page-view.vala"
		_tmp1_ = FALSE;
#line 2350 "page-view.c"
	}
#line 41 "../src/page-view.vala"
	if (_tmp1_) {
#line 41 "../src/page-view.vala"
		_tmp0_ = TRUE;
#line 2356 "page-view.c"
	} else {
		gboolean _tmp6_ = FALSE;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 41 "../src/page-view.vala"
		_tmp7_ = page_view_get_selected (self);
#line 41 "../src/page-view.vala"
		_tmp8_ = _tmp7_;
#line 41 "../src/page-view.vala"
		if (!_tmp8_) {
#line 2367 "page-view.c"
			gboolean _tmp9_;
			gboolean _tmp10_;
#line 41 "../src/page-view.vala"
			_tmp9_ = page_view_get_selected (self);
#line 41 "../src/page-view.vala"
			_tmp10_ = _tmp9_;
#line 41 "../src/page-view.vala"
			_tmp6_ = !_tmp10_;
#line 2376 "page-view.c"
		} else {
#line 41 "../src/page-view.vala"
			_tmp6_ = FALSE;
#line 2380 "page-view.c"
		}
#line 41 "../src/page-view.vala"
		_tmp0_ = _tmp6_;
#line 2384 "page-view.c"
	}
#line 41 "../src/page-view.vala"
	if (_tmp0_) {
#line 42 "../src/page-view.vala"
		return;
#line 2390 "page-view.c"
	}
#line 43 "../src/page-view.vala"
	_tmp11_ = page_view_get_selected (self);
#line 43 "../src/page-view.vala"
	_tmp12_ = _tmp11_;
#line 43 "../src/page-view.vala"
	page_view_set_selected (self, _tmp12_);
#line 44 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 39 "../src/page-view.vala"
	g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_SELECTED_PROPERTY]);
#line 2402 "page-view.c"
}

gint
page_view_get_x_offset (PageView* self)
{
	gint result;
#line 60 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 60 "../src/page-view.vala"
	result = self->priv->_x_offset;
#line 60 "../src/page-view.vala"
	return result;
#line 2415 "page-view.c"
}

void
page_view_set_x_offset (PageView* self,
                        gint value)
{
	gint old_value;
#line 60 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 60 "../src/page-view.vala"
	old_value = page_view_get_x_offset (self);
#line 60 "../src/page-view.vala"
	if (old_value != value) {
#line 60 "../src/page-view.vala"
		self->priv->_x_offset = value;
#line 60 "../src/page-view.vala"
		g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_X_OFFSET_PROPERTY]);
#line 2433 "page-view.c"
	}
}

gint
page_view_get_y_offset (PageView* self)
{
	gint result;
#line 61 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 61 "../src/page-view.vala"
	result = self->priv->_y_offset;
#line 61 "../src/page-view.vala"
	return result;
#line 2447 "page-view.c"
}

void
page_view_set_y_offset (PageView* self,
                        gint value)
{
	gint old_value;
#line 61 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/page-view.vala"
	old_value = page_view_get_y_offset (self);
#line 61 "../src/page-view.vala"
	if (old_value != value) {
#line 61 "../src/page-view.vala"
		self->priv->_y_offset = value;
#line 61 "../src/page-view.vala"
		g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_Y_OFFSET_PROPERTY]);
#line 2465 "page-view.c"
	}
}

const gchar*
page_view_get_cursor (PageView* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 72 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 72 "../src/page-view.vala"
	_tmp0_ = self->priv->_cursor;
#line 72 "../src/page-view.vala"
	result = _tmp0_;
#line 72 "../src/page-view.vala"
	return result;
#line 2482 "page-view.c"
}

static void
page_view_set_cursor (PageView* self,
                      const gchar* value)
{
	gchar* old_value;
#line 72 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 72 "../src/page-view.vala"
	old_value = page_view_get_cursor (self);
#line 72 "../src/page-view.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 2496 "page-view.c"
		gchar* _tmp0_;
#line 72 "../src/page-view.vala"
		_tmp0_ = g_strdup (value);
#line 72 "../src/page-view.vala"
		_g_free0 (self->priv->_cursor);
#line 72 "../src/page-view.vala"
		self->priv->_cursor = _tmp0_;
#line 72 "../src/page-view.vala"
		g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_CURSOR_PROPERTY]);
#line 2506 "page-view.c"
	}
}

gint
page_view_get_width (PageView* self)
{
	gint result;
#line 601 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 601 "../src/page-view.vala"
	result = self->priv->width_;
#line 601 "../src/page-view.vala"
	return result;
#line 2520 "page-view.c"
}

void
page_view_set_width (PageView* self,
                     gint value)
{
	gint h = 0;
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	Page* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gboolean _tmp6_ = FALSE;
#line 602 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 605 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 605 "../src/page-view.vala"
	_tmp1_ = page_get_height (_tmp0_);
#line 605 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 605 "../src/page-view.vala"
	_tmp3_ = self->priv->_page;
#line 605 "../src/page-view.vala"
	_tmp4_ = page_get_width (_tmp3_);
#line 605 "../src/page-view.vala"
	_tmp5_ = _tmp4_;
#line 605 "../src/page-view.vala"
	h = (gint) ((((gdouble) value) * _tmp2_) / _tmp5_);
#line 606 "../src/page-view.vala"
	if (self->priv->width_ == value) {
#line 606 "../src/page-view.vala"
		_tmp6_ = self->priv->height_ == h;
#line 2555 "page-view.c"
	} else {
#line 606 "../src/page-view.vala"
		_tmp6_ = FALSE;
#line 2559 "page-view.c"
	}
#line 606 "../src/page-view.vala"
	if (_tmp6_) {
#line 607 "../src/page-view.vala"
		return;
#line 2565 "page-view.c"
	}
#line 609 "../src/page-view.vala"
	self->priv->width_ = value;
#line 610 "../src/page-view.vala"
	self->priv->height_ = h;
#line 613 "../src/page-view.vala"
	self->priv->update_image = TRUE;
#line 615 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL], 0);
#line 616 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 602 "../src/page-view.vala"
	g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_WIDTH_PROPERTY]);
#line 2579 "page-view.c"
}

gint
page_view_get_height (PageView* self)
{
	gint result;
#line 622 "../src/page-view.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 622 "../src/page-view.vala"
	result = self->priv->height_;
#line 622 "../src/page-view.vala"
	return result;
#line 2592 "page-view.c"
}

void
page_view_set_height (PageView* self,
                      gint value)
{
	gint w = 0;
	Page* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	Page* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gboolean _tmp6_ = FALSE;
#line 623 "../src/page-view.vala"
	g_return_if_fail (self != NULL);
#line 626 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 626 "../src/page-view.vala"
	_tmp1_ = page_get_width (_tmp0_);
#line 626 "../src/page-view.vala"
	_tmp2_ = _tmp1_;
#line 626 "../src/page-view.vala"
	_tmp3_ = self->priv->_page;
#line 626 "../src/page-view.vala"
	_tmp4_ = page_get_height (_tmp3_);
#line 626 "../src/page-view.vala"
	_tmp5_ = _tmp4_;
#line 626 "../src/page-view.vala"
	w = (gint) ((((gdouble) value) * _tmp2_) / _tmp5_);
#line 627 "../src/page-view.vala"
	if (self->priv->width_ == w) {
#line 627 "../src/page-view.vala"
		_tmp6_ = self->priv->height_ == value;
#line 2627 "page-view.c"
	} else {
#line 627 "../src/page-view.vala"
		_tmp6_ = FALSE;
#line 2631 "page-view.c"
	}
#line 627 "../src/page-view.vala"
	if (_tmp6_) {
#line 628 "../src/page-view.vala"
		return;
#line 2637 "page-view.c"
	}
#line 630 "../src/page-view.vala"
	self->priv->width_ = w;
#line 631 "../src/page-view.vala"
	self->priv->height_ = value;
#line 634 "../src/page-view.vala"
	self->priv->update_image = TRUE;
#line 636 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL], 0);
#line 637 "../src/page-view.vala"
	g_signal_emit (self, page_view_signals[PAGE_VIEW_CHANGED_SIGNAL], 0);
#line 623 "../src/page-view.vala"
	g_object_notify_by_pspec ((GObject *) self, page_view_properties[PAGE_VIEW_HEIGHT_PROPERTY]);
#line 2651 "page-view.c"
}

static void
page_view_class_init (PageViewClass * klass,
                      gpointer klass_data)
{
#line 26 "../src/page-view.vala"
	page_view_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/page-view.vala"
	g_type_class_adjust_private_offset (klass, &PageView_private_offset);
#line 26 "../src/page-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_page_view_get_property;
#line 26 "../src/page-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_page_view_set_property;
#line 26 "../src/page-view.vala"
	G_OBJECT_CLASS (klass)->finalize = page_view_finalize;
#line 26 "../src/page-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_PAGE_PROPERTY, page_view_properties[PAGE_VIEW_PAGE_PROPERTY] = g_param_spec_object ("page", "page", "page", TYPE_PAGE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/page-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_SELECTED_PROPERTY, page_view_properties[PAGE_VIEW_SELECTED_PROPERTY] = g_param_spec_boolean ("selected", "selected", "selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/page-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_X_OFFSET_PROPERTY, page_view_properties[PAGE_VIEW_X_OFFSET_PROPERTY] = g_param_spec_int ("x-offset", "x-offset", "x-offset", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/page-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_Y_OFFSET_PROPERTY, page_view_properties[PAGE_VIEW_Y_OFFSET_PROPERTY] = g_param_spec_int ("y-offset", "y-offset", "y-offset", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/page-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_CURSOR_PROPERTY, page_view_properties[PAGE_VIEW_CURSOR_PROPERTY] = g_param_spec_string ("cursor", "cursor", "cursor", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 26 "../src/page-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_WIDTH_PROPERTY, page_view_properties[PAGE_VIEW_WIDTH_PROPERTY] = g_param_spec_int ("width", "width", "width", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/page-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAGE_VIEW_HEIGHT_PROPERTY, page_view_properties[PAGE_VIEW_HEIGHT_PROPERTY] = g_param_spec_int ("height", "height", "height", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/page-view.vala"
	page_view_signals[PAGE_VIEW_SIZE_CHANGED_SIGNAL] = g_signal_new ("size-changed", TYPE_PAGE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 26 "../src/page-view.vala"
	page_view_signals[PAGE_VIEW_CHANGED_SIGNAL] = g_signal_new ("changed", TYPE_PAGE_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2686 "page-view.c"
}

static void
page_view_instance_init (PageView * self,
                         gpointer klass)
{
	gchar* _tmp0_;
#line 26 "../src/page-view.vala"
	self->priv = page_view_get_instance_private (self);
#line 35 "../src/page-view.vala"
	self->priv->selected_ = FALSE;
#line 48 "../src/page-view.vala"
	self->priv->ruler_width = 8;
#line 50 "../src/page-view.vala"
	self->priv->border_width = 2;
#line 53 "../src/page-view.vala"
	self->priv->update_image = TRUE;
#line 72 "../src/page-view.vala"
	_tmp0_ = g_strdup ("arrow");
#line 72 "../src/page-view.vala"
	self->priv->_cursor = _tmp0_;
#line 74 "../src/page-view.vala"
	self->priv->animate_n_segments = 7;
#line 2710 "page-view.c"
}

static void
page_view_finalize (GObject * obj)
{
	PageView * self;
	Page* _tmp0_;
	guint _tmp1_;
	Page* _tmp2_;
	guint _tmp3_;
	Page* _tmp4_;
	guint _tmp5_;
	Page* _tmp6_;
	guint _tmp7_;
	Page* _tmp8_;
	guint _tmp9_;
	PageViewTexture* _tmp10_;
	guint _tmp11_;
#line 26 "../src/page-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PAGE_VIEW, PageView);
#line 96 "../src/page-view.vala"
	_tmp0_ = self->priv->_page;
#line 96 "../src/page-view.vala"
	g_signal_parse_name ("pixels-changed", TYPE_PAGE, &_tmp1_, NULL, FALSE);
#line 96 "../src/page-view.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _page_view_page_pixels_changed_cb_page_pixels_changed, self);
#line 97 "../src/page-view.vala"
	_tmp2_ = self->priv->_page;
#line 97 "../src/page-view.vala"
	g_signal_parse_name ("size-changed", TYPE_PAGE, &_tmp3_, NULL, FALSE);
#line 97 "../src/page-view.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _page_view_page_size_changed_cb_page_size_changed, self);
#line 98 "../src/page-view.vala"
	_tmp4_ = self->priv->_page;
#line 98 "../src/page-view.vala"
	g_signal_parse_name ("crop-changed", TYPE_PAGE, &_tmp5_, NULL, FALSE);
#line 98 "../src/page-view.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _page_view_page_overlay_changed_cb_page_crop_changed, self);
#line 99 "../src/page-view.vala"
	_tmp6_ = self->priv->_page;
#line 99 "../src/page-view.vala"
	g_signal_parse_name ("scan-line-changed", TYPE_PAGE, &_tmp7_, NULL, FALSE);
#line 99 "../src/page-view.vala"
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _page_view_page_overlay_changed_cb_page_scan_line_changed, self);
#line 100 "../src/page-view.vala"
	_tmp8_ = self->priv->_page;
#line 100 "../src/page-view.vala"
	g_signal_parse_name ("scan-direction-changed", TYPE_PAGE, &_tmp9_, NULL, FALSE);
#line 100 "../src/page-view.vala"
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _page_view_scan_direction_changed_cb_page_scan_direction_changed, self);
#line 102 "../src/page-view.vala"
	_tmp10_ = self->priv->page_texture;
#line 102 "../src/page-view.vala"
	g_signal_parse_name ("new-buffer", TYPE_PAGE_VIEW_TEXTURE, &_tmp11_, NULL, FALSE);
#line 102 "../src/page-view.vala"
	g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _page_view_new_buffer_cb_page_view_texture_new_buffer, self);
#line 29 "../src/page-view.vala"
	_g_object_unref0 (self->priv->_page);
#line 32 "../src/page-view.vala"
	_g_object_unref0 (self->priv->page_texture);
#line 72 "../src/page-view.vala"
	_g_free0 (self->priv->_cursor);
#line 26 "../src/page-view.vala"
	G_OBJECT_CLASS (page_view_parent_class)->finalize (obj);
#line 2775 "page-view.c"
}

static GType
page_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PageViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) page_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PageView), 0, (GInstanceInitFunc) page_view_instance_init, NULL };
	GType page_view_type_id;
	page_view_type_id = g_type_register_static (G_TYPE_OBJECT, "PageView", &g_define_type_info, 0);
	PageView_private_offset = g_type_add_instance_private (page_view_type_id, sizeof (PageViewPrivate));
	return page_view_type_id;
}

GType
page_view_get_type (void)
{
	static volatile gsize page_view_type_id__once = 0;
	if (g_once_init_enter (&page_view_type_id__once)) {
		GType page_view_type_id;
		page_view_type_id = page_view_get_type_once ();
		g_once_init_leave (&page_view_type_id__once, page_view_type_id);
	}
	return page_view_type_id__once;
}

static void
_vala_page_view_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	PageView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PAGE_VIEW, PageView);
#line 26 "../src/page-view.vala"
	switch (property_id) {
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_PAGE_PROPERTY:
#line 26 "../src/page-view.vala"
		g_value_set_object (value, page_view_get_page (self));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_SELECTED_PROPERTY:
#line 26 "../src/page-view.vala"
		g_value_set_boolean (value, page_view_get_selected (self));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_X_OFFSET_PROPERTY:
#line 26 "../src/page-view.vala"
		g_value_set_int (value, page_view_get_x_offset (self));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_Y_OFFSET_PROPERTY:
#line 26 "../src/page-view.vala"
		g_value_set_int (value, page_view_get_y_offset (self));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_CURSOR_PROPERTY:
#line 26 "../src/page-view.vala"
		g_value_set_string (value, page_view_get_cursor (self));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_WIDTH_PROPERTY:
#line 26 "../src/page-view.vala"
		g_value_set_int (value, page_view_get_width (self));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_HEIGHT_PROPERTY:
#line 26 "../src/page-view.vala"
		g_value_set_int (value, page_view_get_height (self));
#line 26 "../src/page-view.vala"
		break;
#line 2852 "page-view.c"
		default:
#line 26 "../src/page-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/page-view.vala"
		break;
#line 2858 "page-view.c"
	}
}

static void
_vala_page_view_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	PageView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PAGE_VIEW, PageView);
#line 26 "../src/page-view.vala"
	switch (property_id) {
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_PAGE_PROPERTY:
#line 26 "../src/page-view.vala"
		page_view_set_page (self, g_value_get_object (value));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_SELECTED_PROPERTY:
#line 26 "../src/page-view.vala"
		page_view_set_selected (self, g_value_get_boolean (value));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_X_OFFSET_PROPERTY:
#line 26 "../src/page-view.vala"
		page_view_set_x_offset (self, g_value_get_int (value));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_Y_OFFSET_PROPERTY:
#line 26 "../src/page-view.vala"
		page_view_set_y_offset (self, g_value_get_int (value));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_CURSOR_PROPERTY:
#line 26 "../src/page-view.vala"
		page_view_set_cursor (self, g_value_get_string (value));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_WIDTH_PROPERTY:
#line 26 "../src/page-view.vala"
		page_view_set_width (self, g_value_get_int (value));
#line 26 "../src/page-view.vala"
		break;
#line 26 "../src/page-view.vala"
		case PAGE_VIEW_HEIGHT_PROPERTY:
#line 26 "../src/page-view.vala"
		page_view_set_height (self, g_value_get_int (value));
#line 26 "../src/page-view.vala"
		break;
#line 2914 "page-view.c"
		default:
#line 26 "../src/page-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/page-view.vala"
		break;
#line 2920 "page-view.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

